<?php

namespace QCC\CampusM\CloudService;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'returnStatus' => '\\QCC\\CampusM\\CloudService\\StructType\\ReturnStatus',
            'assetIdentifier' => '\\QCC\\CampusM\\CloudService\\StructType\\AssetIdentifier',
            'assetValue' => '\\QCC\\CampusM\\CloudService\\StructType\\AssetValue',
            'assetIdentifiers' => '\\QCC\\CampusM\\CloudService\\StructType\\AssetIdentifiers',
            'assetValues' => '\\QCC\\CampusM\\CloudService\\StructType\\AssetValues',
            'mitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Mitem',
            'menu' => '\\QCC\\CampusM\\CloudService\\StructType\\Menu',
            'feed' => '\\QCC\\CampusM\\CloudService\\StructType\\Feed',
            'rssCategory' => '\\QCC\\CampusM\\CloudService\\StructType\\RssCategory',
            'rssCategories' => '\\QCC\\CampusM\\CloudService\\StructType\\RssCategories',
            'feeds' => '\\QCC\\CampusM\\CloudService\\StructType\\Feeds',
            'map' => '\\QCC\\CampusM\\CloudService\\StructType\\Map',
            'maps' => '\\QCC\\CampusM\\CloudService\\StructType\\Maps',
            'uitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Uitem',
            'sitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Sitem',
            'services' => '\\QCC\\CampusM\\CloudService\\StructType\\Services',
            'sitems' => '\\QCC\\CampusM\\CloudService\\StructType\\Sitems',
            'positionsFeedFormat' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionsFeedFormat',
            'positionsFeedNotesFormat' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionsFeedNotesFormat',
            'positionsFeedNoteFormat' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionsFeedNoteFormat',
            'citem' => '\\QCC\\CampusM\\CloudService\\StructType\\Citem',
            'titem' => '\\QCC\\CampusM\\CloudService\\StructType\\Titem',
            'colours' => '\\QCC\\CampusM\\CloudService\\StructType\\Colours',
            'advert' => '\\QCC\\CampusM\\CloudService\\StructType\\Advert',
            'adverts' => '\\QCC\\CampusM\\CloudService\\StructType\\Adverts',
            'homePageNewsItem' => '\\QCC\\CampusM\\CloudService\\StructType\\HomePageNewsItem',
            'homePageNews' => '\\QCC\\CampusM\\CloudService\\StructType\\HomePageNews',
            'selectBookmarkRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SelectBookmarkRequest',
            'selectBookmarkResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SelectBookmarkResponse',
            'bookmarks' => '\\QCC\\CampusM\\CloudService\\StructType\\Bookmarks',
            'bookmark' => '\\QCC\\CampusM\\CloudService\\StructType\\Bookmark',
            'authRssItems' => '\\QCC\\CampusM\\CloudService\\StructType\\AuthRssItems',
            'authRssItem' => '\\QCC\\CampusM\\CloudService\\StructType\\AuthRssItem',
            'getResourcesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GetResourcesRequest',
            'getResourcesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetResourcesResponse',
            'resources' => '\\QCC\\CampusM\\CloudService\\StructType\\Resources',
            'resource' => '\\QCC\\CampusM\\CloudService\\StructType\\Resource',
            'personDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonDetails',
            'blackberryPushConfig' => '\\QCC\\CampusM\\CloudService\\StructType\\BlackberryPushConfig',
            'webUIToolBar' => '\\QCC\\CampusM\\CloudService\\StructType\\WebUIToolBar',
            'toolBar' => '\\QCC\\CampusM\\CloudService\\StructType\\ToolBar',
            'toolBarMenuItems' => '\\QCC\\CampusM\\CloudService\\StructType\\ToolBarMenuItems',
            'toolBarMenuItem' => '\\QCC\\CampusM\\CloudService\\StructType\\ToolBarMenuItem',
            'v3Images' => '\\QCC\\CampusM\\CloudService\\StructType\\V3Images',
            'web2Data' => '\\QCC\\CampusM\\CloudService\\StructType\\Web2Data',
            'profileWeb2Data' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileWeb2Data',
            'homepageColors' => '\\QCC\\CampusM\\CloudService\\StructType\\HomepageColors',
            'webUIComponents' => '\\QCC\\CampusM\\CloudService\\StructType\\WebUIComponents',
            'webUIComponent' => '\\QCC\\CampusM\\CloudService\\StructType\\WebUIComponent',
            'valueItem' => '\\QCC\\CampusM\\CloudService\\StructType\\ValueItem',
            'validValues' => '\\QCC\\CampusM\\CloudService\\StructType\\ValidValues',
            'suggestions' => '\\QCC\\CampusM\\CloudService\\StructType\\Suggestions',
            'suggestionsMenuCode' => '\\QCC\\CampusM\\CloudService\\StructType\\SuggestionsMenuCode',
            'searchSuggestions' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchSuggestions',
            'settingModules' => '\\QCC\\CampusM\\CloudService\\StructType\\SettingModules',
            'module' => '\\QCC\\CampusM\\CloudService\\StructType\\Module',
            'moduleSettings' => '\\QCC\\CampusM\\CloudService\\StructType\\ModuleSettings',
            'moduleSetting' => '\\QCC\\CampusM\\CloudService\\StructType\\ModuleSetting',
            'personalisationSettings' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonalisationSettings',
            'personDets' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonDets',
            'startupMEPRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupMEPRequest',
            'startupMEPResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupMEPResponse',
            'startupRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupRequest',
            'startupResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupResponse',
            'appDirectoryLoginRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\AppDirectoryLoginRequest',
            'appDirectoryLoginResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\AppDirectoryLoginResponse',
            'roleNames' => '\\QCC\\CampusM\\CloudService\\StructType\\RoleNames',
            'attributes' => '\\QCC\\CampusM\\CloudService\\StructType\\Attributes',
            'attribute' => '\\QCC\\CampusM\\CloudService\\StructType\\Attribute',
            'appRoleNameList' => '\\QCC\\CampusM\\CloudService\\StructType\\AppRoleNameList',
            'EmailAddress' => '\\QCC\\CampusM\\CloudService\\StructType\\EmailAddress',
            'emailAddresses' => '\\QCC\\CampusM\\CloudService\\StructType\\EmailAddresses',
            'roleIds' => '\\QCC\\CampusM\\CloudService\\StructType\\RoleIds',
            'profileRoleList' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileRoleList',
            'profileRoleLists' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileRoleLists',
            'setupUserResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SetupUserResponse',
            'setupUserRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetupUserRequest',
            'setAppServerPasswordRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetAppServerPasswordRequest',
            'setPersonPasswordRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetPersonPasswordRequest',
            'facebookPostAuthorizeRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\FacebookPostAuthorizeRequest',
            'facebookPostRemoveRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\FacebookPostRemoveRequest',
            'validateUserRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ValidateUserRequest',
            'notificationTarget' => '\\QCC\\CampusM\\CloudService\\StructType\\NotificationTarget',
            'notificationTargets' => '\\QCC\\CampusM\\CloudService\\StructType\\NotificationTargets',
            'notification' => '\\QCC\\CampusM\\CloudService\\StructType\\Notification',
            'notifications' => '\\QCC\\CampusM\\CloudService\\StructType\\Notifications',
            'alert' => '\\QCC\\CampusM\\CloudService\\StructType\\Alert',
            'alerts' => '\\QCC\\CampusM\\CloudService\\StructType\\Alerts',
            'viewAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ViewAlertsRequest',
            'viewAlertsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ViewAlertsResponse',
            'deleteAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DeleteAlertsRequest',
            'readAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ReadAlertsRequest',
            'updateMenuRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateMenuRequest',
            'myLocationOptionsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\MyLocationOptionsRequest',
            'updateMyLocationRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateMyLocationRequest',
            'fitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Fitem',
            'friends' => '\\QCC\\CampusM\\CloudService\\StructType\\Friends',
            'friendGroup' => '\\QCC\\CampusM\\CloudService\\StructType\\FriendGroup',
            'friendGroups' => '\\QCC\\CampusM\\CloudService\\StructType\\FriendGroups',
            'findFriendsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\FindFriendsRequest',
            'findFriendsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\FindFriendsResponse',
            'newsEventsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\NewsEventsRequest',
            'newsEventsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\NewsEventsResponse',
            'updateRssSubsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateRssSubsRequest',
            'listAvailableFeedsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableFeedsRequest',
            'listAvailableFeedsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableFeedsResponse',
            'languageMapping' => '\\QCC\\CampusM\\CloudService\\StructType\\LanguageMapping',
            'languageMappings' => '\\QCC\\CampusM\\CloudService\\StructType\\LanguageMappings',
            'languagePack' => '\\QCC\\CampusM\\CloudService\\StructType\\LanguagePack',
            'languagePacks' => '\\QCC\\CampusM\\CloudService\\StructType\\LanguagePacks',
            'pgitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Pgitem',
            'javascriptUrls' => '\\QCC\\CampusM\\CloudService\\StructType\\JavascriptUrls',
            'cssItem' => '\\QCC\\CampusM\\CloudService\\StructType\\CssItem',
            'javascriptItem' => '\\QCC\\CampusM\\CloudService\\StructType\\JavascriptItem',
            'deviceItem' => '\\QCC\\CampusM\\CloudService\\StructType\\DeviceItem',
            'cssItems' => '\\QCC\\CampusM\\CloudService\\StructType\\CssItems',
            'javascriptItems' => '\\QCC\\CampusM\\CloudService\\StructType\\JavascriptItems',
            'deviceItems' => '\\QCC\\CampusM\\CloudService\\StructType\\DeviceItems',
            'guideItems' => '\\QCC\\CampusM\\CloudService\\StructType\\GuideItems',
            'cachedPGItem' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedPGItem',
            'cachedPGItems' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedPGItems',
            'guideItems1' => '\\QCC\\CampusM\\CloudService\\StructType\\GuideItems1',
            'cachedGuideItems' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedGuideItems',
            'authAccess' => '\\QCC\\CampusM\\CloudService\\StructType\\AuthAccess',
            'profile' => '\\QCC\\CampusM\\CloudService\\StructType\\Profile',
            'startupFlows' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupFlows',
            'startupFlow' => '\\QCC\\CampusM\\CloudService\\StructType\\StartupFlow',
            'flowStrings' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowStrings',
            'flowString' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowString',
            'flowServices' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowServices',
            'flowService' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowService',
            'profiles' => '\\QCC\\CampusM\\CloudService\\StructType\\Profiles',
            'profileGroup' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileGroup',
            'profileGroups' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileGroups',
            'listAvailableProfilesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableProfilesRequest',
            'listAvailableProfilesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableProfilesResponse',
            'profileTutorial' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileTutorial',
            'profileTutorials' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileTutorials',
            'headerColors' => '\\QCC\\CampusM\\CloudService\\StructType\\HeaderColors',
            'listAvailableOrganisationsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableOrganisationsRequest',
            'listAvailableOrganisationsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ListAvailableOrganisationsResponse',
            'organisation' => '\\QCC\\CampusM\\CloudService\\StructType\\Organisation',
            'pitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Pitem',
            'beaconIds' => '\\QCC\\CampusM\\CloudService\\StructType\\BeaconIds',
            'positions' => '\\QCC\\CampusM\\CloudService\\StructType\\Positions',
            'paitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Paitem',
            'positionActions' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionActions',
            'litem' => '\\QCC\\CampusM\\CloudService\\StructType\\Litem',
            'locations' => '\\QCC\\CampusM\\CloudService\\StructType\\Locations',
            'locationCategoriesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationCategoriesRequest',
            'locationCategoriesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationCategoriesResponse',
            'locationListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationListRequest',
            'locationListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationListResponse',
            'findPositionsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\FindPositionsRequest',
            'findPositionsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\FindPositionsResponse',
            'alertSubscriptionGroups' => '\\QCC\\CampusM\\CloudService\\StructType\\AlertSubscriptionGroups',
            'alertSubscriptionGroup' => '\\QCC\\CampusM\\CloudService\\StructType\\AlertSubscriptionGroup',
            'alertSubscriptions' => '\\QCC\\CampusM\\CloudService\\StructType\\AlertSubscriptions',
            'alertSubscription' => '\\QCC\\CampusM\\CloudService\\StructType\\AlertSubscription',
            'updateAlertSubscriptionsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateAlertSubscriptionsRequest',
            'updateDistanceSettingRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateDistanceSettingRequest',
            'updateFavouritesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateFavouritesRequest',
            'sendAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SendAlertsRequest',
            'sendNotificationsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SendNotificationsRequest',
            'retrieveAlertSubscriptionsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveAlertSubscriptionsRequest',
            'retrieveAlertSubscriptionsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveAlertSubscriptionsResponse',
            'retrieveFavouritesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveFavouritesRequest',
            'retrieveFavouritesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveFavouritesResponse',
            'addFriendRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\AddFriendRequest',
            'updateFriendsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateFriendsRequest',
            'ufriends' => '\\QCC\\CampusM\\CloudService\\StructType\\Ufriends',
            'ufitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Ufitem',
            'psnitem' => '\\QCC\\CampusM\\CloudService\\StructType\\Psnitem',
            'plist' => '\\QCC\\CampusM\\CloudService\\StructType\\Plist',
            'searchPersonRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchPersonRequest',
            'searchPersonResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchPersonResponse',
            'splashPage' => '\\QCC\\CampusM\\CloudService\\StructType\\SplashPage',
            'splashPageResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SplashPageResponse',
            'updatePerson' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdatePerson',
            'retrievePosition' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrievePosition',
            'retrievePositionResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrievePositionResponse',
            'pocketGuide' => '\\QCC\\CampusM\\CloudService\\StructType\\PocketGuide',
            'pocketGuideResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\PocketGuideResponse',
            'forgottenPasswordRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ForgottenPasswordRequest',
            'personVotes' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonVotes',
            'options' => '\\QCC\\CampusM\\CloudService\\StructType\\Options',
            'option' => '\\QCC\\CampusM\\CloudService\\StructType\\Option',
            'question' => '\\QCC\\CampusM\\CloudService\\StructType\\Question',
            'questions' => '\\QCC\\CampusM\\CloudService\\StructType\\Questions',
            'listQuestions' => '\\QCC\\CampusM\\CloudService\\StructType\\ListQuestions',
            'listQuestionsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ListQuestionsResponse',
            'category' => '\\QCC\\CampusM\\CloudService\\StructType\\Category',
            'categories' => '\\QCC\\CampusM\\CloudService\\StructType\\Categories',
            'listVoteCategories' => '\\QCC\\CampusM\\CloudService\\StructType\\ListVoteCategories',
            'listVoteCategoriesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ListVoteCategoriesResponse',
            'person' => '\\QCC\\CampusM\\CloudService\\StructType\\Person',
            'personTextResponses' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonTextResponses',
            'personTextResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\PersonTextResponse',
            'voteResults' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteResults',
            'voteResultsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteResultsResponse',
            'submitOptions' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitOptions',
            'submitOption' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitOption',
            'submitQuestion' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitQuestion',
            'userFeedbackSupertype' => '\\QCC\\CampusM\\CloudService\\StructType\\UserFeedbackSupertype',
            'submitUserFeedback' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitUserFeedback',
            'submitUserIdea' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitUserIdea',
            'submitUserProblem' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitUserProblem',
            'submitIdea' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitIdea',
            'submitProblem' => '\\QCC\\CampusM\\CloudService\\StructType\\SubmitProblem',
            'appropriate' => '\\QCC\\CampusM\\CloudService\\StructType\\Appropriate',
            'deleteUserRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DeleteUserRequest',
            'deleteUserResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DeleteUserResponse',
            'enterProfileRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\EnterProfileRequest',
            'orgUsersRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\OrgUsersRequest',
            'orgUsersResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\OrgUsersResponse',
            'users' => '\\QCC\\CampusM\\CloudService\\StructType\\Users',
            'appUser' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUser',
            'appUsersRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUsersRequest',
            'appUsersResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUsersResponse',
            'appUsers' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUsers',
            'campusmUser' => '\\QCC\\CampusM\\CloudService\\StructType\\CampusmUser',
            'appUserProfile' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUserProfile',
            'appUserProfiles' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUserProfiles',
            'appUserAlertSubscription' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUserAlertSubscription',
            'appUserAlertSubscriptions' => '\\QCC\\CampusM\\CloudService\\StructType\\AppUserAlertSubscriptions',
            'userLoginRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginRequest',
            'userLoginResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginResponse',
            'userLoginLDAPRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginLDAPRequest',
            'userLoginLDAPResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginLDAPResponse',
            'profileIds' => '\\QCC\\CampusM\\CloudService\\StructType\\ProfileIds',
            'userLoginOAuthRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginOAuthRequest',
            'userLoginOAuthResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UserLoginOAuthResponse',
            'customerRolesList' => '\\QCC\\CampusM\\CloudService\\StructType\\CustomerRolesList',
            'oAuthTokenRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\OAuthTokenRequest',
            'oAuthTokenResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\OAuthTokenResponse',
            'oAuthRefreshRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\OAuthRefreshRequest',
            'oAuthRefreshResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\OAuthRefreshResponse',
            'oAuthReturnStatus' => '\\QCC\\CampusM\\CloudService\\StructType\\OAuthReturnStatus',
            'pocketGuideContentRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\PocketGuideContentRequest',
            'pocketGuideContentResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\PocketGuideContentResponse',
            'cleanupExpiredAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CleanupExpiredAlertsRequest',
            'cleanupExpiredAlertsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CleanupExpiredAlertsResponse',
            'cachedPocketGuide' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedPocketGuide',
            'cachedPocketGuideResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedPocketGuideResponse',
            'mapItem' => '\\QCC\\CampusM\\CloudService\\StructType\\MapItem',
            'cachedMapPositionRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedMapPositionRequest',
            'cachedMapPositionResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedMapPositionResponse',
            'cachedMapItems' => '\\QCC\\CampusM\\CloudService\\StructType\\CachedMapItems',
            'retrieveRssHeaderItemsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveRssHeaderItemsRequest',
            'retrieveRssHeaderItemsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\RetrieveRssHeaderItemsResponse',
            'base64Request' => '\\QCC\\CampusM\\CloudService\\StructType\\Base64Request',
            'base64URLs' => '\\QCC\\CampusM\\CloudService\\StructType\\Base64URLs',
            'base64Response' => '\\QCC\\CampusM\\CloudService\\StructType\\Base64Response',
            'base64Images' => '\\QCC\\CampusM\\CloudService\\StructType\\Base64Images',
            'base64Image' => '\\QCC\\CampusM\\CloudService\\StructType\\Base64Image',
            'bookmarkUserRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\BookmarkUserRequest',
            'bookmarkUserResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\BookmarkUserResponse',
            'deleteBookmarkRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DeleteBookmarkRequest',
            'deleteBookmarkResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DeleteBookmarkResponse',
            'voteResultUrlRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteResultUrlRequest',
            'voteResultUrlResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteResultUrlResponse',
            'delegateDirRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DelegateDirRequest',
            'delegateDirResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DelegateDirResponse',
            'institutions' => '\\QCC\\CampusM\\CloudService\\StructType\\Institutions',
            'institution' => '\\QCC\\CampusM\\CloudService\\StructType\\Institution',
            'delegates' => '\\QCC\\CampusM\\CloudService\\StructType\\Delegates',
            'delegate' => '\\QCC\\CampusM\\CloudService\\StructType\\Delegate',
            'directoryListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DirectoryListRequest',
            'directoryListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DirectoryListResponse',
            'regProcessRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\RegProcessRequest',
            'regProcessResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\RegProcessResponse',
            'login' => '\\QCC\\CampusM\\CloudService\\StructType\\Login',
            'loginResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\LoginResponse',
            'searchposition' => '\\QCC\\CampusM\\CloudService\\StructType\\Searchposition',
            'searchpositions' => '\\QCC\\CampusM\\CloudService\\StructType\\Searchpositions',
            'searchPositionRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchPositionRequest',
            'searchPositionResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchPositionResponse',
            'hostConfigRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\HostConfigRequest',
            'hostConfigResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\HostConfigResponse',
            'hostConfigDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\HostConfigDetails',
            'getRefLookupsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GetRefLookupsRequest',
            'getRefLookupsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetRefLookupsResponse',
            'lookups' => '\\QCC\\CampusM\\CloudService\\StructType\\Lookups',
            'lookup' => '\\QCC\\CampusM\\CloudService\\StructType\\Lookup',
            'items' => '\\QCC\\CampusM\\CloudService\\StructType\\Items',
            'item' => '\\QCC\\CampusM\\CloudService\\StructType\\Item',
            'createStudentRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CreateStudentRequest',
            'students' => '\\QCC\\CampusM\\CloudService\\StructType\\Students',
            'student' => '\\QCC\\CampusM\\CloudService\\StructType\\Student',
            'insertXmlRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\InsertXmlRequest',
            'insertXmlResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\InsertXmlResponse',
            'aekPageRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\AekPageRequest',
            'aekPageResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\AekPageResponse',
            'aekPageDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\AekPageDetails',
            'aekPage' => '\\QCC\\CampusM\\CloudService\\StructType\\AekPage',
            'AbstractAdminServiceRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\AbstractAdminServiceRequest',
            'certificateStatusRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CertificateStatusRequest',
            'certificateStatusResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CertificateStatusResponse',
            'certificateStatus' => '\\QCC\\CampusM\\CloudService\\StructType\\CertificateStatus',
            'reconfigurePushCentreRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ReconfigurePushCentreRequest',
            'pushCentreStatusRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\PushCentreStatusRequest',
            'pushCentreStatusResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\PushCentreStatusResponse',
            'pushCentreStatus' => '\\QCC\\CampusM\\CloudService\\StructType\\PushCentreStatus',
            'emails' => '\\QCC\\CampusM\\CloudService\\StructType\\Emails',
            'setRolesUpdatedRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetRolesUpdatedRequest',
            'authGroups' => '\\QCC\\CampusM\\CloudService\\StructType\\AuthGroups',
            'sendIntegratedAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SendIntegratedAlertsRequest',
            'testAsyncRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\TestAsyncRequest',
            'insertDirectoryListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\InsertDirectoryListRequest',
            'insertDirectoryListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\InsertDirectoryListResponse',
            'updateDirectoryListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateDirectoryListRequest',
            'updateDirectoryListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateDirectoryListResponse',
            'searchDirectoryListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchDirectoryListRequest',
            'searchDirectoryListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchDirectoryListResponse',
            'searchDirListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchDirListRequest',
            'searchDirListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchDirListResponse',
            'countries' => '\\QCC\\CampusM\\CloudService\\StructType\\Countries',
            'country' => '\\QCC\\CampusM\\CloudService\\StructType\\Country',
            'delegateDetailsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DelegateDetailsRequest',
            'delegateDetailsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DelegateDetailsResponse',
            'details' => '\\QCC\\CampusM\\CloudService\\StructType\\Details',
            'detail' => '\\QCC\\CampusM\\CloudService\\StructType\\Detail',
            'dirListRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DirListRequest',
            'dirListResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\DirListResponse',
            'getCurrentProfileRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GetCurrentProfileRequest',
            'getCurrentProfileResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetCurrentProfileResponse',
            'updatePositionNotes' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdatePositionNotes',
            'updatePositions' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdatePositions',
            'positionActionRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionActionRequest',
            'positionActionResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\PositionActionResponse',
            'checkInLocationsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckInLocationsRequest',
            'checkInLocationsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckInLocationsResponse',
            'checkInLocation' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckInLocation',
            'checkInLocations' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckInLocations',
            'locationFriends' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationFriends',
            'locationFriend' => '\\QCC\\CampusM\\CloudService\\StructType\\LocationFriend',
            'myDetailRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\MyDetailRequest',
            'myDetailResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\MyDetailResponse',
            'sendAlertEmailsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SendAlertEmailsRequest',
            'sendAlertEmailsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SendAlertEmailsResponse',
            'voteCsvRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteCsvRequest',
            'voteCsvTextRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\VoteCsvTextRequest',
            'ucisaThingyRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UcisaThingyRequest',
            'ucisaThingyResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UcisaThingyResponse',
            'removePersonRolesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\RemovePersonRolesRequest',
            'appRoleIds' => '\\QCC\\CampusM\\CloudService\\StructType\\AppRoleIds',
            'regions' => '\\QCC\\CampusM\\CloudService\\StructType\\Regions',
            'typesOfWork' => '\\QCC\\CampusM\\CloudService\\StructType\\TypesOfWork',
            'workhours' => '\\QCC\\CampusM\\CloudService\\StructType\\Workhours',
            'saveJobPreferences' => '\\QCC\\CampusM\\CloudService\\StructType\\SaveJobPreferences',
            'getJobPreferences' => '\\QCC\\CampusM\\CloudService\\StructType\\GetJobPreferences',
            'getJobPreferencesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetJobPreferencesResponse',
            'saveJobVacancies' => '\\QCC\\CampusM\\CloudService\\StructType\\SaveJobVacancies',
            'sendJobAlerts' => '\\QCC\\CampusM\\CloudService\\StructType\\SendJobAlerts',
            'vacancy' => '\\QCC\\CampusM\\CloudService\\StructType\\Vacancy',
            'vacancyList' => '\\QCC\\CampusM\\CloudService\\StructType\\VacancyList',
            'searchJobVacancies' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchJobVacancies',
            'searchJobVacanciesResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SearchJobVacanciesResponse',
            'setupCouncilAlertsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetupCouncilAlertsRequest',
            'flowDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowDetails',
            'flowDetail' => '\\QCC\\CampusM\\CloudService\\StructType\\FlowDetail',
            'capturedFlowDatasets' => '\\QCC\\CampusM\\CloudService\\StructType\\CapturedFlowDatasets',
            'capturedFlowDataset' => '\\QCC\\CampusM\\CloudService\\StructType\\CapturedFlowDataset',
            'reportItOptionsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItOptionsRequest',
            'reportItOptionsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItOptionsResponse',
            'reportItCategories' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItCategories',
            'reportItCategory' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItCategory',
            'reportItEntries' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntries',
            'reportItEntry' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntry',
            'reportItEntryOptions' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntryOptions',
            'reportItEntryOption' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntryOption',
            'reportItEntryPersonalDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntryPersonalDetails',
            'reportItEntryPersonalDetail' => '\\QCC\\CampusM\\CloudService\\StructType\\ReportItEntryPersonalDetail',
            'sendSchoolAlerts' => '\\QCC\\CampusM\\CloudService\\StructType\\SendSchoolAlerts',
            'educauseSyncItineraryRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseSyncItineraryRequest',
            'educauseSyncItineraryResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseSyncItineraryResponse',
            'educauseEmails' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseEmails',
            'educauseExhibitors' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseExhibitors',
            'educauseSessions' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseSessions',
            'educauseSessionDetails' => '\\QCC\\CampusM\\CloudService\\StructType\\EducauseSessionDetails',
            'checkActivatedEmailsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckActivatedEmailsRequest',
            'checkActivatedEmailsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\CheckActivatedEmailsResponse',
            'activatedEmails' => '\\QCC\\CampusM\\CloudService\\StructType\\ActivatedEmails',
            'updateFeedsDataRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateFeedsDataRequest',
            'getFeedItemsRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GetFeedItemsRequest',
            'getFeedItemsResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetFeedItemsResponse',
            'feedItems' => '\\QCC\\CampusM\\CloudService\\StructType\\FeedItems',
            'feedItem' => '\\QCC\\CampusM\\CloudService\\StructType\\FeedItem',
            'indexQueries' => '\\QCC\\CampusM\\CloudService\\StructType\\IndexQueries',
            'indexQuery' => '\\QCC\\CampusM\\CloudService\\StructType\\IndexQuery',
            'itemReferences' => '\\QCC\\CampusM\\CloudService\\StructType\\ItemReferences',
            'readExpressions' => '\\QCC\\CampusM\\CloudService\\StructType\\ReadExpressions',
            'readExpression' => '\\QCC\\CampusM\\CloudService\\StructType\\ReadExpression',
            'expressionResult' => '\\QCC\\CampusM\\CloudService\\StructType\\ExpressionResult',
            'resendActivationEmailRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ResendActivationEmailRequest',
            'userDetailRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UserDetailRequest',
            'userDetailResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\UserDetailResponse',
            'updateUserDetailRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\UpdateUserDetailRequest',
            'expireFeedsSurveysRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\ExpireFeedsSurveysRequest',
            'sendRssAlerts' => '\\QCC\\CampusM\\CloudService\\StructType\\SendRssAlerts',
            'generateHashRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GenerateHashRequest',
            'generateHashResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GenerateHashResponse',
            'deactivateOldDevicesRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\DeactivateOldDevicesRequest',
            'insightCaptureServiceRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\InsightCaptureServiceRequest',
            'ps' => '\\QCC\\CampusM\\CloudService\\StructType\\Ps',
            'p' => '\\QCC\\CampusM\\CloudService\\StructType\\P',
            'us' => '\\QCC\\CampusM\\CloudService\\StructType\\Us',
            'ud' => '\\QCC\\CampusM\\CloudService\\StructType\\Ud',
            'setPersonalisationConfigRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\SetPersonalisationConfigRequest',
            'setPersonalisationConfigResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\SetPersonalisationConfigResponse',
            'getPersonalisationConfigRequest' => '\\QCC\\CampusM\\CloudService\\StructType\\GetPersonalisationConfigRequest',
            'getPersonalisationConfigResponse' => '\\QCC\\CampusM\\CloudService\\StructType\\GetPersonalisationConfigResponse',
        );
    }
}
