<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for aekPageRequest StructType
 * @subpackage Structs
 */
class AekPageRequest extends AbstractStructBase
{
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The orgMobilepassword
     * @var string
     */
    public $orgMobilepassword;
    /**
     * The screenReference
     * @var string
     */
    public $screenReference;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * Constructor method for aekPageRequest
     * @uses AekPageRequest::setOrgCode()
     * @uses AekPageRequest::setOrgMobilepassword()
     * @uses AekPageRequest::setScreenReference()
     * @uses AekPageRequest::setPassword()
     * @param int $orgCode
     * @param string $orgMobilepassword
     * @param string $screenReference
     * @param string $password
     */
    public function __construct($orgCode = null, $orgMobilepassword = null, $screenReference = null, $password = null)
    {
        $this
            ->setOrgCode($orgCode)
            ->setOrgMobilepassword($orgMobilepassword)
            ->setScreenReference($screenReference)
            ->setPassword($password);
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\AekPageRequest
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get orgMobilepassword value
     * @return string|null
     */
    public function getOrgMobilepassword()
    {
        return $this->orgMobilepassword;
    }
    /**
     * Set orgMobilepassword value
     * @param string $orgMobilepassword
     * @return \QCC\CampusM\CloudService\StructType\AekPageRequest
     */
    public function setOrgMobilepassword($orgMobilepassword = null)
    {
        // validation for constraint: string
        if (!is_null($orgMobilepassword) && !is_string($orgMobilepassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orgMobilepassword)), __LINE__);
        }
        $this->orgMobilepassword = $orgMobilepassword;
        return $this;
    }
    /**
     * Get screenReference value
     * @return string|null
     */
    public function getScreenReference()
    {
        return $this->screenReference;
    }
    /**
     * Set screenReference value
     * @param string $screenReference
     * @return \QCC\CampusM\CloudService\StructType\AekPageRequest
     */
    public function setScreenReference($screenReference = null)
    {
        // validation for constraint: string
        if (!is_null($screenReference) && !is_string($screenReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($screenReference)), __LINE__);
        }
        $this->screenReference = $screenReference;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\AekPageRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AekPageRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
