<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for alert StructType
 * @subpackage Structs
 */
class Alert extends AbstractStructBase
{
    /**
     * The code
     * @var int
     */
    public $code;
    /**
     * The dt
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dt;
    /**
     * The note
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $note;
    /**
     * The message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The read
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $read;
    /**
     * Constructor method for alert
     * @uses Alert::setCode()
     * @uses Alert::setDt()
     * @uses Alert::setNote()
     * @uses Alert::setMessage()
     * @uses Alert::setRead()
     * @param int $code
     * @param string $dt
     * @param string $note
     * @param string $message
     * @param string $read
     */
    public function __construct($code = null, $dt = null, $note = null, $message = null, $read = null)
    {
        $this
            ->setCode($code)
            ->setDt($dt)
            ->setNote($note)
            ->setMessage($message)
            ->setRead($read);
    }
    /**
     * Get code value
     * @return int|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param int $code
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !is_numeric($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get dt value
     * @return string|null
     */
    public function getDt()
    {
        return $this->dt;
    }
    /**
     * Set dt value
     * @param string $dt
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public function setDt($dt = null)
    {
        // validation for constraint: string
        if (!is_null($dt) && !is_string($dt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dt)), __LINE__);
        }
        $this->dt = $dt;
        return $this;
    }
    /**
     * Get note value
     * @return string|null
     */
    public function getNote()
    {
        return $this->note;
    }
    /**
     * Set note value
     * @param string $note
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public function setNote($note = null)
    {
        // validation for constraint: string
        if (!is_null($note) && !is_string($note)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($note)), __LINE__);
        }
        $this->note = $note;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get read value
     * @return string|null
     */
    public function getRead()
    {
        return $this->read;
    }
    /**
     * Set read value
     * @param string $read
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public function setRead($read = null)
    {
        // validation for constraint: string
        if (!is_null($read) && !is_string($read)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($read)), __LINE__);
        }
        $this->read = $read;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Alert
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
