<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for alertSubscription StructType
 * @subpackage Structs
 */
class AlertSubscription extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The subscribed
     * @var bool
     */
    public $subscribed;
    /**
     * Constructor method for alertSubscription
     * @uses AlertSubscription::setId()
     * @uses AlertSubscription::setDescription()
     * @uses AlertSubscription::setSubscribed()
     * @param int $id
     * @param string $description
     * @param bool $subscribed
     */
    public function __construct($id = null, $description = null, $subscribed = null)
    {
        $this
            ->setId($id)
            ->setDescription($description)
            ->setSubscribed($subscribed);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscription
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscription
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get subscribed value
     * @return bool|null
     */
    public function getSubscribed()
    {
        return $this->subscribed;
    }
    /**
     * Set subscribed value
     * @param bool $subscribed
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscription
     */
    public function setSubscribed($subscribed = null)
    {
        // validation for constraint: boolean
        if (!is_null($subscribed) && !is_bool($subscribed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($subscribed)), __LINE__);
        }
        $this->subscribed = $subscribed;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
