<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for alertSubscriptionGroup StructType
 * @subpackage Structs
 */
class AlertSubscriptionGroup extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The alertSubscriptions
     * @var \QCC\CampusM\CloudService\StructType\AlertSubscriptions
     */
    public $alertSubscriptions;
    /**
     * Constructor method for alertSubscriptionGroup
     * @uses AlertSubscriptionGroup::setId()
     * @uses AlertSubscriptionGroup::setDescription()
     * @uses AlertSubscriptionGroup::setAlertSubscriptions()
     * @param int $id
     * @param string $description
     * @param \QCC\CampusM\CloudService\StructType\AlertSubscriptions $alertSubscriptions
     */
    public function __construct($id = null, $description = null, \QCC\CampusM\CloudService\StructType\AlertSubscriptions $alertSubscriptions = null)
    {
        $this
            ->setId($id)
            ->setDescription($description)
            ->setAlertSubscriptions($alertSubscriptions);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscriptionGroup
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscriptionGroup
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get alertSubscriptions value
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscriptions|null
     */
    public function getAlertSubscriptions()
    {
        return $this->alertSubscriptions;
    }
    /**
     * Set alertSubscriptions value
     * @param \QCC\CampusM\CloudService\StructType\AlertSubscriptions $alertSubscriptions
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscriptionGroup
     */
    public function setAlertSubscriptions(\QCC\CampusM\CloudService\StructType\AlertSubscriptions $alertSubscriptions = null)
    {
        $this->alertSubscriptions = $alertSubscriptions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AlertSubscriptionGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
