<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for appUserAlertSubscription StructType
 * @subpackage Structs
 */
class AppUserAlertSubscription extends AbstractStructBase
{
    /**
     * The alertSubscriptionId
     * @var int
     */
    public $alertSubscriptionId;
    /**
     * The alertGroupName
     * @var string
     */
    public $alertGroupName;
    /**
     * Constructor method for appUserAlertSubscription
     * @uses AppUserAlertSubscription::setAlertSubscriptionId()
     * @uses AppUserAlertSubscription::setAlertGroupName()
     * @param int $alertSubscriptionId
     * @param string $alertGroupName
     */
    public function __construct($alertSubscriptionId = null, $alertGroupName = null)
    {
        $this
            ->setAlertSubscriptionId($alertSubscriptionId)
            ->setAlertGroupName($alertGroupName);
    }
    /**
     * Get alertSubscriptionId value
     * @return int|null
     */
    public function getAlertSubscriptionId()
    {
        return $this->alertSubscriptionId;
    }
    /**
     * Set alertSubscriptionId value
     * @param int $alertSubscriptionId
     * @return \QCC\CampusM\CloudService\StructType\AppUserAlertSubscription
     */
    public function setAlertSubscriptionId($alertSubscriptionId = null)
    {
        // validation for constraint: int
        if (!is_null($alertSubscriptionId) && !is_numeric($alertSubscriptionId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($alertSubscriptionId)), __LINE__);
        }
        $this->alertSubscriptionId = $alertSubscriptionId;
        return $this;
    }
    /**
     * Get alertGroupName value
     * @return string|null
     */
    public function getAlertGroupName()
    {
        return $this->alertGroupName;
    }
    /**
     * Set alertGroupName value
     * @param string $alertGroupName
     * @return \QCC\CampusM\CloudService\StructType\AppUserAlertSubscription
     */
    public function setAlertGroupName($alertGroupName = null)
    {
        // validation for constraint: string
        if (!is_null($alertGroupName) && !is_string($alertGroupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alertGroupName)), __LINE__);
        }
        $this->alertGroupName = $alertGroupName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AppUserAlertSubscription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
