<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for appropriate StructType
 * @subpackage Structs
 */
class Appropriate extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The vqCode
     * @var int
     */
    public $vqCode;
    /**
     * Constructor method for appropriate
     * @uses Appropriate::setPersonId()
     * @uses Appropriate::setPassword()
     * @uses Appropriate::setVqCode()
     * @param int $personId
     * @param string $password
     * @param int $vqCode
     */
    public function __construct($personId = null, $password = null, $vqCode = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setVqCode($vqCode);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\Appropriate
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\Appropriate
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get vqCode value
     * @return int|null
     */
    public function getVqCode()
    {
        return $this->vqCode;
    }
    /**
     * Set vqCode value
     * @param int $vqCode
     * @return \QCC\CampusM\CloudService\StructType\Appropriate
     */
    public function setVqCode($vqCode = null)
    {
        // validation for constraint: int
        if (!is_null($vqCode) && !is_numeric($vqCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vqCode)), __LINE__);
        }
        $this->vqCode = $vqCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Appropriate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
