<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for assetValues StructType
 * @subpackage Structs
 */
class AssetValues extends AbstractStructBase
{
    /**
     * The assetValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\AssetValue[]
     */
    public $assetValue;
    /**
     * Constructor method for assetValues
     * @uses AssetValues::setAssetValue()
     * @param \QCC\CampusM\CloudService\StructType\AssetValue[] $assetValue
     */
    public function __construct(array $assetValue = array())
    {
        $this
            ->setAssetValue($assetValue);
    }
    /**
     * Get assetValue value
     * @return \QCC\CampusM\CloudService\StructType\AssetValue[]|null
     */
    public function getAssetValue()
    {
        return $this->assetValue;
    }
    /**
     * Set assetValue value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\AssetValue[] $assetValue
     * @return \QCC\CampusM\CloudService\StructType\AssetValues
     */
    public function setAssetValue(array $assetValue = array())
    {
        foreach ($assetValue as $assetValuesAssetValueItem) {
            // validation for constraint: itemType
            if (!$assetValuesAssetValueItem instanceof \QCC\CampusM\CloudService\StructType\AssetValue) {
                throw new \InvalidArgumentException(sprintf('The assetValue property can only contain items of \QCC\CampusM\CloudService\StructType\AssetValue, "%s" given', is_object($assetValuesAssetValueItem) ? get_class($assetValuesAssetValueItem) : gettype($assetValuesAssetValueItem)), __LINE__);
            }
        }
        $this->assetValue = $assetValue;
        return $this;
    }
    /**
     * Add item to assetValue value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\AssetValue $item
     * @return \QCC\CampusM\CloudService\StructType\AssetValues
     */
    public function addToAssetValue(\QCC\CampusM\CloudService\StructType\AssetValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\AssetValue) {
            throw new \InvalidArgumentException(sprintf('The assetValue property can only contain items of \QCC\CampusM\CloudService\StructType\AssetValue, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->assetValue[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AssetValues
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
