<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for attribute StructType
 * @subpackage Structs
 */
class Attribute extends AbstractStructBase
{
    /**
     * The attributeName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $attributeName;
    /**
     * The attributeDisplayName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $attributeDisplayName;
    /**
     * The attributeValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $attributeValue;
    /**
     * Constructor method for attribute
     * @uses Attribute::setAttributeName()
     * @uses Attribute::setAttributeDisplayName()
     * @uses Attribute::setAttributeValue()
     * @param string $attributeName
     * @param string $attributeDisplayName
     * @param string $attributeValue
     */
    public function __construct($attributeName = null, $attributeDisplayName = null, $attributeValue = null)
    {
        $this
            ->setAttributeName($attributeName)
            ->setAttributeDisplayName($attributeDisplayName)
            ->setAttributeValue($attributeValue);
    }
    /**
     * Get attributeName value
     * @return string|null
     */
    public function getAttributeName()
    {
        return $this->attributeName;
    }
    /**
     * Set attributeName value
     * @param string $attributeName
     * @return \QCC\CampusM\CloudService\StructType\Attribute
     */
    public function setAttributeName($attributeName = null)
    {
        // validation for constraint: string
        if (!is_null($attributeName) && !is_string($attributeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeName)), __LINE__);
        }
        $this->attributeName = $attributeName;
        return $this;
    }
    /**
     * Get attributeDisplayName value
     * @return string|null
     */
    public function getAttributeDisplayName()
    {
        return $this->attributeDisplayName;
    }
    /**
     * Set attributeDisplayName value
     * @param string $attributeDisplayName
     * @return \QCC\CampusM\CloudService\StructType\Attribute
     */
    public function setAttributeDisplayName($attributeDisplayName = null)
    {
        // validation for constraint: string
        if (!is_null($attributeDisplayName) && !is_string($attributeDisplayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeDisplayName)), __LINE__);
        }
        $this->attributeDisplayName = $attributeDisplayName;
        return $this;
    }
    /**
     * Get attributeValue value
     * @return string|null
     */
    public function getAttributeValue()
    {
        return $this->attributeValue;
    }
    /**
     * Set attributeValue value
     * @param string $attributeValue
     * @return \QCC\CampusM\CloudService\StructType\Attribute
     */
    public function setAttributeValue($attributeValue = null)
    {
        // validation for constraint: string
        if (!is_null($attributeValue) && !is_string($attributeValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeValue)), __LINE__);
        }
        $this->attributeValue = $attributeValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Attribute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
