<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for authRssItem StructType
 * @subpackage Structs
 */
class AuthRssItem extends AbstractStructBase
{
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The sname
     * @var string
     */
    public $sname;
    /**
     * The rssUrl
     * @var string
     */
    public $rssUrl;
    /**
     * The sortOrder
     * @var string
     */
    public $sortOrder;
    /**
     * Constructor method for authRssItem
     * @uses AuthRssItem::setDescription()
     * @uses AuthRssItem::setSname()
     * @uses AuthRssItem::setRssUrl()
     * @uses AuthRssItem::setSortOrder()
     * @param string $description
     * @param string $sname
     * @param string $rssUrl
     * @param string $sortOrder
     */
    public function __construct($description = null, $sname = null, $rssUrl = null, $sortOrder = null)
    {
        $this
            ->setDescription($description)
            ->setSname($sname)
            ->setRssUrl($rssUrl)
            ->setSortOrder($sortOrder);
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\AuthRssItem
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get sname value
     * @return string|null
     */
    public function getSname()
    {
        return $this->sname;
    }
    /**
     * Set sname value
     * @param string $sname
     * @return \QCC\CampusM\CloudService\StructType\AuthRssItem
     */
    public function setSname($sname = null)
    {
        // validation for constraint: string
        if (!is_null($sname) && !is_string($sname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sname)), __LINE__);
        }
        $this->sname = $sname;
        return $this;
    }
    /**
     * Get rssUrl value
     * @return string|null
     */
    public function getRssUrl()
    {
        return $this->rssUrl;
    }
    /**
     * Set rssUrl value
     * @param string $rssUrl
     * @return \QCC\CampusM\CloudService\StructType\AuthRssItem
     */
    public function setRssUrl($rssUrl = null)
    {
        // validation for constraint: string
        if (!is_null($rssUrl) && !is_string($rssUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rssUrl)), __LINE__);
        }
        $this->rssUrl = $rssUrl;
        return $this;
    }
    /**
     * Get sortOrder value
     * @return string|null
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }
    /**
     * Set sortOrder value
     * @param string $sortOrder
     * @return \QCC\CampusM\CloudService\StructType\AuthRssItem
     */
    public function setSortOrder($sortOrder = null)
    {
        // validation for constraint: string
        if (!is_null($sortOrder) && !is_string($sortOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sortOrder)), __LINE__);
        }
        $this->sortOrder = $sortOrder;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\AuthRssItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
