<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for base64Image StructType
 * @subpackage Structs
 */
class Base64Image extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $id;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The url
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $url;
    /**
     * The dateEntered
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateEntered;
    /**
     * The base64
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $base64;
    /**
     * Constructor method for base64Image
     * @uses Base64Image::setId()
     * @uses Base64Image::setName()
     * @uses Base64Image::setUrl()
     * @uses Base64Image::setDateEntered()
     * @uses Base64Image::setBase64()
     * @param int $id
     * @param string $name
     * @param string $url
     * @param string $dateEntered
     * @param string $base64
     */
    public function __construct($id = null, $name = null, $url = null, $dateEntered = null, $base64 = null)
    {
        $this
            ->setId($id)
            ->setName($name)
            ->setUrl($url)
            ->setDateEntered($dateEntered)
            ->setBase64($base64);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Get dateEntered value
     * @return string|null
     */
    public function getDateEntered()
    {
        return $this->dateEntered;
    }
    /**
     * Set dateEntered value
     * @param string $dateEntered
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public function setDateEntered($dateEntered = null)
    {
        // validation for constraint: string
        if (!is_null($dateEntered) && !is_string($dateEntered)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateEntered)), __LINE__);
        }
        $this->dateEntered = $dateEntered;
        return $this;
    }
    /**
     * Get base64 value
     * @return string|null
     */
    public function getBase64()
    {
        return $this->base64;
    }
    /**
     * Set base64 value
     * @param string $base64
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public function setBase64($base64 = null)
    {
        // validation for constraint: string
        if (!is_null($base64) && !is_string($base64)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($base64)), __LINE__);
        }
        $this->base64 = $base64;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Base64Image
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
