<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for beaconIds StructType
 * @subpackage Structs
 */
class BeaconIds extends AbstractStructBase
{
    /**
     * The beaconId
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $beaconId;
    /**
     * Constructor method for beaconIds
     * @uses BeaconIds::setBeaconId()
     * @param string[] $beaconId
     */
    public function __construct(array $beaconId = array())
    {
        $this
            ->setBeaconId($beaconId);
    }
    /**
     * Get beaconId value
     * @return string[]|null
     */
    public function getBeaconId()
    {
        return $this->beaconId;
    }
    /**
     * Set beaconId value
     * @throws \InvalidArgumentException
     * @param string[] $beaconId
     * @return \QCC\CampusM\CloudService\StructType\BeaconIds
     */
    public function setBeaconId(array $beaconId = array())
    {
        foreach ($beaconId as $beaconIdsBeaconIdItem) {
            // validation for constraint: itemType
            if (!is_string($beaconIdsBeaconIdItem)) {
                throw new \InvalidArgumentException(sprintf('The beaconId property can only contain items of string, "%s" given', is_object($beaconIdsBeaconIdItem) ? get_class($beaconIdsBeaconIdItem) : gettype($beaconIdsBeaconIdItem)), __LINE__);
            }
        }
        $this->beaconId = $beaconId;
        return $this;
    }
    /**
     * Add item to beaconId value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \QCC\CampusM\CloudService\StructType\BeaconIds
     */
    public function addToBeaconId($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The beaconId property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->beaconId[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\BeaconIds
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
