<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for blackberryPushConfig StructType
 * @subpackage Structs
 */
class BlackberryPushConfig extends AbstractStructBase
{
    /**
     * The blackberryPushConfigLastUpdated
     * @var string
     */
    public $blackberryPushConfigLastUpdated;
    /**
     * The blackberryAppId
     * @var string
     */
    public $blackberryAppId;
    /**
     * The blackberryPPGUrl
     * @var string
     */
    public $blackberryPPGUrl;
    /**
     * The blackberryPPGPort
     * @var int
     */
    public $blackberryPPGPort;
    /**
     * Constructor method for blackberryPushConfig
     * @uses BlackberryPushConfig::setBlackberryPushConfigLastUpdated()
     * @uses BlackberryPushConfig::setBlackberryAppId()
     * @uses BlackberryPushConfig::setBlackberryPPGUrl()
     * @uses BlackberryPushConfig::setBlackberryPPGPort()
     * @param string $blackberryPushConfigLastUpdated
     * @param string $blackberryAppId
     * @param string $blackberryPPGUrl
     * @param int $blackberryPPGPort
     */
    public function __construct($blackberryPushConfigLastUpdated = null, $blackberryAppId = null, $blackberryPPGUrl = null, $blackberryPPGPort = null)
    {
        $this
            ->setBlackberryPushConfigLastUpdated($blackberryPushConfigLastUpdated)
            ->setBlackberryAppId($blackberryAppId)
            ->setBlackberryPPGUrl($blackberryPPGUrl)
            ->setBlackberryPPGPort($blackberryPPGPort);
    }
    /**
     * Get blackberryPushConfigLastUpdated value
     * @return string|null
     */
    public function getBlackberryPushConfigLastUpdated()
    {
        return $this->blackberryPushConfigLastUpdated;
    }
    /**
     * Set blackberryPushConfigLastUpdated value
     * @param string $blackberryPushConfigLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\BlackberryPushConfig
     */
    public function setBlackberryPushConfigLastUpdated($blackberryPushConfigLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($blackberryPushConfigLastUpdated) && !is_string($blackberryPushConfigLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blackberryPushConfigLastUpdated)), __LINE__);
        }
        $this->blackberryPushConfigLastUpdated = $blackberryPushConfigLastUpdated;
        return $this;
    }
    /**
     * Get blackberryAppId value
     * @return string|null
     */
    public function getBlackberryAppId()
    {
        return $this->blackberryAppId;
    }
    /**
     * Set blackberryAppId value
     * @param string $blackberryAppId
     * @return \QCC\CampusM\CloudService\StructType\BlackberryPushConfig
     */
    public function setBlackberryAppId($blackberryAppId = null)
    {
        // validation for constraint: string
        if (!is_null($blackberryAppId) && !is_string($blackberryAppId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blackberryAppId)), __LINE__);
        }
        $this->blackberryAppId = $blackberryAppId;
        return $this;
    }
    /**
     * Get blackberryPPGUrl value
     * @return string|null
     */
    public function getBlackberryPPGUrl()
    {
        return $this->blackberryPPGUrl;
    }
    /**
     * Set blackberryPPGUrl value
     * @param string $blackberryPPGUrl
     * @return \QCC\CampusM\CloudService\StructType\BlackberryPushConfig
     */
    public function setBlackberryPPGUrl($blackberryPPGUrl = null)
    {
        // validation for constraint: string
        if (!is_null($blackberryPPGUrl) && !is_string($blackberryPPGUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blackberryPPGUrl)), __LINE__);
        }
        $this->blackberryPPGUrl = $blackberryPPGUrl;
        return $this;
    }
    /**
     * Get blackberryPPGPort value
     * @return int|null
     */
    public function getBlackberryPPGPort()
    {
        return $this->blackberryPPGPort;
    }
    /**
     * Set blackberryPPGPort value
     * @param int $blackberryPPGPort
     * @return \QCC\CampusM\CloudService\StructType\BlackberryPushConfig
     */
    public function setBlackberryPPGPort($blackberryPPGPort = null)
    {
        // validation for constraint: int
        if (!is_null($blackberryPPGPort) && !is_numeric($blackberryPPGPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($blackberryPPGPort)), __LINE__);
        }
        $this->blackberryPPGPort = $blackberryPPGPort;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\BlackberryPushConfig
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
