<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cachedGuideItems StructType
 * @subpackage Structs
 */
class CachedGuideItems extends AbstractStructBase
{
    /**
     * The pocketGuideLastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pocketGuideLastUpdated;
    /**
     * The deviceInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\DeviceItems
     */
    public $deviceInfo;
    /**
     * The cssInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\CssItems
     */
    public $cssInfo;
    /**
     * The javascriptInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\JavascriptItems
     */
    public $javascriptInfo;
    /**
     * The cachedPGItems
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\CachedPGItems
     */
    public $cachedPGItems;
    /**
     * Constructor method for cachedGuideItems
     * @uses CachedGuideItems::setPocketGuideLastUpdated()
     * @uses CachedGuideItems::setDeviceInfo()
     * @uses CachedGuideItems::setCssInfo()
     * @uses CachedGuideItems::setJavascriptInfo()
     * @uses CachedGuideItems::setCachedPGItems()
     * @param string $pocketGuideLastUpdated
     * @param \QCC\CampusM\CloudService\StructType\DeviceItems $deviceInfo
     * @param \QCC\CampusM\CloudService\StructType\CssItems $cssInfo
     * @param \QCC\CampusM\CloudService\StructType\JavascriptItems $javascriptInfo
     * @param \QCC\CampusM\CloudService\StructType\CachedPGItems $cachedPGItems
     */
    public function __construct($pocketGuideLastUpdated = null, \QCC\CampusM\CloudService\StructType\DeviceItems $deviceInfo = null, \QCC\CampusM\CloudService\StructType\CssItems $cssInfo = null, \QCC\CampusM\CloudService\StructType\JavascriptItems $javascriptInfo = null, \QCC\CampusM\CloudService\StructType\CachedPGItems $cachedPGItems = null)
    {
        $this
            ->setPocketGuideLastUpdated($pocketGuideLastUpdated)
            ->setDeviceInfo($deviceInfo)
            ->setCssInfo($cssInfo)
            ->setJavascriptInfo($javascriptInfo)
            ->setCachedPGItems($cachedPGItems);
    }
    /**
     * Get pocketGuideLastUpdated value
     * @return string|null
     */
    public function getPocketGuideLastUpdated()
    {
        return $this->pocketGuideLastUpdated;
    }
    /**
     * Set pocketGuideLastUpdated value
     * @param string $pocketGuideLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public function setPocketGuideLastUpdated($pocketGuideLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($pocketGuideLastUpdated) && !is_string($pocketGuideLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pocketGuideLastUpdated)), __LINE__);
        }
        $this->pocketGuideLastUpdated = $pocketGuideLastUpdated;
        return $this;
    }
    /**
     * Get deviceInfo value
     * @return \QCC\CampusM\CloudService\StructType\DeviceItems|null
     */
    public function getDeviceInfo()
    {
        return $this->deviceInfo;
    }
    /**
     * Set deviceInfo value
     * @param \QCC\CampusM\CloudService\StructType\DeviceItems $deviceInfo
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public function setDeviceInfo(\QCC\CampusM\CloudService\StructType\DeviceItems $deviceInfo = null)
    {
        $this->deviceInfo = $deviceInfo;
        return $this;
    }
    /**
     * Get cssInfo value
     * @return \QCC\CampusM\CloudService\StructType\CssItems|null
     */
    public function getCssInfo()
    {
        return $this->cssInfo;
    }
    /**
     * Set cssInfo value
     * @param \QCC\CampusM\CloudService\StructType\CssItems $cssInfo
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public function setCssInfo(\QCC\CampusM\CloudService\StructType\CssItems $cssInfo = null)
    {
        $this->cssInfo = $cssInfo;
        return $this;
    }
    /**
     * Get javascriptInfo value
     * @return \QCC\CampusM\CloudService\StructType\JavascriptItems|null
     */
    public function getJavascriptInfo()
    {
        return $this->javascriptInfo;
    }
    /**
     * Set javascriptInfo value
     * @param \QCC\CampusM\CloudService\StructType\JavascriptItems $javascriptInfo
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public function setJavascriptInfo(\QCC\CampusM\CloudService\StructType\JavascriptItems $javascriptInfo = null)
    {
        $this->javascriptInfo = $javascriptInfo;
        return $this;
    }
    /**
     * Get cachedPGItems value
     * @return \QCC\CampusM\CloudService\StructType\CachedPGItems|null
     */
    public function getCachedPGItems()
    {
        return $this->cachedPGItems;
    }
    /**
     * Set cachedPGItems value
     * @param \QCC\CampusM\CloudService\StructType\CachedPGItems $cachedPGItems
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public function setCachedPGItems(\QCC\CampusM\CloudService\StructType\CachedPGItems $cachedPGItems = null)
    {
        $this->cachedPGItems = $cachedPGItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
