<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cachedMapPositionResponse StructType
 * @subpackage Structs
 */
class CachedMapPositionResponse extends AbstractStructBase
{
    /**
     * The mapsLastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mapsLastUpdated;
    /**
     * The locationsLastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $locationsLastUpdated;
    /**
     * The cachedMapItems
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\CachedMapItems
     */
    public $cachedMapItems;
    /**
     * Constructor method for cachedMapPositionResponse
     * @uses CachedMapPositionResponse::setMapsLastUpdated()
     * @uses CachedMapPositionResponse::setLocationsLastUpdated()
     * @uses CachedMapPositionResponse::setCachedMapItems()
     * @param string $mapsLastUpdated
     * @param string $locationsLastUpdated
     * @param \QCC\CampusM\CloudService\StructType\CachedMapItems $cachedMapItems
     */
    public function __construct($mapsLastUpdated = null, $locationsLastUpdated = null, \QCC\CampusM\CloudService\StructType\CachedMapItems $cachedMapItems = null)
    {
        $this
            ->setMapsLastUpdated($mapsLastUpdated)
            ->setLocationsLastUpdated($locationsLastUpdated)
            ->setCachedMapItems($cachedMapItems);
    }
    /**
     * Get mapsLastUpdated value
     * @return string|null
     */
    public function getMapsLastUpdated()
    {
        return $this->mapsLastUpdated;
    }
    /**
     * Set mapsLastUpdated value
     * @param string $mapsLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\CachedMapPositionResponse
     */
    public function setMapsLastUpdated($mapsLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($mapsLastUpdated) && !is_string($mapsLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mapsLastUpdated)), __LINE__);
        }
        $this->mapsLastUpdated = $mapsLastUpdated;
        return $this;
    }
    /**
     * Get locationsLastUpdated value
     * @return string|null
     */
    public function getLocationsLastUpdated()
    {
        return $this->locationsLastUpdated;
    }
    /**
     * Set locationsLastUpdated value
     * @param string $locationsLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\CachedMapPositionResponse
     */
    public function setLocationsLastUpdated($locationsLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($locationsLastUpdated) && !is_string($locationsLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locationsLastUpdated)), __LINE__);
        }
        $this->locationsLastUpdated = $locationsLastUpdated;
        return $this;
    }
    /**
     * Get cachedMapItems value
     * @return \QCC\CampusM\CloudService\StructType\CachedMapItems|null
     */
    public function getCachedMapItems()
    {
        return $this->cachedMapItems;
    }
    /**
     * Set cachedMapItems value
     * @param \QCC\CampusM\CloudService\StructType\CachedMapItems $cachedMapItems
     * @return \QCC\CampusM\CloudService\StructType\CachedMapPositionResponse
     */
    public function setCachedMapItems(\QCC\CampusM\CloudService\StructType\CachedMapItems $cachedMapItems = null)
    {
        $this->cachedMapItems = $cachedMapItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\CachedMapPositionResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
