<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for certificateStatusResponse StructType
 * @subpackage Structs
 */
class CertificateStatusResponse extends AbstractStructBase
{
    /**
     * The certificateStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\CertificateStatus[]
     */
    public $certificateStatus;
    /**
     * Constructor method for certificateStatusResponse
     * @uses CertificateStatusResponse::setCertificateStatus()
     * @param \QCC\CampusM\CloudService\StructType\CertificateStatus[] $certificateStatus
     */
    public function __construct(array $certificateStatus = array())
    {
        $this
            ->setCertificateStatus($certificateStatus);
    }
    /**
     * Get certificateStatus value
     * @return \QCC\CampusM\CloudService\StructType\CertificateStatus[]|null
     */
    public function getCertificateStatus()
    {
        return $this->certificateStatus;
    }
    /**
     * Set certificateStatus value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\CertificateStatus[] $certificateStatus
     * @return \QCC\CampusM\CloudService\StructType\CertificateStatusResponse
     */
    public function setCertificateStatus(array $certificateStatus = array())
    {
        foreach ($certificateStatus as $certificateStatusResponseCertificateStatusItem) {
            // validation for constraint: itemType
            if (!$certificateStatusResponseCertificateStatusItem instanceof \QCC\CampusM\CloudService\StructType\CertificateStatus) {
                throw new \InvalidArgumentException(sprintf('The certificateStatus property can only contain items of \QCC\CampusM\CloudService\StructType\CertificateStatus, "%s" given', is_object($certificateStatusResponseCertificateStatusItem) ? get_class($certificateStatusResponseCertificateStatusItem) : gettype($certificateStatusResponseCertificateStatusItem)), __LINE__);
            }
        }
        $this->certificateStatus = $certificateStatus;
        return $this;
    }
    /**
     * Add item to certificateStatus value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\CertificateStatus $item
     * @return \QCC\CampusM\CloudService\StructType\CertificateStatusResponse
     */
    public function addToCertificateStatus(\QCC\CampusM\CloudService\StructType\CertificateStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\CertificateStatus) {
            throw new \InvalidArgumentException(sprintf('The certificateStatus property can only contain items of \QCC\CampusM\CloudService\StructType\CertificateStatus, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->certificateStatus[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\CertificateStatusResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
