<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for colours StructType
 * @subpackage Structs
 */
class Colours extends AbstractStructBase
{
    /**
     * The citem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Citem[]
     */
    public $citem;
    /**
     * The titem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Titem[]
     */
    public $titem;
    /**
     * Constructor method for colours
     * @uses Colours::setCitem()
     * @uses Colours::setTitem()
     * @param \QCC\CampusM\CloudService\StructType\Citem[] $citem
     * @param \QCC\CampusM\CloudService\StructType\Titem[] $titem
     */
    public function __construct(array $citem = array(), array $titem = array())
    {
        $this
            ->setCitem($citem)
            ->setTitem($titem);
    }
    /**
     * Get citem value
     * @return \QCC\CampusM\CloudService\StructType\Citem[]|null
     */
    public function getCitem()
    {
        return $this->citem;
    }
    /**
     * Set citem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Citem[] $citem
     * @return \QCC\CampusM\CloudService\StructType\Colours
     */
    public function setCitem(array $citem = array())
    {
        foreach ($citem as $coloursCitemItem) {
            // validation for constraint: itemType
            if (!$coloursCitemItem instanceof \QCC\CampusM\CloudService\StructType\Citem) {
                throw new \InvalidArgumentException(sprintf('The citem property can only contain items of \QCC\CampusM\CloudService\StructType\Citem, "%s" given', is_object($coloursCitemItem) ? get_class($coloursCitemItem) : gettype($coloursCitemItem)), __LINE__);
            }
        }
        $this->citem = $citem;
        return $this;
    }
    /**
     * Add item to citem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Citem $item
     * @return \QCC\CampusM\CloudService\StructType\Colours
     */
    public function addToCitem(\QCC\CampusM\CloudService\StructType\Citem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Citem) {
            throw new \InvalidArgumentException(sprintf('The citem property can only contain items of \QCC\CampusM\CloudService\StructType\Citem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->citem[] = $item;
        return $this;
    }
    /**
     * Get titem value
     * @return \QCC\CampusM\CloudService\StructType\Titem[]|null
     */
    public function getTitem()
    {
        return $this->titem;
    }
    /**
     * Set titem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Titem[] $titem
     * @return \QCC\CampusM\CloudService\StructType\Colours
     */
    public function setTitem(array $titem = array())
    {
        foreach ($titem as $coloursTitemItem) {
            // validation for constraint: itemType
            if (!$coloursTitemItem instanceof \QCC\CampusM\CloudService\StructType\Titem) {
                throw new \InvalidArgumentException(sprintf('The titem property can only contain items of \QCC\CampusM\CloudService\StructType\Titem, "%s" given', is_object($coloursTitemItem) ? get_class($coloursTitemItem) : gettype($coloursTitemItem)), __LINE__);
            }
        }
        $this->titem = $titem;
        return $this;
    }
    /**
     * Add item to titem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Titem $item
     * @return \QCC\CampusM\CloudService\StructType\Colours
     */
    public function addToTitem(\QCC\CampusM\CloudService\StructType\Titem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Titem) {
            throw new \InvalidArgumentException(sprintf('The titem property can only contain items of \QCC\CampusM\CloudService\StructType\Titem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->titem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Colours
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
