<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for country StructType
 * @subpackage Structs
 */
class Country extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The website
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $website;
    /**
     * The delegates
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Delegates
     */
    public $delegates;
    /**
     * Constructor method for country
     * @uses Country::setName()
     * @uses Country::setWebsite()
     * @uses Country::setDelegates()
     * @param string $name
     * @param string $website
     * @param \QCC\CampusM\CloudService\StructType\Delegates $delegates
     */
    public function __construct($name = null, $website = null, \QCC\CampusM\CloudService\StructType\Delegates $delegates = null)
    {
        $this
            ->setName($name)
            ->setWebsite($website)
            ->setDelegates($delegates);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \QCC\CampusM\CloudService\StructType\Country
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get website value
     * @return string|null
     */
    public function getWebsite()
    {
        return $this->website;
    }
    /**
     * Set website value
     * @param string $website
     * @return \QCC\CampusM\CloudService\StructType\Country
     */
    public function setWebsite($website = null)
    {
        // validation for constraint: string
        if (!is_null($website) && !is_string($website)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($website)), __LINE__);
        }
        $this->website = $website;
        return $this;
    }
    /**
     * Get delegates value
     * @return \QCC\CampusM\CloudService\StructType\Delegates|null
     */
    public function getDelegates()
    {
        return $this->delegates;
    }
    /**
     * Set delegates value
     * @param \QCC\CampusM\CloudService\StructType\Delegates $delegates
     * @return \QCC\CampusM\CloudService\StructType\Country
     */
    public function setDelegates(\QCC\CampusM\CloudService\StructType\Delegates $delegates = null)
    {
        $this->delegates = $delegates;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Country
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
