<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cssItem StructType
 * @subpackage Structs
 */
class CssItem extends AbstractStructBase
{
    /**
     * The cssUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cssUrl;
    /**
     * The cssContent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cssContent;
    /**
     * Constructor method for cssItem
     * @uses CssItem::setCssUrl()
     * @uses CssItem::setCssContent()
     * @param string $cssUrl
     * @param string $cssContent
     */
    public function __construct($cssUrl = null, $cssContent = null)
    {
        $this
            ->setCssUrl($cssUrl)
            ->setCssContent($cssContent);
    }
    /**
     * Get cssUrl value
     * @return string|null
     */
    public function getCssUrl()
    {
        return $this->cssUrl;
    }
    /**
     * Set cssUrl value
     * @param string $cssUrl
     * @return \QCC\CampusM\CloudService\StructType\CssItem
     */
    public function setCssUrl($cssUrl = null)
    {
        // validation for constraint: string
        if (!is_null($cssUrl) && !is_string($cssUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cssUrl)), __LINE__);
        }
        $this->cssUrl = $cssUrl;
        return $this;
    }
    /**
     * Get cssContent value
     * @return string|null
     */
    public function getCssContent()
    {
        return $this->cssContent;
    }
    /**
     * Set cssContent value
     * @param string $cssContent
     * @return \QCC\CampusM\CloudService\StructType\CssItem
     */
    public function setCssContent($cssContent = null)
    {
        // validation for constraint: string
        if (!is_null($cssContent) && !is_string($cssContent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cssContent)), __LINE__);
        }
        $this->cssContent = $cssContent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\CssItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
