<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cssItems StructType
 * @subpackage Structs
 */
class CssItems extends AbstractStructBase
{
    /**
     * The cssItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\CssItem[]
     */
    public $cssItem;
    /**
     * Constructor method for cssItems
     * @uses CssItems::setCssItem()
     * @param \QCC\CampusM\CloudService\StructType\CssItem[] $cssItem
     */
    public function __construct(array $cssItem = array())
    {
        $this
            ->setCssItem($cssItem);
    }
    /**
     * Get cssItem value
     * @return \QCC\CampusM\CloudService\StructType\CssItem[]|null
     */
    public function getCssItem()
    {
        return $this->cssItem;
    }
    /**
     * Set cssItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\CssItem[] $cssItem
     * @return \QCC\CampusM\CloudService\StructType\CssItems
     */
    public function setCssItem(array $cssItem = array())
    {
        foreach ($cssItem as $cssItemsCssItemItem) {
            // validation for constraint: itemType
            if (!$cssItemsCssItemItem instanceof \QCC\CampusM\CloudService\StructType\CssItem) {
                throw new \InvalidArgumentException(sprintf('The cssItem property can only contain items of \QCC\CampusM\CloudService\StructType\CssItem, "%s" given', is_object($cssItemsCssItemItem) ? get_class($cssItemsCssItemItem) : gettype($cssItemsCssItemItem)), __LINE__);
            }
        }
        $this->cssItem = $cssItem;
        return $this;
    }
    /**
     * Add item to cssItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\CssItem $item
     * @return \QCC\CampusM\CloudService\StructType\CssItems
     */
    public function addToCssItem(\QCC\CampusM\CloudService\StructType\CssItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\CssItem) {
            throw new \InvalidArgumentException(sprintf('The cssItem property can only contain items of \QCC\CampusM\CloudService\StructType\CssItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->cssItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\CssItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
