<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for details StructType
 * @subpackage Structs
 */
class Details extends AbstractStructBase
{
    /**
     * The detail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Detail[]
     */
    public $detail;
    /**
     * Constructor method for details
     * @uses Details::setDetail()
     * @param \QCC\CampusM\CloudService\StructType\Detail[] $detail
     */
    public function __construct(array $detail = array())
    {
        $this
            ->setDetail($detail);
    }
    /**
     * Get detail value
     * @return \QCC\CampusM\CloudService\StructType\Detail[]|null
     */
    public function getDetail()
    {
        return $this->detail;
    }
    /**
     * Set detail value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Detail[] $detail
     * @return \QCC\CampusM\CloudService\StructType\Details
     */
    public function setDetail(array $detail = array())
    {
        foreach ($detail as $detailsDetailItem) {
            // validation for constraint: itemType
            if (!$detailsDetailItem instanceof \QCC\CampusM\CloudService\StructType\Detail) {
                throw new \InvalidArgumentException(sprintf('The detail property can only contain items of \QCC\CampusM\CloudService\StructType\Detail, "%s" given', is_object($detailsDetailItem) ? get_class($detailsDetailItem) : gettype($detailsDetailItem)), __LINE__);
            }
        }
        $this->detail = $detail;
        return $this;
    }
    /**
     * Add item to detail value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Detail $item
     * @return \QCC\CampusM\CloudService\StructType\Details
     */
    public function addToDetail(\QCC\CampusM\CloudService\StructType\Detail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Detail) {
            throw new \InvalidArgumentException(sprintf('The detail property can only contain items of \QCC\CampusM\CloudService\StructType\Detail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->detail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Details
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
