<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceItem StructType
 * @subpackage Structs
 */
class DeviceItem extends AbstractStructBase
{
    /**
     * The deviceName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deviceName;
    /**
     * The header
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $header;
    /**
     * The footer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $footer;
    /**
     * Constructor method for deviceItem
     * @uses DeviceItem::setDeviceName()
     * @uses DeviceItem::setHeader()
     * @uses DeviceItem::setFooter()
     * @param string $deviceName
     * @param string $header
     * @param string $footer
     */
    public function __construct($deviceName = null, $header = null, $footer = null)
    {
        $this
            ->setDeviceName($deviceName)
            ->setHeader($header)
            ->setFooter($footer);
    }
    /**
     * Get deviceName value
     * @return string|null
     */
    public function getDeviceName()
    {
        return $this->deviceName;
    }
    /**
     * Set deviceName value
     * @param string $deviceName
     * @return \QCC\CampusM\CloudService\StructType\DeviceItem
     */
    public function setDeviceName($deviceName = null)
    {
        // validation for constraint: string
        if (!is_null($deviceName) && !is_string($deviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deviceName)), __LINE__);
        }
        $this->deviceName = $deviceName;
        return $this;
    }
    /**
     * Get header value
     * @return string|null
     */
    public function getHeader()
    {
        return $this->header;
    }
    /**
     * Set header value
     * @param string $header
     * @return \QCC\CampusM\CloudService\StructType\DeviceItem
     */
    public function setHeader($header = null)
    {
        // validation for constraint: string
        if (!is_null($header) && !is_string($header)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($header)), __LINE__);
        }
        $this->header = $header;
        return $this;
    }
    /**
     * Get footer value
     * @return string|null
     */
    public function getFooter()
    {
        return $this->footer;
    }
    /**
     * Set footer value
     * @param string $footer
     * @return \QCC\CampusM\CloudService\StructType\DeviceItem
     */
    public function setFooter($footer = null)
    {
        // validation for constraint: string
        if (!is_null($footer) && !is_string($footer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($footer)), __LINE__);
        }
        $this->footer = $footer;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\DeviceItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
