<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceItems StructType
 * @subpackage Structs
 */
class DeviceItems extends AbstractStructBase
{
    /**
     * The deviceItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\DeviceItem[]
     */
    public $deviceItem;
    /**
     * Constructor method for deviceItems
     * @uses DeviceItems::setDeviceItem()
     * @param \QCC\CampusM\CloudService\StructType\DeviceItem[] $deviceItem
     */
    public function __construct(array $deviceItem = array())
    {
        $this
            ->setDeviceItem($deviceItem);
    }
    /**
     * Get deviceItem value
     * @return \QCC\CampusM\CloudService\StructType\DeviceItem[]|null
     */
    public function getDeviceItem()
    {
        return $this->deviceItem;
    }
    /**
     * Set deviceItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\DeviceItem[] $deviceItem
     * @return \QCC\CampusM\CloudService\StructType\DeviceItems
     */
    public function setDeviceItem(array $deviceItem = array())
    {
        foreach ($deviceItem as $deviceItemsDeviceItemItem) {
            // validation for constraint: itemType
            if (!$deviceItemsDeviceItemItem instanceof \QCC\CampusM\CloudService\StructType\DeviceItem) {
                throw new \InvalidArgumentException(sprintf('The deviceItem property can only contain items of \QCC\CampusM\CloudService\StructType\DeviceItem, "%s" given', is_object($deviceItemsDeviceItemItem) ? get_class($deviceItemsDeviceItemItem) : gettype($deviceItemsDeviceItemItem)), __LINE__);
            }
        }
        $this->deviceItem = $deviceItem;
        return $this;
    }
    /**
     * Add item to deviceItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\DeviceItem $item
     * @return \QCC\CampusM\CloudService\StructType\DeviceItems
     */
    public function addToDeviceItem(\QCC\CampusM\CloudService\StructType\DeviceItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\DeviceItem) {
            throw new \InvalidArgumentException(sprintf('The deviceItem property can only contain items of \QCC\CampusM\CloudService\StructType\DeviceItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->deviceItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\DeviceItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
