<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for educauseSyncItineraryRequest StructType
 * @subpackage Structs
 */
class EducauseSyncItineraryRequest extends AbstractStructBase
{
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The itineraryRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $itineraryRef;
    /**
     * The addIds
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addIds;
    /**
     * The removeIds
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $removeIds;
    /**
     * Constructor method for educauseSyncItineraryRequest
     * @uses EducauseSyncItineraryRequest::setOrgCode()
     * @uses EducauseSyncItineraryRequest::setPersonId()
     * @uses EducauseSyncItineraryRequest::setPassword()
     * @uses EducauseSyncItineraryRequest::setItineraryRef()
     * @uses EducauseSyncItineraryRequest::setAddIds()
     * @uses EducauseSyncItineraryRequest::setRemoveIds()
     * @param int $orgCode
     * @param int $personId
     * @param string $password
     * @param string $itineraryRef
     * @param string $addIds
     * @param string $removeIds
     */
    public function __construct($orgCode = null, $personId = null, $password = null, $itineraryRef = null, $addIds = null, $removeIds = null)
    {
        $this
            ->setOrgCode($orgCode)
            ->setPersonId($personId)
            ->setPassword($password)
            ->setItineraryRef($itineraryRef)
            ->setAddIds($addIds)
            ->setRemoveIds($removeIds);
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get itineraryRef value
     * @return string|null
     */
    public function getItineraryRef()
    {
        return $this->itineraryRef;
    }
    /**
     * Set itineraryRef value
     * @param string $itineraryRef
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setItineraryRef($itineraryRef = null)
    {
        // validation for constraint: string
        if (!is_null($itineraryRef) && !is_string($itineraryRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($itineraryRef)), __LINE__);
        }
        $this->itineraryRef = $itineraryRef;
        return $this;
    }
    /**
     * Get addIds value
     * @return string|null
     */
    public function getAddIds()
    {
        return $this->addIds;
    }
    /**
     * Set addIds value
     * @param string $addIds
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setAddIds($addIds = null)
    {
        // validation for constraint: string
        if (!is_null($addIds) && !is_string($addIds)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addIds)), __LINE__);
        }
        $this->addIds = $addIds;
        return $this;
    }
    /**
     * Get removeIds value
     * @return string|null
     */
    public function getRemoveIds()
    {
        return $this->removeIds;
    }
    /**
     * Set removeIds value
     * @param string $removeIds
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public function setRemoveIds($removeIds = null)
    {
        // validation for constraint: string
        if (!is_null($removeIds) && !is_string($removeIds)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($removeIds)), __LINE__);
        }
        $this->removeIds = $removeIds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\EducauseSyncItineraryRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
