<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for emailAddresses StructType
 * @subpackage Structs
 */
class EmailAddresses extends AbstractStructBase
{
    /**
     * The email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 3
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\EmailAddress[]
     */
    public $email;
    /**
     * Constructor method for emailAddresses
     * @uses EmailAddresses::setEmail()
     * @param \QCC\CampusM\CloudService\StructType\EmailAddress[] $email
     */
    public function __construct(array $email = array())
    {
        $this
            ->setEmail($email);
    }
    /**
     * Get email value
     * @return \QCC\CampusM\CloudService\StructType\EmailAddress[]|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\EmailAddress[] $email
     * @return \QCC\CampusM\CloudService\StructType\EmailAddresses
     */
    public function setEmail(array $email = array())
    {
        foreach ($email as $emailAddressesEmailItem) {
            // validation for constraint: itemType
            if (!$emailAddressesEmailItem instanceof \QCC\CampusM\CloudService\StructType\EmailAddress) {
                throw new \InvalidArgumentException(sprintf('The email property can only contain items of \QCC\CampusM\CloudService\StructType\EmailAddress, "%s" given', is_object($emailAddressesEmailItem) ? get_class($emailAddressesEmailItem) : gettype($emailAddressesEmailItem)), __LINE__);
            }
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Add item to email value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\EmailAddress $item
     * @return \QCC\CampusM\CloudService\StructType\EmailAddresses
     */
    public function addToEmail(\QCC\CampusM\CloudService\StructType\EmailAddress $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\EmailAddress) {
            throw new \InvalidArgumentException(sprintf('The email property can only contain items of \QCC\CampusM\CloudService\StructType\EmailAddress, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->email[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\EmailAddresses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
