<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for expressionResult StructType
 * @subpackage Structs
 */
class ExpressionResult extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The read
     * @var string
     */
    public $read;
    /**
     * Constructor method for expressionResult
     * @uses ExpressionResult::setName()
     * @uses ExpressionResult::setRead()
     * @param string $name
     * @param string $read
     */
    public function __construct($name = null, $read = null)
    {
        $this
            ->setName($name)
            ->setRead($read);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \QCC\CampusM\CloudService\StructType\ExpressionResult
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get read value
     * @return string|null
     */
    public function getRead()
    {
        return $this->read;
    }
    /**
     * Set read value
     * @param string $read
     * @return \QCC\CampusM\CloudService\StructType\ExpressionResult
     */
    public function setRead($read = null)
    {
        // validation for constraint: string
        if (!is_null($read) && !is_string($read)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($read)), __LINE__);
        }
        $this->read = $read;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ExpressionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
