<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for facebookPostAuthorizeRequest StructType
 * @subpackage Structs
 */
class FacebookPostAuthorizeRequest extends AbstractStructBase
{
    /**
     * The fb_sig_authorize
     * @var int
     */
    public $fb_sig_authorize;
    /**
     * The fb_sig_time
     * @var string
     */
    public $fb_sig_time;
    /**
     * The fb_sig_user
     * @var int
     */
    public $fb_sig_user;
    /**
     * The fb_sig_profile_update_time
     * @var int
     */
    public $fb_sig_profile_update_time;
    /**
     * The fb_sig_session_key
     * @var string
     */
    public $fb_sig_session_key;
    /**
     * The fb_sig_expires
     * @var int
     */
    public $fb_sig_expires;
    /**
     * The fb_sig_api_key
     * @var string
     */
    public $fb_sig_api_key;
    /**
     * The fb_sig_linked_account_ids
     * @var string
     */
    public $fb_sig_linked_account_ids;
    /**
     * The fb_sig
     * @var string
     */
    public $fb_sig;
    /**
     * Constructor method for facebookPostAuthorizeRequest
     * @uses FacebookPostAuthorizeRequest::setFb_sig_authorize()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_time()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_user()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_profile_update_time()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_session_key()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_expires()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_api_key()
     * @uses FacebookPostAuthorizeRequest::setFb_sig_linked_account_ids()
     * @uses FacebookPostAuthorizeRequest::setFb_sig()
     * @param int $fb_sig_authorize
     * @param string $fb_sig_time
     * @param int $fb_sig_user
     * @param int $fb_sig_profile_update_time
     * @param string $fb_sig_session_key
     * @param int $fb_sig_expires
     * @param string $fb_sig_api_key
     * @param string $fb_sig_linked_account_ids
     * @param string $fb_sig
     */
    public function __construct($fb_sig_authorize = null, $fb_sig_time = null, $fb_sig_user = null, $fb_sig_profile_update_time = null, $fb_sig_session_key = null, $fb_sig_expires = null, $fb_sig_api_key = null, $fb_sig_linked_account_ids = null, $fb_sig = null)
    {
        $this
            ->setFb_sig_authorize($fb_sig_authorize)
            ->setFb_sig_time($fb_sig_time)
            ->setFb_sig_user($fb_sig_user)
            ->setFb_sig_profile_update_time($fb_sig_profile_update_time)
            ->setFb_sig_session_key($fb_sig_session_key)
            ->setFb_sig_expires($fb_sig_expires)
            ->setFb_sig_api_key($fb_sig_api_key)
            ->setFb_sig_linked_account_ids($fb_sig_linked_account_ids)
            ->setFb_sig($fb_sig);
    }
    /**
     * Get fb_sig_authorize value
     * @return int|null
     */
    public function getFb_sig_authorize()
    {
        return $this->fb_sig_authorize;
    }
    /**
     * Set fb_sig_authorize value
     * @param int $fb_sig_authorize
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_authorize($fb_sig_authorize = null)
    {
        // validation for constraint: int
        if (!is_null($fb_sig_authorize) && !is_numeric($fb_sig_authorize)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($fb_sig_authorize)), __LINE__);
        }
        $this->fb_sig_authorize = $fb_sig_authorize;
        return $this;
    }
    /**
     * Get fb_sig_time value
     * @return string|null
     */
    public function getFb_sig_time()
    {
        return $this->fb_sig_time;
    }
    /**
     * Set fb_sig_time value
     * @param string $fb_sig_time
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_time($fb_sig_time = null)
    {
        // validation for constraint: string
        if (!is_null($fb_sig_time) && !is_string($fb_sig_time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fb_sig_time)), __LINE__);
        }
        $this->fb_sig_time = $fb_sig_time;
        return $this;
    }
    /**
     * Get fb_sig_user value
     * @return int|null
     */
    public function getFb_sig_user()
    {
        return $this->fb_sig_user;
    }
    /**
     * Set fb_sig_user value
     * @param int $fb_sig_user
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_user($fb_sig_user = null)
    {
        // validation for constraint: int
        if (!is_null($fb_sig_user) && !is_numeric($fb_sig_user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($fb_sig_user)), __LINE__);
        }
        $this->fb_sig_user = $fb_sig_user;
        return $this;
    }
    /**
     * Get fb_sig_profile_update_time value
     * @return int|null
     */
    public function getFb_sig_profile_update_time()
    {
        return $this->fb_sig_profile_update_time;
    }
    /**
     * Set fb_sig_profile_update_time value
     * @param int $fb_sig_profile_update_time
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_profile_update_time($fb_sig_profile_update_time = null)
    {
        // validation for constraint: int
        if (!is_null($fb_sig_profile_update_time) && !is_numeric($fb_sig_profile_update_time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($fb_sig_profile_update_time)), __LINE__);
        }
        $this->fb_sig_profile_update_time = $fb_sig_profile_update_time;
        return $this;
    }
    /**
     * Get fb_sig_session_key value
     * @return string|null
     */
    public function getFb_sig_session_key()
    {
        return $this->fb_sig_session_key;
    }
    /**
     * Set fb_sig_session_key value
     * @param string $fb_sig_session_key
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_session_key($fb_sig_session_key = null)
    {
        // validation for constraint: string
        if (!is_null($fb_sig_session_key) && !is_string($fb_sig_session_key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fb_sig_session_key)), __LINE__);
        }
        $this->fb_sig_session_key = $fb_sig_session_key;
        return $this;
    }
    /**
     * Get fb_sig_expires value
     * @return int|null
     */
    public function getFb_sig_expires()
    {
        return $this->fb_sig_expires;
    }
    /**
     * Set fb_sig_expires value
     * @param int $fb_sig_expires
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_expires($fb_sig_expires = null)
    {
        // validation for constraint: int
        if (!is_null($fb_sig_expires) && !is_numeric($fb_sig_expires)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($fb_sig_expires)), __LINE__);
        }
        $this->fb_sig_expires = $fb_sig_expires;
        return $this;
    }
    /**
     * Get fb_sig_api_key value
     * @return string|null
     */
    public function getFb_sig_api_key()
    {
        return $this->fb_sig_api_key;
    }
    /**
     * Set fb_sig_api_key value
     * @param string $fb_sig_api_key
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_api_key($fb_sig_api_key = null)
    {
        // validation for constraint: string
        if (!is_null($fb_sig_api_key) && !is_string($fb_sig_api_key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fb_sig_api_key)), __LINE__);
        }
        $this->fb_sig_api_key = $fb_sig_api_key;
        return $this;
    }
    /**
     * Get fb_sig_linked_account_ids value
     * @return string|null
     */
    public function getFb_sig_linked_account_ids()
    {
        return $this->fb_sig_linked_account_ids;
    }
    /**
     * Set fb_sig_linked_account_ids value
     * @param string $fb_sig_linked_account_ids
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig_linked_account_ids($fb_sig_linked_account_ids = null)
    {
        // validation for constraint: string
        if (!is_null($fb_sig_linked_account_ids) && !is_string($fb_sig_linked_account_ids)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fb_sig_linked_account_ids)), __LINE__);
        }
        $this->fb_sig_linked_account_ids = $fb_sig_linked_account_ids;
        return $this;
    }
    /**
     * Get fb_sig value
     * @return string|null
     */
    public function getFb_sig()
    {
        return $this->fb_sig;
    }
    /**
     * Set fb_sig value
     * @param string $fb_sig
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public function setFb_sig($fb_sig = null)
    {
        // validation for constraint: string
        if (!is_null($fb_sig) && !is_string($fb_sig)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fb_sig)), __LINE__);
        }
        $this->fb_sig = $fb_sig;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FacebookPostAuthorizeRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
