<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for fitem StructType
 * @subpackage Structs
 */
class Fitem extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The order
     * @var int
     */
    public $order;
    /**
     * The share
     * @var string
     */
    public $share;
    /**
     * The locd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $locd;
    /**
     * The lati
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $lati;
    /**
     * The longi
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $longi;
    /**
     * The acc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $acc;
    /**
     * The com
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $com;
    /**
     * The photo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $photo;
    /**
     * The groupDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $groupDescription;
    /**
     * The distance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $distance;
    /**
     * The checkInLoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $checkInLoc;
    /**
     * The checkInLat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $checkInLat;
    /**
     * The checkInLong
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $checkInLong;
    /**
     * The checkInTime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $checkInTime;
    /**
     * The checkInPositionCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $checkInPositionCode;
    /**
     * Constructor method for fitem
     * @uses Fitem::setId()
     * @uses Fitem::setName()
     * @uses Fitem::setOrder()
     * @uses Fitem::setShare()
     * @uses Fitem::setLocd()
     * @uses Fitem::setLati()
     * @uses Fitem::setLongi()
     * @uses Fitem::setAcc()
     * @uses Fitem::setCom()
     * @uses Fitem::setPhoto()
     * @uses Fitem::setGroupDescription()
     * @uses Fitem::setDistance()
     * @uses Fitem::setCheckInLoc()
     * @uses Fitem::setCheckInLat()
     * @uses Fitem::setCheckInLong()
     * @uses Fitem::setCheckInTime()
     * @uses Fitem::setCheckInPositionCode()
     * @param int $id
     * @param string $name
     * @param int $order
     * @param string $share
     * @param string $locd
     * @param float $lati
     * @param float $longi
     * @param int $acc
     * @param string $com
     * @param string $photo
     * @param string $groupDescription
     * @param float $distance
     * @param string $checkInLoc
     * @param float $checkInLat
     * @param float $checkInLong
     * @param string $checkInTime
     * @param int $checkInPositionCode
     */
    public function __construct($id = null, $name = null, $order = null, $share = null, $locd = null, $lati = null, $longi = null, $acc = null, $com = null, $photo = null, $groupDescription = null, $distance = null, $checkInLoc = null, $checkInLat = null, $checkInLong = null, $checkInTime = null, $checkInPositionCode = null)
    {
        $this
            ->setId($id)
            ->setName($name)
            ->setOrder($order)
            ->setShare($share)
            ->setLocd($locd)
            ->setLati($lati)
            ->setLongi($longi)
            ->setAcc($acc)
            ->setCom($com)
            ->setPhoto($photo)
            ->setGroupDescription($groupDescription)
            ->setDistance($distance)
            ->setCheckInLoc($checkInLoc)
            ->setCheckInLat($checkInLat)
            ->setCheckInLong($checkInLong)
            ->setCheckInTime($checkInTime)
            ->setCheckInPositionCode($checkInPositionCode);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get order value
     * @return int|null
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @param int $order
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setOrder($order = null)
    {
        // validation for constraint: int
        if (!is_null($order) && !is_numeric($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($order)), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
    /**
     * Get share value
     * @return string|null
     */
    public function getShare()
    {
        return $this->share;
    }
    /**
     * Set share value
     * @param string $share
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setShare($share = null)
    {
        // validation for constraint: string
        if (!is_null($share) && !is_string($share)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($share)), __LINE__);
        }
        $this->share = $share;
        return $this;
    }
    /**
     * Get locd value
     * @return string|null
     */
    public function getLocd()
    {
        return $this->locd;
    }
    /**
     * Set locd value
     * @param string $locd
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setLocd($locd = null)
    {
        // validation for constraint: string
        if (!is_null($locd) && !is_string($locd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locd)), __LINE__);
        }
        $this->locd = $locd;
        return $this;
    }
    /**
     * Get lati value
     * @return float|null
     */
    public function getLati()
    {
        return $this->lati;
    }
    /**
     * Set lati value
     * @param float $lati
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setLati($lati = null)
    {
        $this->lati = $lati;
        return $this;
    }
    /**
     * Get longi value
     * @return float|null
     */
    public function getLongi()
    {
        return $this->longi;
    }
    /**
     * Set longi value
     * @param float $longi
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setLongi($longi = null)
    {
        $this->longi = $longi;
        return $this;
    }
    /**
     * Get acc value
     * @return int|null
     */
    public function getAcc()
    {
        return $this->acc;
    }
    /**
     * Set acc value
     * @param int $acc
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setAcc($acc = null)
    {
        // validation for constraint: int
        if (!is_null($acc) && !is_numeric($acc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($acc)), __LINE__);
        }
        $this->acc = $acc;
        return $this;
    }
    /**
     * Get com value
     * @return string|null
     */
    public function getCom()
    {
        return $this->com;
    }
    /**
     * Set com value
     * @param string $com
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCom($com = null)
    {
        // validation for constraint: string
        if (!is_null($com) && !is_string($com)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($com)), __LINE__);
        }
        $this->com = $com;
        return $this;
    }
    /**
     * Get photo value
     * @return string|null
     */
    public function getPhoto()
    {
        return $this->photo;
    }
    /**
     * Set photo value
     * @param string $photo
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setPhoto($photo = null)
    {
        // validation for constraint: string
        if (!is_null($photo) && !is_string($photo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($photo)), __LINE__);
        }
        $this->photo = $photo;
        return $this;
    }
    /**
     * Get groupDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGroupDescription()
    {
        return isset($this->groupDescription) ? $this->groupDescription : null;
    }
    /**
     * Set groupDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $groupDescription
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setGroupDescription($groupDescription = null)
    {
        // validation for constraint: string
        if (!is_null($groupDescription) && !is_string($groupDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($groupDescription)), __LINE__);
        }
        if (is_null($groupDescription) || (is_array($groupDescription) && empty($groupDescription))) {
            unset($this->groupDescription);
        } else {
            $this->groupDescription = $groupDescription;
        }
        return $this;
    }
    /**
     * Get distance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getDistance()
    {
        return isset($this->distance) ? $this->distance : null;
    }
    /**
     * Set distance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $distance
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setDistance($distance = null)
    {
        if (is_null($distance) || (is_array($distance) && empty($distance))) {
            unset($this->distance);
        } else {
            $this->distance = $distance;
        }
        return $this;
    }
    /**
     * Get checkInLoc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCheckInLoc()
    {
        return isset($this->checkInLoc) ? $this->checkInLoc : null;
    }
    /**
     * Set checkInLoc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $checkInLoc
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCheckInLoc($checkInLoc = null)
    {
        // validation for constraint: string
        if (!is_null($checkInLoc) && !is_string($checkInLoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($checkInLoc)), __LINE__);
        }
        if (is_null($checkInLoc) || (is_array($checkInLoc) && empty($checkInLoc))) {
            unset($this->checkInLoc);
        } else {
            $this->checkInLoc = $checkInLoc;
        }
        return $this;
    }
    /**
     * Get checkInLat value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getCheckInLat()
    {
        return isset($this->checkInLat) ? $this->checkInLat : null;
    }
    /**
     * Set checkInLat value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $checkInLat
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCheckInLat($checkInLat = null)
    {
        if (is_null($checkInLat) || (is_array($checkInLat) && empty($checkInLat))) {
            unset($this->checkInLat);
        } else {
            $this->checkInLat = $checkInLat;
        }
        return $this;
    }
    /**
     * Get checkInLong value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getCheckInLong()
    {
        return isset($this->checkInLong) ? $this->checkInLong : null;
    }
    /**
     * Set checkInLong value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $checkInLong
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCheckInLong($checkInLong = null)
    {
        if (is_null($checkInLong) || (is_array($checkInLong) && empty($checkInLong))) {
            unset($this->checkInLong);
        } else {
            $this->checkInLong = $checkInLong;
        }
        return $this;
    }
    /**
     * Get checkInTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCheckInTime()
    {
        return isset($this->checkInTime) ? $this->checkInTime : null;
    }
    /**
     * Set checkInTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $checkInTime
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCheckInTime($checkInTime = null)
    {
        // validation for constraint: string
        if (!is_null($checkInTime) && !is_string($checkInTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($checkInTime)), __LINE__);
        }
        if (is_null($checkInTime) || (is_array($checkInTime) && empty($checkInTime))) {
            unset($this->checkInTime);
        } else {
            $this->checkInTime = $checkInTime;
        }
        return $this;
    }
    /**
     * Get checkInPositionCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCheckInPositionCode()
    {
        return isset($this->checkInPositionCode) ? $this->checkInPositionCode : null;
    }
    /**
     * Set checkInPositionCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $checkInPositionCode
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public function setCheckInPositionCode($checkInPositionCode = null)
    {
        // validation for constraint: int
        if (!is_null($checkInPositionCode) && !is_numeric($checkInPositionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($checkInPositionCode)), __LINE__);
        }
        if (is_null($checkInPositionCode) || (is_array($checkInPositionCode) && empty($checkInPositionCode))) {
            unset($this->checkInPositionCode);
        } else {
            $this->checkInPositionCode = $checkInPositionCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Fitem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
