<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for flowDetails StructType
 * @subpackage Structs
 */
class FlowDetails extends AbstractStructBase
{
    /**
     * The flowDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\FlowDetail[]
     */
    public $flowDetail;
    /**
     * Constructor method for flowDetails
     * @uses FlowDetails::setFlowDetail()
     * @param \QCC\CampusM\CloudService\StructType\FlowDetail[] $flowDetail
     */
    public function __construct(array $flowDetail = array())
    {
        $this
            ->setFlowDetail($flowDetail);
    }
    /**
     * Get flowDetail value
     * @return \QCC\CampusM\CloudService\StructType\FlowDetail[]|null
     */
    public function getFlowDetail()
    {
        return $this->flowDetail;
    }
    /**
     * Set flowDetail value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowDetail[] $flowDetail
     * @return \QCC\CampusM\CloudService\StructType\FlowDetails
     */
    public function setFlowDetail(array $flowDetail = array())
    {
        foreach ($flowDetail as $flowDetailsFlowDetailItem) {
            // validation for constraint: itemType
            if (!$flowDetailsFlowDetailItem instanceof \QCC\CampusM\CloudService\StructType\FlowDetail) {
                throw new \InvalidArgumentException(sprintf('The flowDetail property can only contain items of \QCC\CampusM\CloudService\StructType\FlowDetail, "%s" given', is_object($flowDetailsFlowDetailItem) ? get_class($flowDetailsFlowDetailItem) : gettype($flowDetailsFlowDetailItem)), __LINE__);
            }
        }
        $this->flowDetail = $flowDetail;
        return $this;
    }
    /**
     * Add item to flowDetail value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowDetail $item
     * @return \QCC\CampusM\CloudService\StructType\FlowDetails
     */
    public function addToFlowDetail(\QCC\CampusM\CloudService\StructType\FlowDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\FlowDetail) {
            throw new \InvalidArgumentException(sprintf('The flowDetail property can only contain items of \QCC\CampusM\CloudService\StructType\FlowDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->flowDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FlowDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
