<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for flowService StructType
 * @subpackage Structs
 */
class FlowService extends AbstractStructBase
{
    /**
     * The keyValue
     * @var string
     */
    public $keyValue;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The requireAddress
     * @var string
     */
    public $requireAddress;
    /**
     * The requirePostcode
     * @var string
     */
    public $requirePostcode;
    /**
     * The requireEmail
     * @var string
     */
    public $requireEmail;
    /**
     * The defaultIsOn
     * @var string
     */
    public $defaultIsOn;
    /**
     * The serviceUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serviceUrl;
    /**
     * The httpUsername
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $httpUsername;
    /**
     * The httpPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $httpPassword;
    /**
     * The captureField
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $captureField;
    /**
     * Constructor method for flowService
     * @uses FlowService::setKeyValue()
     * @uses FlowService::setDescription()
     * @uses FlowService::setRequireAddress()
     * @uses FlowService::setRequirePostcode()
     * @uses FlowService::setRequireEmail()
     * @uses FlowService::setDefaultIsOn()
     * @uses FlowService::setServiceUrl()
     * @uses FlowService::setHttpUsername()
     * @uses FlowService::setHttpPassword()
     * @uses FlowService::setCaptureField()
     * @param string $keyValue
     * @param string $description
     * @param string $requireAddress
     * @param string $requirePostcode
     * @param string $requireEmail
     * @param string $defaultIsOn
     * @param string $serviceUrl
     * @param string $httpUsername
     * @param string $httpPassword
     * @param string $captureField
     */
    public function __construct($keyValue = null, $description = null, $requireAddress = null, $requirePostcode = null, $requireEmail = null, $defaultIsOn = null, $serviceUrl = null, $httpUsername = null, $httpPassword = null, $captureField = null)
    {
        $this
            ->setKeyValue($keyValue)
            ->setDescription($description)
            ->setRequireAddress($requireAddress)
            ->setRequirePostcode($requirePostcode)
            ->setRequireEmail($requireEmail)
            ->setDefaultIsOn($defaultIsOn)
            ->setServiceUrl($serviceUrl)
            ->setHttpUsername($httpUsername)
            ->setHttpPassword($httpPassword)
            ->setCaptureField($captureField);
    }
    /**
     * Get keyValue value
     * @return string|null
     */
    public function getKeyValue()
    {
        return $this->keyValue;
    }
    /**
     * Set keyValue value
     * @param string $keyValue
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setKeyValue($keyValue = null)
    {
        // validation for constraint: string
        if (!is_null($keyValue) && !is_string($keyValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($keyValue)), __LINE__);
        }
        $this->keyValue = $keyValue;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get requireAddress value
     * @return string|null
     */
    public function getRequireAddress()
    {
        return $this->requireAddress;
    }
    /**
     * Set requireAddress value
     * @param string $requireAddress
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setRequireAddress($requireAddress = null)
    {
        // validation for constraint: string
        if (!is_null($requireAddress) && !is_string($requireAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requireAddress)), __LINE__);
        }
        $this->requireAddress = $requireAddress;
        return $this;
    }
    /**
     * Get requirePostcode value
     * @return string|null
     */
    public function getRequirePostcode()
    {
        return $this->requirePostcode;
    }
    /**
     * Set requirePostcode value
     * @param string $requirePostcode
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setRequirePostcode($requirePostcode = null)
    {
        // validation for constraint: string
        if (!is_null($requirePostcode) && !is_string($requirePostcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requirePostcode)), __LINE__);
        }
        $this->requirePostcode = $requirePostcode;
        return $this;
    }
    /**
     * Get requireEmail value
     * @return string|null
     */
    public function getRequireEmail()
    {
        return $this->requireEmail;
    }
    /**
     * Set requireEmail value
     * @param string $requireEmail
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setRequireEmail($requireEmail = null)
    {
        // validation for constraint: string
        if (!is_null($requireEmail) && !is_string($requireEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requireEmail)), __LINE__);
        }
        $this->requireEmail = $requireEmail;
        return $this;
    }
    /**
     * Get defaultIsOn value
     * @return string|null
     */
    public function getDefaultIsOn()
    {
        return $this->defaultIsOn;
    }
    /**
     * Set defaultIsOn value
     * @param string $defaultIsOn
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setDefaultIsOn($defaultIsOn = null)
    {
        // validation for constraint: string
        if (!is_null($defaultIsOn) && !is_string($defaultIsOn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($defaultIsOn)), __LINE__);
        }
        $this->defaultIsOn = $defaultIsOn;
        return $this;
    }
    /**
     * Get serviceUrl value
     * @return string|null
     */
    public function getServiceUrl()
    {
        return $this->serviceUrl;
    }
    /**
     * Set serviceUrl value
     * @param string $serviceUrl
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setServiceUrl($serviceUrl = null)
    {
        // validation for constraint: string
        if (!is_null($serviceUrl) && !is_string($serviceUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceUrl)), __LINE__);
        }
        $this->serviceUrl = $serviceUrl;
        return $this;
    }
    /**
     * Get httpUsername value
     * @return string|null
     */
    public function getHttpUsername()
    {
        return $this->httpUsername;
    }
    /**
     * Set httpUsername value
     * @param string $httpUsername
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setHttpUsername($httpUsername = null)
    {
        // validation for constraint: string
        if (!is_null($httpUsername) && !is_string($httpUsername)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($httpUsername)), __LINE__);
        }
        $this->httpUsername = $httpUsername;
        return $this;
    }
    /**
     * Get httpPassword value
     * @return string|null
     */
    public function getHttpPassword()
    {
        return $this->httpPassword;
    }
    /**
     * Set httpPassword value
     * @param string $httpPassword
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setHttpPassword($httpPassword = null)
    {
        // validation for constraint: string
        if (!is_null($httpPassword) && !is_string($httpPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($httpPassword)), __LINE__);
        }
        $this->httpPassword = $httpPassword;
        return $this;
    }
    /**
     * Get captureField value
     * @return string|null
     */
    public function getCaptureField()
    {
        return $this->captureField;
    }
    /**
     * Set captureField value
     * @param string $captureField
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public function setCaptureField($captureField = null)
    {
        // validation for constraint: string
        if (!is_null($captureField) && !is_string($captureField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($captureField)), __LINE__);
        }
        $this->captureField = $captureField;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FlowService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
