<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for flowServices StructType
 * @subpackage Structs
 */
class FlowServices extends AbstractStructBase
{
    /**
     * The flowService
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\FlowService[]
     */
    public $flowService;
    /**
     * Constructor method for flowServices
     * @uses FlowServices::setFlowService()
     * @param \QCC\CampusM\CloudService\StructType\FlowService[] $flowService
     */
    public function __construct(array $flowService = array())
    {
        $this
            ->setFlowService($flowService);
    }
    /**
     * Get flowService value
     * @return \QCC\CampusM\CloudService\StructType\FlowService[]|null
     */
    public function getFlowService()
    {
        return $this->flowService;
    }
    /**
     * Set flowService value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowService[] $flowService
     * @return \QCC\CampusM\CloudService\StructType\FlowServices
     */
    public function setFlowService(array $flowService = array())
    {
        foreach ($flowService as $flowServicesFlowServiceItem) {
            // validation for constraint: itemType
            if (!$flowServicesFlowServiceItem instanceof \QCC\CampusM\CloudService\StructType\FlowService) {
                throw new \InvalidArgumentException(sprintf('The flowService property can only contain items of \QCC\CampusM\CloudService\StructType\FlowService, "%s" given', is_object($flowServicesFlowServiceItem) ? get_class($flowServicesFlowServiceItem) : gettype($flowServicesFlowServiceItem)), __LINE__);
            }
        }
        $this->flowService = $flowService;
        return $this;
    }
    /**
     * Add item to flowService value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowService $item
     * @return \QCC\CampusM\CloudService\StructType\FlowServices
     */
    public function addToFlowService(\QCC\CampusM\CloudService\StructType\FlowService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\FlowService) {
            throw new \InvalidArgumentException(sprintf('The flowService property can only contain items of \QCC\CampusM\CloudService\StructType\FlowService, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->flowService[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FlowServices
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
