<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for flowStrings StructType
 * @subpackage Structs
 */
class FlowStrings extends AbstractStructBase
{
    /**
     * The flowString
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\FlowString[]
     */
    public $flowString;
    /**
     * Constructor method for flowStrings
     * @uses FlowStrings::setFlowString()
     * @param \QCC\CampusM\CloudService\StructType\FlowString[] $flowString
     */
    public function __construct(array $flowString = array())
    {
        $this
            ->setFlowString($flowString);
    }
    /**
     * Get flowString value
     * @return \QCC\CampusM\CloudService\StructType\FlowString[]|null
     */
    public function getFlowString()
    {
        return $this->flowString;
    }
    /**
     * Set flowString value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowString[] $flowString
     * @return \QCC\CampusM\CloudService\StructType\FlowStrings
     */
    public function setFlowString(array $flowString = array())
    {
        foreach ($flowString as $flowStringsFlowStringItem) {
            // validation for constraint: itemType
            if (!$flowStringsFlowStringItem instanceof \QCC\CampusM\CloudService\StructType\FlowString) {
                throw new \InvalidArgumentException(sprintf('The flowString property can only contain items of \QCC\CampusM\CloudService\StructType\FlowString, "%s" given', is_object($flowStringsFlowStringItem) ? get_class($flowStringsFlowStringItem) : gettype($flowStringsFlowStringItem)), __LINE__);
            }
        }
        $this->flowString = $flowString;
        return $this;
    }
    /**
     * Add item to flowString value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FlowString $item
     * @return \QCC\CampusM\CloudService\StructType\FlowStrings
     */
    public function addToFlowString(\QCC\CampusM\CloudService\StructType\FlowString $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\FlowString) {
            throw new \InvalidArgumentException(sprintf('The flowString property can only contain items of \QCC\CampusM\CloudService\StructType\FlowString, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->flowString[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FlowStrings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
