<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for friendGroups StructType
 * @subpackage Structs
 */
class FriendGroups extends AbstractStructBase
{
    /**
     * The friendGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\FriendGroup[]
     */
    public $friendGroup;
    /**
     * Constructor method for friendGroups
     * @uses FriendGroups::setFriendGroup()
     * @param \QCC\CampusM\CloudService\StructType\FriendGroup[] $friendGroup
     */
    public function __construct(array $friendGroup = array())
    {
        $this
            ->setFriendGroup($friendGroup);
    }
    /**
     * Get friendGroup value
     * @return \QCC\CampusM\CloudService\StructType\FriendGroup[]|null
     */
    public function getFriendGroup()
    {
        return $this->friendGroup;
    }
    /**
     * Set friendGroup value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FriendGroup[] $friendGroup
     * @return \QCC\CampusM\CloudService\StructType\FriendGroups
     */
    public function setFriendGroup(array $friendGroup = array())
    {
        foreach ($friendGroup as $friendGroupsFriendGroupItem) {
            // validation for constraint: itemType
            if (!$friendGroupsFriendGroupItem instanceof \QCC\CampusM\CloudService\StructType\FriendGroup) {
                throw new \InvalidArgumentException(sprintf('The friendGroup property can only contain items of \QCC\CampusM\CloudService\StructType\FriendGroup, "%s" given', is_object($friendGroupsFriendGroupItem) ? get_class($friendGroupsFriendGroupItem) : gettype($friendGroupsFriendGroupItem)), __LINE__);
            }
        }
        $this->friendGroup = $friendGroup;
        return $this;
    }
    /**
     * Add item to friendGroup value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\FriendGroup $item
     * @return \QCC\CampusM\CloudService\StructType\FriendGroups
     */
    public function addToFriendGroup(\QCC\CampusM\CloudService\StructType\FriendGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\FriendGroup) {
            throw new \InvalidArgumentException(sprintf('The friendGroup property can only contain items of \QCC\CampusM\CloudService\StructType\FriendGroup, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->friendGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\FriendGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
