<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for friends StructType
 * @subpackage Structs
 */
class Friends extends AbstractStructBase
{
    /**
     * The fitem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Fitem[]
     */
    public $fitem;
    /**
     * Constructor method for friends
     * @uses Friends::setFitem()
     * @param \QCC\CampusM\CloudService\StructType\Fitem[] $fitem
     */
    public function __construct(array $fitem = array())
    {
        $this
            ->setFitem($fitem);
    }
    /**
     * Get fitem value
     * @return \QCC\CampusM\CloudService\StructType\Fitem[]|null
     */
    public function getFitem()
    {
        return $this->fitem;
    }
    /**
     * Set fitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Fitem[] $fitem
     * @return \QCC\CampusM\CloudService\StructType\Friends
     */
    public function setFitem(array $fitem = array())
    {
        foreach ($fitem as $friendsFitemItem) {
            // validation for constraint: itemType
            if (!$friendsFitemItem instanceof \QCC\CampusM\CloudService\StructType\Fitem) {
                throw new \InvalidArgumentException(sprintf('The fitem property can only contain items of \QCC\CampusM\CloudService\StructType\Fitem, "%s" given', is_object($friendsFitemItem) ? get_class($friendsFitemItem) : gettype($friendsFitemItem)), __LINE__);
            }
        }
        $this->fitem = $fitem;
        return $this;
    }
    /**
     * Add item to fitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Fitem $item
     * @return \QCC\CampusM\CloudService\StructType\Friends
     */
    public function addToFitem(\QCC\CampusM\CloudService\StructType\Fitem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Fitem) {
            throw new \InvalidArgumentException(sprintf('The fitem property can only contain items of \QCC\CampusM\CloudService\StructType\Fitem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->fitem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Friends
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
