<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for headerColors StructType
 * @subpackage Structs
 */
class HeaderColors extends AbstractStructBase
{
    /**
     * The headerBackgroundStartColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $headerBackgroundStartColor;
    /**
     * The headerBackgroundMidColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $headerBackgroundMidColor;
    /**
     * The headerBackgroundEndColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $headerBackgroundEndColor;
    /**
     * The headerBackgroundDirection
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $headerBackgroundDirection;
    /**
     * The headerSepColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $headerSepColor;
    /**
     * The backImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $backImage;
    /**
     * The headerTextColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $headerTextColor;
    /**
     * The iosColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $iosColor;
    /**
     * Constructor method for headerColors
     * @uses HeaderColors::setHeaderBackgroundStartColor()
     * @uses HeaderColors::setHeaderBackgroundMidColor()
     * @uses HeaderColors::setHeaderBackgroundEndColor()
     * @uses HeaderColors::setHeaderBackgroundDirection()
     * @uses HeaderColors::setHeaderSepColor()
     * @uses HeaderColors::setBackImage()
     * @uses HeaderColors::setHeaderTextColor()
     * @uses HeaderColors::setIosColor()
     * @param string $headerBackgroundStartColor
     * @param string $headerBackgroundMidColor
     * @param string $headerBackgroundEndColor
     * @param int $headerBackgroundDirection
     * @param string $headerSepColor
     * @param string $backImage
     * @param string $headerTextColor
     * @param string $iosColor
     */
    public function __construct($headerBackgroundStartColor = null, $headerBackgroundMidColor = null, $headerBackgroundEndColor = null, $headerBackgroundDirection = null, $headerSepColor = null, $backImage = null, $headerTextColor = null, $iosColor = null)
    {
        $this
            ->setHeaderBackgroundStartColor($headerBackgroundStartColor)
            ->setHeaderBackgroundMidColor($headerBackgroundMidColor)
            ->setHeaderBackgroundEndColor($headerBackgroundEndColor)
            ->setHeaderBackgroundDirection($headerBackgroundDirection)
            ->setHeaderSepColor($headerSepColor)
            ->setBackImage($backImage)
            ->setHeaderTextColor($headerTextColor)
            ->setIosColor($iosColor);
    }
    /**
     * Get headerBackgroundStartColor value
     * @return string|null
     */
    public function getHeaderBackgroundStartColor()
    {
        return $this->headerBackgroundStartColor;
    }
    /**
     * Set headerBackgroundStartColor value
     * @param string $headerBackgroundStartColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderBackgroundStartColor($headerBackgroundStartColor = null)
    {
        // validation for constraint: string
        if (!is_null($headerBackgroundStartColor) && !is_string($headerBackgroundStartColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerBackgroundStartColor)), __LINE__);
        }
        $this->headerBackgroundStartColor = $headerBackgroundStartColor;
        return $this;
    }
    /**
     * Get headerBackgroundMidColor value
     * @return string|null
     */
    public function getHeaderBackgroundMidColor()
    {
        return $this->headerBackgroundMidColor;
    }
    /**
     * Set headerBackgroundMidColor value
     * @param string $headerBackgroundMidColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderBackgroundMidColor($headerBackgroundMidColor = null)
    {
        // validation for constraint: string
        if (!is_null($headerBackgroundMidColor) && !is_string($headerBackgroundMidColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerBackgroundMidColor)), __LINE__);
        }
        $this->headerBackgroundMidColor = $headerBackgroundMidColor;
        return $this;
    }
    /**
     * Get headerBackgroundEndColor value
     * @return string|null
     */
    public function getHeaderBackgroundEndColor()
    {
        return $this->headerBackgroundEndColor;
    }
    /**
     * Set headerBackgroundEndColor value
     * @param string $headerBackgroundEndColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderBackgroundEndColor($headerBackgroundEndColor = null)
    {
        // validation for constraint: string
        if (!is_null($headerBackgroundEndColor) && !is_string($headerBackgroundEndColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerBackgroundEndColor)), __LINE__);
        }
        $this->headerBackgroundEndColor = $headerBackgroundEndColor;
        return $this;
    }
    /**
     * Get headerBackgroundDirection value
     * @return int|null
     */
    public function getHeaderBackgroundDirection()
    {
        return $this->headerBackgroundDirection;
    }
    /**
     * Set headerBackgroundDirection value
     * @param int $headerBackgroundDirection
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderBackgroundDirection($headerBackgroundDirection = null)
    {
        // validation for constraint: int
        if (!is_null($headerBackgroundDirection) && !is_numeric($headerBackgroundDirection)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($headerBackgroundDirection)), __LINE__);
        }
        $this->headerBackgroundDirection = $headerBackgroundDirection;
        return $this;
    }
    /**
     * Get headerSepColor value
     * @return string|null
     */
    public function getHeaderSepColor()
    {
        return $this->headerSepColor;
    }
    /**
     * Set headerSepColor value
     * @param string $headerSepColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderSepColor($headerSepColor = null)
    {
        // validation for constraint: string
        if (!is_null($headerSepColor) && !is_string($headerSepColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerSepColor)), __LINE__);
        }
        $this->headerSepColor = $headerSepColor;
        return $this;
    }
    /**
     * Get backImage value
     * @return string|null
     */
    public function getBackImage()
    {
        return $this->backImage;
    }
    /**
     * Set backImage value
     * @param string $backImage
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setBackImage($backImage = null)
    {
        // validation for constraint: string
        if (!is_null($backImage) && !is_string($backImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($backImage)), __LINE__);
        }
        $this->backImage = $backImage;
        return $this;
    }
    /**
     * Get headerTextColor value
     * @return string|null
     */
    public function getHeaderTextColor()
    {
        return $this->headerTextColor;
    }
    /**
     * Set headerTextColor value
     * @param string $headerTextColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setHeaderTextColor($headerTextColor = null)
    {
        // validation for constraint: string
        if (!is_null($headerTextColor) && !is_string($headerTextColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($headerTextColor)), __LINE__);
        }
        $this->headerTextColor = $headerTextColor;
        return $this;
    }
    /**
     * Get iosColor value
     * @return string|null
     */
    public function getIosColor()
    {
        return $this->iosColor;
    }
    /**
     * Set iosColor value
     * @param string $iosColor
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public function setIosColor($iosColor = null)
    {
        // validation for constraint: string
        if (!is_null($iosColor) && !is_string($iosColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iosColor)), __LINE__);
        }
        $this->iosColor = $iosColor;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
