<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for homePageNewsItem StructType
 * @subpackage Structs
 */
class HomePageNewsItem extends AbstractStructBase
{
    /**
     * The orgCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $orgCode;
    /**
     * The newsId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $newsId;
    /**
     * The message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The dateTimeUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateTimeUpdated;
    /**
     * The sortOrder
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sortOrder;
    /**
     * The rssLink
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rssLink;
    /**
     * Constructor method for homePageNewsItem
     * @uses HomePageNewsItem::setOrgCode()
     * @uses HomePageNewsItem::setNewsId()
     * @uses HomePageNewsItem::setMessage()
     * @uses HomePageNewsItem::setDateTimeUpdated()
     * @uses HomePageNewsItem::setSortOrder()
     * @uses HomePageNewsItem::setRssLink()
     * @param int $orgCode
     * @param int $newsId
     * @param string $message
     * @param string $dateTimeUpdated
     * @param int $sortOrder
     * @param string $rssLink
     */
    public function __construct($orgCode = null, $newsId = null, $message = null, $dateTimeUpdated = null, $sortOrder = null, $rssLink = null)
    {
        $this
            ->setOrgCode($orgCode)
            ->setNewsId($newsId)
            ->setMessage($message)
            ->setDateTimeUpdated($dateTimeUpdated)
            ->setSortOrder($sortOrder)
            ->setRssLink($rssLink);
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get newsId value
     * @return int|null
     */
    public function getNewsId()
    {
        return $this->newsId;
    }
    /**
     * Set newsId value
     * @param int $newsId
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setNewsId($newsId = null)
    {
        // validation for constraint: int
        if (!is_null($newsId) && !is_numeric($newsId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($newsId)), __LINE__);
        }
        $this->newsId = $newsId;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get dateTimeUpdated value
     * @return string|null
     */
    public function getDateTimeUpdated()
    {
        return $this->dateTimeUpdated;
    }
    /**
     * Set dateTimeUpdated value
     * @param string $dateTimeUpdated
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setDateTimeUpdated($dateTimeUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($dateTimeUpdated) && !is_string($dateTimeUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateTimeUpdated)), __LINE__);
        }
        $this->dateTimeUpdated = $dateTimeUpdated;
        return $this;
    }
    /**
     * Get sortOrder value
     * @return int|null
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }
    /**
     * Set sortOrder value
     * @param int $sortOrder
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setSortOrder($sortOrder = null)
    {
        // validation for constraint: int
        if (!is_null($sortOrder) && !is_numeric($sortOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sortOrder)), __LINE__);
        }
        $this->sortOrder = $sortOrder;
        return $this;
    }
    /**
     * Get rssLink value
     * @return string|null
     */
    public function getRssLink()
    {
        return $this->rssLink;
    }
    /**
     * Set rssLink value
     * @param string $rssLink
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public function setRssLink($rssLink = null)
    {
        // validation for constraint: string
        if (!is_null($rssLink) && !is_string($rssLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rssLink)), __LINE__);
        }
        $this->rssLink = $rssLink;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\HomePageNewsItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
