<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for insightCaptureServiceRequest StructType
 * @subpackage Structs
 */
class InsightCaptureServiceRequest extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The org
     * @var int
     */
    public $org;
    /**
     * The pl
     * @var string
     */
    public $pl;
    /**
     * The os
     * @var string
     */
    public $os;
    /**
     * The mo
     * @var string
     */
    public $mo;
    /**
     * The ps
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Ps
     */
    public $ps;
    /**
     * Constructor method for insightCaptureServiceRequest
     * @uses InsightCaptureServiceRequest::setId()
     * @uses InsightCaptureServiceRequest::setOrg()
     * @uses InsightCaptureServiceRequest::setPl()
     * @uses InsightCaptureServiceRequest::setOs()
     * @uses InsightCaptureServiceRequest::setMo()
     * @uses InsightCaptureServiceRequest::setPs()
     * @param int $id
     * @param int $org
     * @param string $pl
     * @param string $os
     * @param string $mo
     * @param \QCC\CampusM\CloudService\StructType\Ps $ps
     */
    public function __construct($id = null, $org = null, $pl = null, $os = null, $mo = null, \QCC\CampusM\CloudService\StructType\Ps $ps = null)
    {
        $this
            ->setId($id)
            ->setOrg($org)
            ->setPl($pl)
            ->setOs($os)
            ->setMo($mo)
            ->setPs($ps);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get org value
     * @return int|null
     */
    public function getOrg()
    {
        return $this->org;
    }
    /**
     * Set org value
     * @param int $org
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setOrg($org = null)
    {
        // validation for constraint: int
        if (!is_null($org) && !is_numeric($org)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($org)), __LINE__);
        }
        $this->org = $org;
        return $this;
    }
    /**
     * Get pl value
     * @return string|null
     */
    public function getPl()
    {
        return $this->pl;
    }
    /**
     * Set pl value
     * @param string $pl
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setPl($pl = null)
    {
        // validation for constraint: string
        if (!is_null($pl) && !is_string($pl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pl)), __LINE__);
        }
        $this->pl = $pl;
        return $this;
    }
    /**
     * Get os value
     * @return string|null
     */
    public function getOs()
    {
        return $this->os;
    }
    /**
     * Set os value
     * @param string $os
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setOs($os = null)
    {
        // validation for constraint: string
        if (!is_null($os) && !is_string($os)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($os)), __LINE__);
        }
        $this->os = $os;
        return $this;
    }
    /**
     * Get mo value
     * @return string|null
     */
    public function getMo()
    {
        return $this->mo;
    }
    /**
     * Set mo value
     * @param string $mo
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setMo($mo = null)
    {
        // validation for constraint: string
        if (!is_null($mo) && !is_string($mo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mo)), __LINE__);
        }
        $this->mo = $mo;
        return $this;
    }
    /**
     * Get ps value
     * @return \QCC\CampusM\CloudService\StructType\Ps|null
     */
    public function getPs()
    {
        return $this->ps;
    }
    /**
     * Set ps value
     * @param \QCC\CampusM\CloudService\StructType\Ps $ps
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public function setPs(\QCC\CampusM\CloudService\StructType\Ps $ps = null)
    {
        $this->ps = $ps;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\InsightCaptureServiceRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
