<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for item StructType
 * @subpackage Structs
 */
class Item extends AbstractStructBase
{
    /**
     * The lookupCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lookupCode;
    /**
     * The lookupValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lookupValue;
    /**
     * Constructor method for item
     * @uses Item::setLookupCode()
     * @uses Item::setLookupValue()
     * @param string $lookupCode
     * @param string $lookupValue
     */
    public function __construct($lookupCode = null, $lookupValue = null)
    {
        $this
            ->setLookupCode($lookupCode)
            ->setLookupValue($lookupValue);
    }
    /**
     * Get lookupCode value
     * @return string|null
     */
    public function getLookupCode()
    {
        return $this->lookupCode;
    }
    /**
     * Set lookupCode value
     * @param string $lookupCode
     * @return \QCC\CampusM\CloudService\StructType\Item
     */
    public function setLookupCode($lookupCode = null)
    {
        // validation for constraint: string
        if (!is_null($lookupCode) && !is_string($lookupCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lookupCode)), __LINE__);
        }
        $this->lookupCode = $lookupCode;
        return $this;
    }
    /**
     * Get lookupValue value
     * @return string|null
     */
    public function getLookupValue()
    {
        return $this->lookupValue;
    }
    /**
     * Set lookupValue value
     * @param string $lookupValue
     * @return \QCC\CampusM\CloudService\StructType\Item
     */
    public function setLookupValue($lookupValue = null)
    {
        // validation for constraint: string
        if (!is_null($lookupValue) && !is_string($lookupValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lookupValue)), __LINE__);
        }
        $this->lookupValue = $lookupValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Item
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
