<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for javascriptItems StructType
 * @subpackage Structs
 */
class JavascriptItems extends AbstractStructBase
{
    /**
     * The javascriptItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\JavascriptItem[]
     */
    public $javascriptItem;
    /**
     * Constructor method for javascriptItems
     * @uses JavascriptItems::setJavascriptItem()
     * @param \QCC\CampusM\CloudService\StructType\JavascriptItem[] $javascriptItem
     */
    public function __construct(array $javascriptItem = array())
    {
        $this
            ->setJavascriptItem($javascriptItem);
    }
    /**
     * Get javascriptItem value
     * @return \QCC\CampusM\CloudService\StructType\JavascriptItem[]|null
     */
    public function getJavascriptItem()
    {
        return $this->javascriptItem;
    }
    /**
     * Set javascriptItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\JavascriptItem[] $javascriptItem
     * @return \QCC\CampusM\CloudService\StructType\JavascriptItems
     */
    public function setJavascriptItem(array $javascriptItem = array())
    {
        foreach ($javascriptItem as $javascriptItemsJavascriptItemItem) {
            // validation for constraint: itemType
            if (!$javascriptItemsJavascriptItemItem instanceof \QCC\CampusM\CloudService\StructType\JavascriptItem) {
                throw new \InvalidArgumentException(sprintf('The javascriptItem property can only contain items of \QCC\CampusM\CloudService\StructType\JavascriptItem, "%s" given', is_object($javascriptItemsJavascriptItemItem) ? get_class($javascriptItemsJavascriptItemItem) : gettype($javascriptItemsJavascriptItemItem)), __LINE__);
            }
        }
        $this->javascriptItem = $javascriptItem;
        return $this;
    }
    /**
     * Add item to javascriptItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\JavascriptItem $item
     * @return \QCC\CampusM\CloudService\StructType\JavascriptItems
     */
    public function addToJavascriptItem(\QCC\CampusM\CloudService\StructType\JavascriptItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\JavascriptItem) {
            throw new \InvalidArgumentException(sprintf('The javascriptItem property can only contain items of \QCC\CampusM\CloudService\StructType\JavascriptItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->javascriptItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\JavascriptItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
