<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for languageMappings StructType
 * @subpackage Structs
 */
class LanguageMappings extends AbstractStructBase
{
    /**
     * The mapping
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\LanguageMapping[]
     */
    public $mapping;
    /**
     * Constructor method for languageMappings
     * @uses LanguageMappings::setMapping()
     * @param \QCC\CampusM\CloudService\StructType\LanguageMapping[] $mapping
     */
    public function __construct(array $mapping = array())
    {
        $this
            ->setMapping($mapping);
    }
    /**
     * Get mapping value
     * @return \QCC\CampusM\CloudService\StructType\LanguageMapping[]|null
     */
    public function getMapping()
    {
        return $this->mapping;
    }
    /**
     * Set mapping value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\LanguageMapping[] $mapping
     * @return \QCC\CampusM\CloudService\StructType\LanguageMappings
     */
    public function setMapping(array $mapping = array())
    {
        foreach ($mapping as $languageMappingsMappingItem) {
            // validation for constraint: itemType
            if (!$languageMappingsMappingItem instanceof \QCC\CampusM\CloudService\StructType\LanguageMapping) {
                throw new \InvalidArgumentException(sprintf('The mapping property can only contain items of \QCC\CampusM\CloudService\StructType\LanguageMapping, "%s" given', is_object($languageMappingsMappingItem) ? get_class($languageMappingsMappingItem) : gettype($languageMappingsMappingItem)), __LINE__);
            }
        }
        $this->mapping = $mapping;
        return $this;
    }
    /**
     * Add item to mapping value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\LanguageMapping $item
     * @return \QCC\CampusM\CloudService\StructType\LanguageMappings
     */
    public function addToMapping(\QCC\CampusM\CloudService\StructType\LanguageMapping $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\LanguageMapping) {
            throw new \InvalidArgumentException(sprintf('The mapping property can only contain items of \QCC\CampusM\CloudService\StructType\LanguageMapping, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->mapping[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\LanguageMappings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
