<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for languagePack StructType
 * @subpackage Structs
 */
class LanguagePack extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The mappings
     * @var \QCC\CampusM\CloudService\StructType\LanguageMappings
     */
    public $mappings;
    /**
     * Constructor method for languagePack
     * @uses LanguagePack::setId()
     * @uses LanguagePack::setMappings()
     * @param int $id
     * @param \QCC\CampusM\CloudService\StructType\LanguageMappings $mappings
     */
    public function __construct($id = null, \QCC\CampusM\CloudService\StructType\LanguageMappings $mappings = null)
    {
        $this
            ->setId($id)
            ->setMappings($mappings);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \QCC\CampusM\CloudService\StructType\LanguagePack
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get mappings value
     * @return \QCC\CampusM\CloudService\StructType\LanguageMappings|null
     */
    public function getMappings()
    {
        return $this->mappings;
    }
    /**
     * Set mappings value
     * @param \QCC\CampusM\CloudService\StructType\LanguageMappings $mappings
     * @return \QCC\CampusM\CloudService\StructType\LanguagePack
     */
    public function setMappings(\QCC\CampusM\CloudService\StructType\LanguageMappings $mappings = null)
    {
        $this->mappings = $mappings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\LanguagePack
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
