<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listAvailableOrganisationsRequest StructType
 * @subpackage Structs
 */
class ListAvailableOrganisationsRequest extends AbstractStructBase
{
    /**
     * The orgType
     * @var string
     */
    public $orgType;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The locale
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $locale;
    /**
     * Constructor method for listAvailableOrganisationsRequest
     * @uses ListAvailableOrganisationsRequest::setOrgType()
     * @uses ListAvailableOrganisationsRequest::setPassword()
     * @uses ListAvailableOrganisationsRequest::setLocale()
     * @param string $orgType
     * @param string $password
     * @param string $locale
     */
    public function __construct($orgType = null, $password = null, $locale = null)
    {
        $this
            ->setOrgType($orgType)
            ->setPassword($password)
            ->setLocale($locale);
    }
    /**
     * Get orgType value
     * @return string|null
     */
    public function getOrgType()
    {
        return $this->orgType;
    }
    /**
     * Set orgType value
     * @param string $orgType
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableOrganisationsRequest
     */
    public function setOrgType($orgType = null)
    {
        // validation for constraint: string
        if (!is_null($orgType) && !is_string($orgType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orgType)), __LINE__);
        }
        $this->orgType = $orgType;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableOrganisationsRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get locale value
     * @return string|null
     */
    public function getLocale()
    {
        return $this->locale;
    }
    /**
     * Set locale value
     * @param string $locale
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableOrganisationsRequest
     */
    public function setLocale($locale = null)
    {
        // validation for constraint: string
        if (!is_null($locale) && !is_string($locale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locale)), __LINE__);
        }
        $this->locale = $locale;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableOrganisationsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
