<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listAvailableProfilesResponse StructType
 * @subpackage Structs
 */
class ListAvailableProfilesResponse extends AbstractStructBase
{
    /**
     * The icon
     * @var string
     */
    public $icon;
    /**
     * The appName
     * @var string
     */
    public $appName;
    /**
     * The welcomeMessage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $welcomeMessage;
    /**
     * The iosAppStoreUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $iosAppStoreUrl;
    /**
     * The androidMarketplaceUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $androidMarketplaceUrl;
    /**
     * The blackberryWorldUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $blackberryWorldUrl;
    /**
     * The profileGroups
     * @var \QCC\CampusM\CloudService\StructType\ProfileGroups
     */
    public $profileGroups;
    /**
     * The languagePacks
     * @var \QCC\CampusM\CloudService\StructType\LanguagePacks
     */
    public $languagePacks;
    /**
     * The profileTutorials
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\ProfileTutorials
     */
    public $profileTutorials;
    /**
     * The headerColors
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\HeaderColors
     */
    public $headerColors;
    /**
     * The languagePacksLastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $languagePacksLastUpdated;
    /**
     * The profilesLastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $profilesLastUpdated;
    /**
     * Constructor method for listAvailableProfilesResponse
     * @uses ListAvailableProfilesResponse::setIcon()
     * @uses ListAvailableProfilesResponse::setAppName()
     * @uses ListAvailableProfilesResponse::setWelcomeMessage()
     * @uses ListAvailableProfilesResponse::setIosAppStoreUrl()
     * @uses ListAvailableProfilesResponse::setAndroidMarketplaceUrl()
     * @uses ListAvailableProfilesResponse::setBlackberryWorldUrl()
     * @uses ListAvailableProfilesResponse::setProfileGroups()
     * @uses ListAvailableProfilesResponse::setLanguagePacks()
     * @uses ListAvailableProfilesResponse::setProfileTutorials()
     * @uses ListAvailableProfilesResponse::setHeaderColors()
     * @uses ListAvailableProfilesResponse::setLanguagePacksLastUpdated()
     * @uses ListAvailableProfilesResponse::setProfilesLastUpdated()
     * @param string $icon
     * @param string $appName
     * @param string $welcomeMessage
     * @param string $iosAppStoreUrl
     * @param string $androidMarketplaceUrl
     * @param string $blackberryWorldUrl
     * @param \QCC\CampusM\CloudService\StructType\ProfileGroups $profileGroups
     * @param \QCC\CampusM\CloudService\StructType\LanguagePacks $languagePacks
     * @param \QCC\CampusM\CloudService\StructType\ProfileTutorials $profileTutorials
     * @param \QCC\CampusM\CloudService\StructType\HeaderColors $headerColors
     * @param string $languagePacksLastUpdated
     * @param string $profilesLastUpdated
     */
    public function __construct($icon = null, $appName = null, $welcomeMessage = null, $iosAppStoreUrl = null, $androidMarketplaceUrl = null, $blackberryWorldUrl = null, \QCC\CampusM\CloudService\StructType\ProfileGroups $profileGroups = null, \QCC\CampusM\CloudService\StructType\LanguagePacks $languagePacks = null, \QCC\CampusM\CloudService\StructType\ProfileTutorials $profileTutorials = null, \QCC\CampusM\CloudService\StructType\HeaderColors $headerColors = null, $languagePacksLastUpdated = null, $profilesLastUpdated = null)
    {
        $this
            ->setIcon($icon)
            ->setAppName($appName)
            ->setWelcomeMessage($welcomeMessage)
            ->setIosAppStoreUrl($iosAppStoreUrl)
            ->setAndroidMarketplaceUrl($androidMarketplaceUrl)
            ->setBlackberryWorldUrl($blackberryWorldUrl)
            ->setProfileGroups($profileGroups)
            ->setLanguagePacks($languagePacks)
            ->setProfileTutorials($profileTutorials)
            ->setHeaderColors($headerColors)
            ->setLanguagePacksLastUpdated($languagePacksLastUpdated)
            ->setProfilesLastUpdated($profilesLastUpdated);
    }
    /**
     * Get icon value
     * @return string|null
     */
    public function getIcon()
    {
        return $this->icon;
    }
    /**
     * Set icon value
     * @param string $icon
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setIcon($icon = null)
    {
        // validation for constraint: string
        if (!is_null($icon) && !is_string($icon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($icon)), __LINE__);
        }
        $this->icon = $icon;
        return $this;
    }
    /**
     * Get appName value
     * @return string|null
     */
    public function getAppName()
    {
        return $this->appName;
    }
    /**
     * Set appName value
     * @param string $appName
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setAppName($appName = null)
    {
        // validation for constraint: string
        if (!is_null($appName) && !is_string($appName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($appName)), __LINE__);
        }
        $this->appName = $appName;
        return $this;
    }
    /**
     * Get welcomeMessage value
     * @return string|null
     */
    public function getWelcomeMessage()
    {
        return $this->welcomeMessage;
    }
    /**
     * Set welcomeMessage value
     * @param string $welcomeMessage
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setWelcomeMessage($welcomeMessage = null)
    {
        // validation for constraint: string
        if (!is_null($welcomeMessage) && !is_string($welcomeMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($welcomeMessage)), __LINE__);
        }
        $this->welcomeMessage = $welcomeMessage;
        return $this;
    }
    /**
     * Get iosAppStoreUrl value
     * @return string|null
     */
    public function getIosAppStoreUrl()
    {
        return $this->iosAppStoreUrl;
    }
    /**
     * Set iosAppStoreUrl value
     * @param string $iosAppStoreUrl
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setIosAppStoreUrl($iosAppStoreUrl = null)
    {
        // validation for constraint: string
        if (!is_null($iosAppStoreUrl) && !is_string($iosAppStoreUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iosAppStoreUrl)), __LINE__);
        }
        $this->iosAppStoreUrl = $iosAppStoreUrl;
        return $this;
    }
    /**
     * Get androidMarketplaceUrl value
     * @return string|null
     */
    public function getAndroidMarketplaceUrl()
    {
        return $this->androidMarketplaceUrl;
    }
    /**
     * Set androidMarketplaceUrl value
     * @param string $androidMarketplaceUrl
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setAndroidMarketplaceUrl($androidMarketplaceUrl = null)
    {
        // validation for constraint: string
        if (!is_null($androidMarketplaceUrl) && !is_string($androidMarketplaceUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($androidMarketplaceUrl)), __LINE__);
        }
        $this->androidMarketplaceUrl = $androidMarketplaceUrl;
        return $this;
    }
    /**
     * Get blackberryWorldUrl value
     * @return string|null
     */
    public function getBlackberryWorldUrl()
    {
        return $this->blackberryWorldUrl;
    }
    /**
     * Set blackberryWorldUrl value
     * @param string $blackberryWorldUrl
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setBlackberryWorldUrl($blackberryWorldUrl = null)
    {
        // validation for constraint: string
        if (!is_null($blackberryWorldUrl) && !is_string($blackberryWorldUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blackberryWorldUrl)), __LINE__);
        }
        $this->blackberryWorldUrl = $blackberryWorldUrl;
        return $this;
    }
    /**
     * Get profileGroups value
     * @return \QCC\CampusM\CloudService\StructType\ProfileGroups|null
     */
    public function getProfileGroups()
    {
        return $this->profileGroups;
    }
    /**
     * Set profileGroups value
     * @param \QCC\CampusM\CloudService\StructType\ProfileGroups $profileGroups
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setProfileGroups(\QCC\CampusM\CloudService\StructType\ProfileGroups $profileGroups = null)
    {
        $this->profileGroups = $profileGroups;
        return $this;
    }
    /**
     * Get languagePacks value
     * @return \QCC\CampusM\CloudService\StructType\LanguagePacks|null
     */
    public function getLanguagePacks()
    {
        return $this->languagePacks;
    }
    /**
     * Set languagePacks value
     * @param \QCC\CampusM\CloudService\StructType\LanguagePacks $languagePacks
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setLanguagePacks(\QCC\CampusM\CloudService\StructType\LanguagePacks $languagePacks = null)
    {
        $this->languagePacks = $languagePacks;
        return $this;
    }
    /**
     * Get profileTutorials value
     * @return \QCC\CampusM\CloudService\StructType\ProfileTutorials|null
     */
    public function getProfileTutorials()
    {
        return $this->profileTutorials;
    }
    /**
     * Set profileTutorials value
     * @param \QCC\CampusM\CloudService\StructType\ProfileTutorials $profileTutorials
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setProfileTutorials(\QCC\CampusM\CloudService\StructType\ProfileTutorials $profileTutorials = null)
    {
        $this->profileTutorials = $profileTutorials;
        return $this;
    }
    /**
     * Get headerColors value
     * @return \QCC\CampusM\CloudService\StructType\HeaderColors|null
     */
    public function getHeaderColors()
    {
        return $this->headerColors;
    }
    /**
     * Set headerColors value
     * @param \QCC\CampusM\CloudService\StructType\HeaderColors $headerColors
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setHeaderColors(\QCC\CampusM\CloudService\StructType\HeaderColors $headerColors = null)
    {
        $this->headerColors = $headerColors;
        return $this;
    }
    /**
     * Get languagePacksLastUpdated value
     * @return string|null
     */
    public function getLanguagePacksLastUpdated()
    {
        return $this->languagePacksLastUpdated;
    }
    /**
     * Set languagePacksLastUpdated value
     * @param string $languagePacksLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setLanguagePacksLastUpdated($languagePacksLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($languagePacksLastUpdated) && !is_string($languagePacksLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($languagePacksLastUpdated)), __LINE__);
        }
        $this->languagePacksLastUpdated = $languagePacksLastUpdated;
        return $this;
    }
    /**
     * Get profilesLastUpdated value
     * @return string|null
     */
    public function getProfilesLastUpdated()
    {
        return $this->profilesLastUpdated;
    }
    /**
     * Set profilesLastUpdated value
     * @param string $profilesLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public function setProfilesLastUpdated($profilesLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($profilesLastUpdated) && !is_string($profilesLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($profilesLastUpdated)), __LINE__);
        }
        $this->profilesLastUpdated = $profilesLastUpdated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ListAvailableProfilesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
