<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listQuestions StructType
 * @subpackage Structs
 */
class ListQuestions extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The listType
     * @var string
     */
    public $listType;
    /**
     * The vcCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $vcCode;
    /**
     * The feedItemRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $feedItemRef;
    /**
     * The feedGroupRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $feedGroupRef;
    /**
     * The classroomCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $classroomCode;
    /**
     * The grType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $grType;
    /**
     * The grWidth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $grWidth;
    /**
     * The grHeight
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $grHeight;
    /**
     * The grColor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $grColor;
    /**
     * Constructor method for listQuestions
     * @uses ListQuestions::setPersonId()
     * @uses ListQuestions::setPassword()
     * @uses ListQuestions::setListType()
     * @uses ListQuestions::setVcCode()
     * @uses ListQuestions::setFeedItemRef()
     * @uses ListQuestions::setFeedGroupRef()
     * @uses ListQuestions::setClassroomCode()
     * @uses ListQuestions::setGrType()
     * @uses ListQuestions::setGrWidth()
     * @uses ListQuestions::setGrHeight()
     * @uses ListQuestions::setGrColor()
     * @param int $personId
     * @param string $password
     * @param string $listType
     * @param int $vcCode
     * @param string $feedItemRef
     * @param string $feedGroupRef
     * @param int $classroomCode
     * @param string $grType
     * @param int $grWidth
     * @param int $grHeight
     * @param string $grColor
     */
    public function __construct($personId = null, $password = null, $listType = null, $vcCode = null, $feedItemRef = null, $feedGroupRef = null, $classroomCode = null, $grType = null, $grWidth = null, $grHeight = null, $grColor = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setListType($listType)
            ->setVcCode($vcCode)
            ->setFeedItemRef($feedItemRef)
            ->setFeedGroupRef($feedGroupRef)
            ->setClassroomCode($classroomCode)
            ->setGrType($grType)
            ->setGrWidth($grWidth)
            ->setGrHeight($grHeight)
            ->setGrColor($grColor);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get listType value
     * @return string|null
     */
    public function getListType()
    {
        return $this->listType;
    }
    /**
     * Set listType value
     * @param string $listType
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setListType($listType = null)
    {
        // validation for constraint: string
        if (!is_null($listType) && !is_string($listType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($listType)), __LINE__);
        }
        $this->listType = $listType;
        return $this;
    }
    /**
     * Get vcCode value
     * @return int|null
     */
    public function getVcCode()
    {
        return $this->vcCode;
    }
    /**
     * Set vcCode value
     * @param int $vcCode
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setVcCode($vcCode = null)
    {
        // validation for constraint: int
        if (!is_null($vcCode) && !is_numeric($vcCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vcCode)), __LINE__);
        }
        $this->vcCode = $vcCode;
        return $this;
    }
    /**
     * Get feedItemRef value
     * @return string|null
     */
    public function getFeedItemRef()
    {
        return $this->feedItemRef;
    }
    /**
     * Set feedItemRef value
     * @param string $feedItemRef
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setFeedItemRef($feedItemRef = null)
    {
        // validation for constraint: string
        if (!is_null($feedItemRef) && !is_string($feedItemRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($feedItemRef)), __LINE__);
        }
        $this->feedItemRef = $feedItemRef;
        return $this;
    }
    /**
     * Get feedGroupRef value
     * @return string|null
     */
    public function getFeedGroupRef()
    {
        return $this->feedGroupRef;
    }
    /**
     * Set feedGroupRef value
     * @param string $feedGroupRef
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setFeedGroupRef($feedGroupRef = null)
    {
        // validation for constraint: string
        if (!is_null($feedGroupRef) && !is_string($feedGroupRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($feedGroupRef)), __LINE__);
        }
        $this->feedGroupRef = $feedGroupRef;
        return $this;
    }
    /**
     * Get classroomCode value
     * @return int|null
     */
    public function getClassroomCode()
    {
        return $this->classroomCode;
    }
    /**
     * Set classroomCode value
     * @param int $classroomCode
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setClassroomCode($classroomCode = null)
    {
        // validation for constraint: int
        if (!is_null($classroomCode) && !is_numeric($classroomCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($classroomCode)), __LINE__);
        }
        $this->classroomCode = $classroomCode;
        return $this;
    }
    /**
     * Get grType value
     * @return string|null
     */
    public function getGrType()
    {
        return $this->grType;
    }
    /**
     * Set grType value
     * @param string $grType
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setGrType($grType = null)
    {
        // validation for constraint: string
        if (!is_null($grType) && !is_string($grType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($grType)), __LINE__);
        }
        $this->grType = $grType;
        return $this;
    }
    /**
     * Get grWidth value
     * @return int|null
     */
    public function getGrWidth()
    {
        return $this->grWidth;
    }
    /**
     * Set grWidth value
     * @param int $grWidth
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setGrWidth($grWidth = null)
    {
        // validation for constraint: int
        if (!is_null($grWidth) && !is_numeric($grWidth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($grWidth)), __LINE__);
        }
        $this->grWidth = $grWidth;
        return $this;
    }
    /**
     * Get grHeight value
     * @return int|null
     */
    public function getGrHeight()
    {
        return $this->grHeight;
    }
    /**
     * Set grHeight value
     * @param int $grHeight
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setGrHeight($grHeight = null)
    {
        // validation for constraint: int
        if (!is_null($grHeight) && !is_numeric($grHeight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($grHeight)), __LINE__);
        }
        $this->grHeight = $grHeight;
        return $this;
    }
    /**
     * Get grColor value
     * @return string|null
     */
    public function getGrColor()
    {
        return $this->grColor;
    }
    /**
     * Set grColor value
     * @param string $grColor
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public function setGrColor($grColor = null)
    {
        // validation for constraint: string
        if (!is_null($grColor) && !is_string($grColor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($grColor)), __LINE__);
        }
        $this->grColor = $grColor;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ListQuestions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
