<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for litem StructType
 * @subpackage Structs
 */
class Litem extends AbstractStructBase
{
    /**
     * The code
     * @var int
     */
    public $code;
    /**
     * The desc
     * @var string
     */
    public $desc;
    /**
     * The descText
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $descText;
    /**
     * The order
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $order;
    /**
     * The img
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $img;
    /**
     * The upd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $upd;
    /**
     * The realTimeData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $realTimeData;
    /**
     * The realTimeServiceName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $realTimeServiceName;
    /**
     * The positions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Positions
     */
    public $positions;
    /**
     * Constructor method for litem
     * @uses Litem::setCode()
     * @uses Litem::setDesc()
     * @uses Litem::setDescText()
     * @uses Litem::setOrder()
     * @uses Litem::setImg()
     * @uses Litem::setUpd()
     * @uses Litem::setRealTimeData()
     * @uses Litem::setRealTimeServiceName()
     * @uses Litem::setPositions()
     * @param int $code
     * @param string $desc
     * @param string $descText
     * @param int $order
     * @param string $img
     * @param string $upd
     * @param string $realTimeData
     * @param string $realTimeServiceName
     * @param \QCC\CampusM\CloudService\StructType\Positions $positions
     */
    public function __construct($code = null, $desc = null, $descText = null, $order = null, $img = null, $upd = null, $realTimeData = null, $realTimeServiceName = null, \QCC\CampusM\CloudService\StructType\Positions $positions = null)
    {
        $this
            ->setCode($code)
            ->setDesc($desc)
            ->setDescText($descText)
            ->setOrder($order)
            ->setImg($img)
            ->setUpd($upd)
            ->setRealTimeData($realTimeData)
            ->setRealTimeServiceName($realTimeServiceName)
            ->setPositions($positions);
    }
    /**
     * Get code value
     * @return int|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param int $code
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !is_numeric($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get desc value
     * @return string|null
     */
    public function getDesc()
    {
        return $this->desc;
    }
    /**
     * Set desc value
     * @param string $desc
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setDesc($desc = null)
    {
        // validation for constraint: string
        if (!is_null($desc) && !is_string($desc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($desc)), __LINE__);
        }
        $this->desc = $desc;
        return $this;
    }
    /**
     * Get descText value
     * @return string|null
     */
    public function getDescText()
    {
        return $this->descText;
    }
    /**
     * Set descText value
     * @param string $descText
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setDescText($descText = null)
    {
        // validation for constraint: string
        if (!is_null($descText) && !is_string($descText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descText)), __LINE__);
        }
        $this->descText = $descText;
        return $this;
    }
    /**
     * Get order value
     * @return int|null
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @param int $order
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setOrder($order = null)
    {
        // validation for constraint: int
        if (!is_null($order) && !is_numeric($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($order)), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
    /**
     * Get img value
     * @return string|null
     */
    public function getImg()
    {
        return $this->img;
    }
    /**
     * Set img value
     * @param string $img
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setImg($img = null)
    {
        // validation for constraint: string
        if (!is_null($img) && !is_string($img)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($img)), __LINE__);
        }
        $this->img = $img;
        return $this;
    }
    /**
     * Get upd value
     * @return string|null
     */
    public function getUpd()
    {
        return $this->upd;
    }
    /**
     * Set upd value
     * @param string $upd
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setUpd($upd = null)
    {
        // validation for constraint: string
        if (!is_null($upd) && !is_string($upd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upd)), __LINE__);
        }
        $this->upd = $upd;
        return $this;
    }
    /**
     * Get realTimeData value
     * @return string|null
     */
    public function getRealTimeData()
    {
        return $this->realTimeData;
    }
    /**
     * Set realTimeData value
     * @param string $realTimeData
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setRealTimeData($realTimeData = null)
    {
        // validation for constraint: string
        if (!is_null($realTimeData) && !is_string($realTimeData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($realTimeData)), __LINE__);
        }
        $this->realTimeData = $realTimeData;
        return $this;
    }
    /**
     * Get realTimeServiceName value
     * @return string|null
     */
    public function getRealTimeServiceName()
    {
        return $this->realTimeServiceName;
    }
    /**
     * Set realTimeServiceName value
     * @param string $realTimeServiceName
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setRealTimeServiceName($realTimeServiceName = null)
    {
        // validation for constraint: string
        if (!is_null($realTimeServiceName) && !is_string($realTimeServiceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($realTimeServiceName)), __LINE__);
        }
        $this->realTimeServiceName = $realTimeServiceName;
        return $this;
    }
    /**
     * Get positions value
     * @return \QCC\CampusM\CloudService\StructType\Positions|null
     */
    public function getPositions()
    {
        return $this->positions;
    }
    /**
     * Set positions value
     * @param \QCC\CampusM\CloudService\StructType\Positions $positions
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public function setPositions(\QCC\CampusM\CloudService\StructType\Positions $positions = null)
    {
        $this->positions = $positions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Litem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
