<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for locations StructType
 * @subpackage Structs
 */
class Locations extends AbstractStructBase
{
    /**
     * The litem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Litem[]
     */
    public $litem;
    /**
     * Constructor method for locations
     * @uses Locations::setLitem()
     * @param \QCC\CampusM\CloudService\StructType\Litem[] $litem
     */
    public function __construct(array $litem = array())
    {
        $this
            ->setLitem($litem);
    }
    /**
     * Get litem value
     * @return \QCC\CampusM\CloudService\StructType\Litem[]|null
     */
    public function getLitem()
    {
        return $this->litem;
    }
    /**
     * Set litem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Litem[] $litem
     * @return \QCC\CampusM\CloudService\StructType\Locations
     */
    public function setLitem(array $litem = array())
    {
        foreach ($litem as $locationsLitemItem) {
            // validation for constraint: itemType
            if (!$locationsLitemItem instanceof \QCC\CampusM\CloudService\StructType\Litem) {
                throw new \InvalidArgumentException(sprintf('The litem property can only contain items of \QCC\CampusM\CloudService\StructType\Litem, "%s" given', is_object($locationsLitemItem) ? get_class($locationsLitemItem) : gettype($locationsLitemItem)), __LINE__);
            }
        }
        $this->litem = $litem;
        return $this;
    }
    /**
     * Add item to litem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Litem $item
     * @return \QCC\CampusM\CloudService\StructType\Locations
     */
    public function addToLitem(\QCC\CampusM\CloudService\StructType\Litem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Litem) {
            throw new \InvalidArgumentException(sprintf('The litem property can only contain items of \QCC\CampusM\CloudService\StructType\Litem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->litem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Locations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
