<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for lookup StructType
 * @subpackage Structs
 */
class Lookup extends AbstractStructBase
{
    /**
     * The refCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $refCode;
    /**
     * The items
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Items
     */
    public $items;
    /**
     * Constructor method for lookup
     * @uses Lookup::setRefCode()
     * @uses Lookup::setItems()
     * @param string $refCode
     * @param \QCC\CampusM\CloudService\StructType\Items $items
     */
    public function __construct($refCode = null, \QCC\CampusM\CloudService\StructType\Items $items = null)
    {
        $this
            ->setRefCode($refCode)
            ->setItems($items);
    }
    /**
     * Get refCode value
     * @return string|null
     */
    public function getRefCode()
    {
        return $this->refCode;
    }
    /**
     * Set refCode value
     * @param string $refCode
     * @return \QCC\CampusM\CloudService\StructType\Lookup
     */
    public function setRefCode($refCode = null)
    {
        // validation for constraint: string
        if (!is_null($refCode) && !is_string($refCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($refCode)), __LINE__);
        }
        $this->refCode = $refCode;
        return $this;
    }
    /**
     * Get items value
     * @return \QCC\CampusM\CloudService\StructType\Items|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \QCC\CampusM\CloudService\StructType\Items $items
     * @return \QCC\CampusM\CloudService\StructType\Lookup
     */
    public function setItems(\QCC\CampusM\CloudService\StructType\Items $items = null)
    {
        $this->items = $items;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Lookup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
