<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for map StructType
 * @subpackage Structs
 */
class Map extends AbstractStructBase
{
    /**
     * The code
     * @var int
     */
    public $code;
    /**
     * The desc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $desc;
    /**
     * The order
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $order;
    /**
     * The tlLong
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tlLong;
    /**
     * The tlLat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tlLat;
    /**
     * The brLong
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $brLong;
    /**
     * The brLat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $brLat;
    /**
     * The img
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $img;
    /**
     * The upd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $upd;
    /**
     * The hideCampusMap
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hideCampusMap;
    /**
     * Constructor method for map
     * @uses Map::setCode()
     * @uses Map::setDesc()
     * @uses Map::setOrder()
     * @uses Map::setTlLong()
     * @uses Map::setTlLat()
     * @uses Map::setBrLong()
     * @uses Map::setBrLat()
     * @uses Map::setImg()
     * @uses Map::setUpd()
     * @uses Map::setHideCampusMap()
     * @param int $code
     * @param string $desc
     * @param int $order
     * @param float $tlLong
     * @param float $tlLat
     * @param float $brLong
     * @param float $brLat
     * @param string $img
     * @param string $upd
     * @param string $hideCampusMap
     */
    public function __construct($code = null, $desc = null, $order = null, $tlLong = null, $tlLat = null, $brLong = null, $brLat = null, $img = null, $upd = null, $hideCampusMap = null)
    {
        $this
            ->setCode($code)
            ->setDesc($desc)
            ->setOrder($order)
            ->setTlLong($tlLong)
            ->setTlLat($tlLat)
            ->setBrLong($brLong)
            ->setBrLat($brLat)
            ->setImg($img)
            ->setUpd($upd)
            ->setHideCampusMap($hideCampusMap);
    }
    /**
     * Get code value
     * @return int|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param int $code
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !is_numeric($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get desc value
     * @return string|null
     */
    public function getDesc()
    {
        return $this->desc;
    }
    /**
     * Set desc value
     * @param string $desc
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setDesc($desc = null)
    {
        // validation for constraint: string
        if (!is_null($desc) && !is_string($desc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($desc)), __LINE__);
        }
        $this->desc = $desc;
        return $this;
    }
    /**
     * Get order value
     * @return int|null
     */
    public function getOrder()
    {
        return $this->order;
    }
    /**
     * Set order value
     * @param int $order
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setOrder($order = null)
    {
        // validation for constraint: int
        if (!is_null($order) && !is_numeric($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($order)), __LINE__);
        }
        $this->order = $order;
        return $this;
    }
    /**
     * Get tlLong value
     * @return float|null
     */
    public function getTlLong()
    {
        return $this->tlLong;
    }
    /**
     * Set tlLong value
     * @param float $tlLong
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setTlLong($tlLong = null)
    {
        $this->tlLong = $tlLong;
        return $this;
    }
    /**
     * Get tlLat value
     * @return float|null
     */
    public function getTlLat()
    {
        return $this->tlLat;
    }
    /**
     * Set tlLat value
     * @param float $tlLat
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setTlLat($tlLat = null)
    {
        $this->tlLat = $tlLat;
        return $this;
    }
    /**
     * Get brLong value
     * @return float|null
     */
    public function getBrLong()
    {
        return $this->brLong;
    }
    /**
     * Set brLong value
     * @param float $brLong
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setBrLong($brLong = null)
    {
        $this->brLong = $brLong;
        return $this;
    }
    /**
     * Get brLat value
     * @return float|null
     */
    public function getBrLat()
    {
        return $this->brLat;
    }
    /**
     * Set brLat value
     * @param float $brLat
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setBrLat($brLat = null)
    {
        $this->brLat = $brLat;
        return $this;
    }
    /**
     * Get img value
     * @return string|null
     */
    public function getImg()
    {
        return $this->img;
    }
    /**
     * Set img value
     * @param string $img
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setImg($img = null)
    {
        // validation for constraint: string
        if (!is_null($img) && !is_string($img)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($img)), __LINE__);
        }
        $this->img = $img;
        return $this;
    }
    /**
     * Get upd value
     * @return string|null
     */
    public function getUpd()
    {
        return $this->upd;
    }
    /**
     * Set upd value
     * @param string $upd
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setUpd($upd = null)
    {
        // validation for constraint: string
        if (!is_null($upd) && !is_string($upd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upd)), __LINE__);
        }
        $this->upd = $upd;
        return $this;
    }
    /**
     * Get hideCampusMap value
     * @return string|null
     */
    public function getHideCampusMap()
    {
        return $this->hideCampusMap;
    }
    /**
     * Set hideCampusMap value
     * @param string $hideCampusMap
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public function setHideCampusMap($hideCampusMap = null)
    {
        // validation for constraint: string
        if (!is_null($hideCampusMap) && !is_string($hideCampusMap)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hideCampusMap)), __LINE__);
        }
        $this->hideCampusMap = $hideCampusMap;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Map
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
