<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for maps StructType
 * @subpackage Structs
 */
class Maps extends AbstractStructBase
{
    /**
     * The map
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Map[]
     */
    public $map;
    /**
     * Constructor method for maps
     * @uses Maps::setMap()
     * @param \QCC\CampusM\CloudService\StructType\Map[] $map
     */
    public function __construct(array $map = array())
    {
        $this
            ->setMap($map);
    }
    /**
     * Get map value
     * @return \QCC\CampusM\CloudService\StructType\Map[]|null
     */
    public function getMap()
    {
        return $this->map;
    }
    /**
     * Set map value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Map[] $map
     * @return \QCC\CampusM\CloudService\StructType\Maps
     */
    public function setMap(array $map = array())
    {
        foreach ($map as $mapsMapItem) {
            // validation for constraint: itemType
            if (!$mapsMapItem instanceof \QCC\CampusM\CloudService\StructType\Map) {
                throw new \InvalidArgumentException(sprintf('The map property can only contain items of \QCC\CampusM\CloudService\StructType\Map, "%s" given', is_object($mapsMapItem) ? get_class($mapsMapItem) : gettype($mapsMapItem)), __LINE__);
            }
        }
        $this->map = $map;
        return $this;
    }
    /**
     * Add item to map value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Map $item
     * @return \QCC\CampusM\CloudService\StructType\Maps
     */
    public function addToMap(\QCC\CampusM\CloudService\StructType\Map $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Map) {
            throw new \InvalidArgumentException(sprintf('The map property can only contain items of \QCC\CampusM\CloudService\StructType\Map, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->map[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Maps
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
