<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for module StructType
 * @subpackage Structs
 */
class Module extends AbstractStructBase
{
    /**
     * The key
     * @var string
     */
    public $key;
    /**
     * The settings
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\ModuleSettings
     */
    public $settings;
    /**
     * Constructor method for module
     * @uses Module::setKey()
     * @uses Module::setSettings()
     * @param string $key
     * @param \QCC\CampusM\CloudService\StructType\ModuleSettings $settings
     */
    public function __construct($key = null, \QCC\CampusM\CloudService\StructType\ModuleSettings $settings = null)
    {
        $this
            ->setKey($key)
            ->setSettings($settings);
    }
    /**
     * Get key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->key;
    }
    /**
     * Set key value
     * @param string $key
     * @return \QCC\CampusM\CloudService\StructType\Module
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($key)), __LINE__);
        }
        $this->key = $key;
        return $this;
    }
    /**
     * Get settings value
     * @return \QCC\CampusM\CloudService\StructType\ModuleSettings|null
     */
    public function getSettings()
    {
        return $this->settings;
    }
    /**
     * Set settings value
     * @param \QCC\CampusM\CloudService\StructType\ModuleSettings $settings
     * @return \QCC\CampusM\CloudService\StructType\Module
     */
    public function setSettings(\QCC\CampusM\CloudService\StructType\ModuleSettings $settings = null)
    {
        $this->settings = $settings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Module
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
