<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for myDetailResponse StructType
 * @subpackage Structs
 */
class MyDetailResponse extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The emailAddress
     * @var string
     */
    public $emailAddress;
    /**
     * The firstName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstName;
    /**
     * The lastName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastName;
    /**
     * The shareMyLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $shareMyLocation;
    /**
     * The updateLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $updateLocation;
    /**
     * The lastComment
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastComment;
    /**
     * The lastImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastImage;
    /**
     * The lastGpsDatetime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastGpsDatetime;
    /**
     * The lastCheckinLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastCheckinLocation;
    /**
     * The lastCheckinLatitude
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $lastCheckinLatitude;
    /**
     * The lastCheckinLongitude
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $lastCheckinLongitude;
    /**
     * The lastCheckinDatetime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastCheckinDatetime;
    /**
     * Constructor method for myDetailResponse
     * @uses MyDetailResponse::setPersonId()
     * @uses MyDetailResponse::setOrgCode()
     * @uses MyDetailResponse::setEmailAddress()
     * @uses MyDetailResponse::setFirstName()
     * @uses MyDetailResponse::setLastName()
     * @uses MyDetailResponse::setShareMyLocation()
     * @uses MyDetailResponse::setUpdateLocation()
     * @uses MyDetailResponse::setLastComment()
     * @uses MyDetailResponse::setLastImage()
     * @uses MyDetailResponse::setLastGpsDatetime()
     * @uses MyDetailResponse::setLastCheckinLocation()
     * @uses MyDetailResponse::setLastCheckinLatitude()
     * @uses MyDetailResponse::setLastCheckinLongitude()
     * @uses MyDetailResponse::setLastCheckinDatetime()
     * @param int $personId
     * @param int $orgCode
     * @param string $emailAddress
     * @param string $firstName
     * @param string $lastName
     * @param string $shareMyLocation
     * @param string $updateLocation
     * @param string $lastComment
     * @param string $lastImage
     * @param string $lastGpsDatetime
     * @param string $lastCheckinLocation
     * @param float $lastCheckinLatitude
     * @param float $lastCheckinLongitude
     * @param string $lastCheckinDatetime
     */
    public function __construct($personId = null, $orgCode = null, $emailAddress = null, $firstName = null, $lastName = null, $shareMyLocation = null, $updateLocation = null, $lastComment = null, $lastImage = null, $lastGpsDatetime = null, $lastCheckinLocation = null, $lastCheckinLatitude = null, $lastCheckinLongitude = null, $lastCheckinDatetime = null)
    {
        $this
            ->setPersonId($personId)
            ->setOrgCode($orgCode)
            ->setEmailAddress($emailAddress)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setShareMyLocation($shareMyLocation)
            ->setUpdateLocation($updateLocation)
            ->setLastComment($lastComment)
            ->setLastImage($lastImage)
            ->setLastGpsDatetime($lastGpsDatetime)
            ->setLastCheckinLocation($lastCheckinLocation)
            ->setLastCheckinLatitude($lastCheckinLatitude)
            ->setLastCheckinLongitude($lastCheckinLongitude)
            ->setLastCheckinDatetime($lastCheckinDatetime);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get emailAddress value
     * @return string|null
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }
    /**
     * Set emailAddress value
     * @param string $emailAddress
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setEmailAddress($emailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddress) && !is_string($emailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($emailAddress)), __LINE__);
        }
        $this->emailAddress = $emailAddress;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get lastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param string $lastName
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastName)), __LINE__);
        }
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Get shareMyLocation value
     * @return string|null
     */
    public function getShareMyLocation()
    {
        return $this->shareMyLocation;
    }
    /**
     * Set shareMyLocation value
     * @param string $shareMyLocation
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setShareMyLocation($shareMyLocation = null)
    {
        // validation for constraint: string
        if (!is_null($shareMyLocation) && !is_string($shareMyLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shareMyLocation)), __LINE__);
        }
        $this->shareMyLocation = $shareMyLocation;
        return $this;
    }
    /**
     * Get updateLocation value
     * @return string|null
     */
    public function getUpdateLocation()
    {
        return $this->updateLocation;
    }
    /**
     * Set updateLocation value
     * @param string $updateLocation
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setUpdateLocation($updateLocation = null)
    {
        // validation for constraint: string
        if (!is_null($updateLocation) && !is_string($updateLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($updateLocation)), __LINE__);
        }
        $this->updateLocation = $updateLocation;
        return $this;
    }
    /**
     * Get lastComment value
     * @return string|null
     */
    public function getLastComment()
    {
        return $this->lastComment;
    }
    /**
     * Set lastComment value
     * @param string $lastComment
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastComment($lastComment = null)
    {
        // validation for constraint: string
        if (!is_null($lastComment) && !is_string($lastComment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastComment)), __LINE__);
        }
        $this->lastComment = $lastComment;
        return $this;
    }
    /**
     * Get lastImage value
     * @return string|null
     */
    public function getLastImage()
    {
        return $this->lastImage;
    }
    /**
     * Set lastImage value
     * @param string $lastImage
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastImage($lastImage = null)
    {
        // validation for constraint: string
        if (!is_null($lastImage) && !is_string($lastImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastImage)), __LINE__);
        }
        $this->lastImage = $lastImage;
        return $this;
    }
    /**
     * Get lastGpsDatetime value
     * @return string|null
     */
    public function getLastGpsDatetime()
    {
        return $this->lastGpsDatetime;
    }
    /**
     * Set lastGpsDatetime value
     * @param string $lastGpsDatetime
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastGpsDatetime($lastGpsDatetime = null)
    {
        // validation for constraint: string
        if (!is_null($lastGpsDatetime) && !is_string($lastGpsDatetime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastGpsDatetime)), __LINE__);
        }
        $this->lastGpsDatetime = $lastGpsDatetime;
        return $this;
    }
    /**
     * Get lastCheckinLocation value
     * @return string|null
     */
    public function getLastCheckinLocation()
    {
        return $this->lastCheckinLocation;
    }
    /**
     * Set lastCheckinLocation value
     * @param string $lastCheckinLocation
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastCheckinLocation($lastCheckinLocation = null)
    {
        // validation for constraint: string
        if (!is_null($lastCheckinLocation) && !is_string($lastCheckinLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastCheckinLocation)), __LINE__);
        }
        $this->lastCheckinLocation = $lastCheckinLocation;
        return $this;
    }
    /**
     * Get lastCheckinLatitude value
     * @return float|null
     */
    public function getLastCheckinLatitude()
    {
        return $this->lastCheckinLatitude;
    }
    /**
     * Set lastCheckinLatitude value
     * @param float $lastCheckinLatitude
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastCheckinLatitude($lastCheckinLatitude = null)
    {
        $this->lastCheckinLatitude = $lastCheckinLatitude;
        return $this;
    }
    /**
     * Get lastCheckinLongitude value
     * @return float|null
     */
    public function getLastCheckinLongitude()
    {
        return $this->lastCheckinLongitude;
    }
    /**
     * Set lastCheckinLongitude value
     * @param float $lastCheckinLongitude
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastCheckinLongitude($lastCheckinLongitude = null)
    {
        $this->lastCheckinLongitude = $lastCheckinLongitude;
        return $this;
    }
    /**
     * Get lastCheckinDatetime value
     * @return string|null
     */
    public function getLastCheckinDatetime()
    {
        return $this->lastCheckinDatetime;
    }
    /**
     * Set lastCheckinDatetime value
     * @param string $lastCheckinDatetime
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public function setLastCheckinDatetime($lastCheckinDatetime = null)
    {
        // validation for constraint: string
        if (!is_null($lastCheckinDatetime) && !is_string($lastCheckinDatetime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastCheckinDatetime)), __LINE__);
        }
        $this->lastCheckinDatetime = $lastCheckinDatetime;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\MyDetailResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
