<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for paitem StructType
 * @subpackage Structs
 */
class Paitem extends AbstractStructBase
{
    /**
     * The locRef
     * @var string
     */
    public $locRef;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The url
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $url;
    /**
     * The image
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $image;
    /**
     * The positionCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $positionCode;
    /**
     * The position
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Pitem
     */
    public $position;
    /**
     * Constructor method for paitem
     * @uses Paitem::setLocRef()
     * @uses Paitem::setDescription()
     * @uses Paitem::setUrl()
     * @uses Paitem::setImage()
     * @uses Paitem::setPositionCode()
     * @uses Paitem::setPosition()
     * @param string $locRef
     * @param string $description
     * @param string $url
     * @param string $image
     * @param int $positionCode
     * @param \QCC\CampusM\CloudService\StructType\Pitem $position
     */
    public function __construct($locRef = null, $description = null, $url = null, $image = null, $positionCode = null, \QCC\CampusM\CloudService\StructType\Pitem $position = null)
    {
        $this
            ->setLocRef($locRef)
            ->setDescription($description)
            ->setUrl($url)
            ->setImage($image)
            ->setPositionCode($positionCode)
            ->setPosition($position);
    }
    /**
     * Get locRef value
     * @return string|null
     */
    public function getLocRef()
    {
        return $this->locRef;
    }
    /**
     * Set locRef value
     * @param string $locRef
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setLocRef($locRef = null)
    {
        // validation for constraint: string
        if (!is_null($locRef) && !is_string($locRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locRef)), __LINE__);
        }
        $this->locRef = $locRef;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Get image value
     * @return string|null
     */
    public function getImage()
    {
        return $this->image;
    }
    /**
     * Set image value
     * @param string $image
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setImage($image = null)
    {
        // validation for constraint: string
        if (!is_null($image) && !is_string($image)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($image)), __LINE__);
        }
        $this->image = $image;
        return $this;
    }
    /**
     * Get positionCode value
     * @return int|null
     */
    public function getPositionCode()
    {
        return $this->positionCode;
    }
    /**
     * Set positionCode value
     * @param int $positionCode
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setPositionCode($positionCode = null)
    {
        // validation for constraint: int
        if (!is_null($positionCode) && !is_numeric($positionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($positionCode)), __LINE__);
        }
        $this->positionCode = $positionCode;
        return $this;
    }
    /**
     * Get position value
     * @return \QCC\CampusM\CloudService\StructType\Pitem|null
     */
    public function getPosition()
    {
        return $this->position;
    }
    /**
     * Set position value
     * @param \QCC\CampusM\CloudService\StructType\Pitem $position
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public function setPosition(\QCC\CampusM\CloudService\StructType\Pitem $position = null)
    {
        $this->position = $position;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Paitem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
