<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for personTextResponse StructType
 * @subpackage Structs
 */
class PersonTextResponse extends AbstractStructBase
{
    /**
     * The vqCode
     * @var int
     */
    public $vqCode;
    /**
     * The text
     * @var string
     */
    public $text;
    /**
     * Constructor method for personTextResponse
     * @uses PersonTextResponse::setVqCode()
     * @uses PersonTextResponse::setText()
     * @param int $vqCode
     * @param string $text
     */
    public function __construct($vqCode = null, $text = null)
    {
        $this
            ->setVqCode($vqCode)
            ->setText($text);
    }
    /**
     * Get vqCode value
     * @return int|null
     */
    public function getVqCode()
    {
        return $this->vqCode;
    }
    /**
     * Set vqCode value
     * @param int $vqCode
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponse
     */
    public function setVqCode($vqCode = null)
    {
        // validation for constraint: int
        if (!is_null($vqCode) && !is_numeric($vqCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vqCode)), __LINE__);
        }
        $this->vqCode = $vqCode;
        return $this;
    }
    /**
     * Get text value
     * @return string|null
     */
    public function getText()
    {
        return $this->text;
    }
    /**
     * Set text value
     * @param string $text
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponse
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($text)), __LINE__);
        }
        $this->text = $text;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
