<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for personTextResponses StructType
 * @subpackage Structs
 */
class PersonTextResponses extends AbstractStructBase
{
    /**
     * The response
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\PersonTextResponse[]
     */
    public $response;
    /**
     * Constructor method for personTextResponses
     * @uses PersonTextResponses::setResponse()
     * @param \QCC\CampusM\CloudService\StructType\PersonTextResponse[] $response
     */
    public function __construct(array $response = array())
    {
        $this
            ->setResponse($response);
    }
    /**
     * Get response value
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponse[]|null
     */
    public function getResponse()
    {
        return $this->response;
    }
    /**
     * Set response value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\PersonTextResponse[] $response
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponses
     */
    public function setResponse(array $response = array())
    {
        foreach ($response as $personTextResponsesResponseItem) {
            // validation for constraint: itemType
            if (!$personTextResponsesResponseItem instanceof \QCC\CampusM\CloudService\StructType\PersonTextResponse) {
                throw new \InvalidArgumentException(sprintf('The response property can only contain items of \QCC\CampusM\CloudService\StructType\PersonTextResponse, "%s" given', is_object($personTextResponsesResponseItem) ? get_class($personTextResponsesResponseItem) : gettype($personTextResponsesResponseItem)), __LINE__);
            }
        }
        $this->response = $response;
        return $this;
    }
    /**
     * Add item to response value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\PersonTextResponse $item
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponses
     */
    public function addToResponse(\QCC\CampusM\CloudService\StructType\PersonTextResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\PersonTextResponse) {
            throw new \InvalidArgumentException(sprintf('The response property can only contain items of \QCC\CampusM\CloudService\StructType\PersonTextResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->response[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PersonTextResponses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
