<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for personalisationSettings StructType
 * @subpackage Structs
 */
class PersonalisationSettings extends AbstractStructBase
{
    /**
     * The personalisationEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $personalisationEnabled;
    /**
     * The personConfigJson
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $personConfigJson;
    /**
     * Constructor method for personalisationSettings
     * @uses PersonalisationSettings::setPersonalisationEnabled()
     * @uses PersonalisationSettings::setPersonConfigJson()
     * @param bool $personalisationEnabled
     * @param string $personConfigJson
     */
    public function __construct($personalisationEnabled = null, $personConfigJson = null)
    {
        $this
            ->setPersonalisationEnabled($personalisationEnabled)
            ->setPersonConfigJson($personConfigJson);
    }
    /**
     * Get personalisationEnabled value
     * @return bool|null
     */
    public function getPersonalisationEnabled()
    {
        return $this->personalisationEnabled;
    }
    /**
     * Set personalisationEnabled value
     * @param bool $personalisationEnabled
     * @return \QCC\CampusM\CloudService\StructType\PersonalisationSettings
     */
    public function setPersonalisationEnabled($personalisationEnabled = null)
    {
        // validation for constraint: boolean
        if (!is_null($personalisationEnabled) && !is_bool($personalisationEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($personalisationEnabled)), __LINE__);
        }
        $this->personalisationEnabled = $personalisationEnabled;
        return $this;
    }
    /**
     * Get personConfigJson value
     * @return string|null
     */
    public function getPersonConfigJson()
    {
        return $this->personConfigJson;
    }
    /**
     * Set personConfigJson value
     * @param string $personConfigJson
     * @return \QCC\CampusM\CloudService\StructType\PersonalisationSettings
     */
    public function setPersonConfigJson($personConfigJson = null)
    {
        // validation for constraint: string
        if (!is_null($personConfigJson) && !is_string($personConfigJson)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($personConfigJson)), __LINE__);
        }
        $this->personConfigJson = $personConfigJson;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PersonalisationSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
