<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pocketGuideContentResponse StructType
 * @subpackage Structs
 */
class PocketGuideContentResponse extends AbstractStructBase
{
    /**
     * The confirmation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $confirmation;
    /**
     * The pgContent
     * @var string
     */
    public $pgContent;
    /**
     * The pgStylesheet
     * @var string
     */
    public $pgStylesheet;
    /**
     * Constructor method for pocketGuideContentResponse
     * @uses PocketGuideContentResponse::setConfirmation()
     * @uses PocketGuideContentResponse::setPgContent()
     * @uses PocketGuideContentResponse::setPgStylesheet()
     * @param string $confirmation
     * @param string $pgContent
     * @param string $pgStylesheet
     */
    public function __construct($confirmation = null, $pgContent = null, $pgStylesheet = null)
    {
        $this
            ->setConfirmation($confirmation)
            ->setPgContent($pgContent)
            ->setPgStylesheet($pgStylesheet);
    }
    /**
     * Get confirmation value
     * @return string|null
     */
    public function getConfirmation()
    {
        return $this->confirmation;
    }
    /**
     * Set confirmation value
     * @param string $confirmation
     * @return \QCC\CampusM\CloudService\StructType\PocketGuideContentResponse
     */
    public function setConfirmation($confirmation = null)
    {
        // validation for constraint: string
        if (!is_null($confirmation) && !is_string($confirmation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($confirmation)), __LINE__);
        }
        $this->confirmation = $confirmation;
        return $this;
    }
    /**
     * Get pgContent value
     * @return string|null
     */
    public function getPgContent()
    {
        return $this->pgContent;
    }
    /**
     * Set pgContent value
     * @param string $pgContent
     * @return \QCC\CampusM\CloudService\StructType\PocketGuideContentResponse
     */
    public function setPgContent($pgContent = null)
    {
        // validation for constraint: string
        if (!is_null($pgContent) && !is_string($pgContent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pgContent)), __LINE__);
        }
        $this->pgContent = $pgContent;
        return $this;
    }
    /**
     * Get pgStylesheet value
     * @return string|null
     */
    public function getPgStylesheet()
    {
        return $this->pgStylesheet;
    }
    /**
     * Set pgStylesheet value
     * @param string $pgStylesheet
     * @return \QCC\CampusM\CloudService\StructType\PocketGuideContentResponse
     */
    public function setPgStylesheet($pgStylesheet = null)
    {
        // validation for constraint: string
        if (!is_null($pgStylesheet) && !is_string($pgStylesheet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pgStylesheet)), __LINE__);
        }
        $this->pgStylesheet = $pgStylesheet;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PocketGuideContentResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
