<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for positionActions StructType
 * @subpackage Structs
 */
class PositionActions extends AbstractStructBase
{
    /**
     * The paitem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Paitem[]
     */
    public $paitem;
    /**
     * Constructor method for positionActions
     * @uses PositionActions::setPaitem()
     * @param \QCC\CampusM\CloudService\StructType\Paitem[] $paitem
     */
    public function __construct(array $paitem = array())
    {
        $this
            ->setPaitem($paitem);
    }
    /**
     * Get paitem value
     * @return \QCC\CampusM\CloudService\StructType\Paitem[]|null
     */
    public function getPaitem()
    {
        return $this->paitem;
    }
    /**
     * Set paitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Paitem[] $paitem
     * @return \QCC\CampusM\CloudService\StructType\PositionActions
     */
    public function setPaitem(array $paitem = array())
    {
        foreach ($paitem as $positionActionsPaitemItem) {
            // validation for constraint: itemType
            if (!$positionActionsPaitemItem instanceof \QCC\CampusM\CloudService\StructType\Paitem) {
                throw new \InvalidArgumentException(sprintf('The paitem property can only contain items of \QCC\CampusM\CloudService\StructType\Paitem, "%s" given', is_object($positionActionsPaitemItem) ? get_class($positionActionsPaitemItem) : gettype($positionActionsPaitemItem)), __LINE__);
            }
        }
        $this->paitem = $paitem;
        return $this;
    }
    /**
     * Add item to paitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Paitem $item
     * @return \QCC\CampusM\CloudService\StructType\PositionActions
     */
    public function addToPaitem(\QCC\CampusM\CloudService\StructType\Paitem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Paitem) {
            throw new \InvalidArgumentException(sprintf('The paitem property can only contain items of \QCC\CampusM\CloudService\StructType\Paitem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->paitem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PositionActions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
