<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for positionsFeedFormat StructType
 * @subpackage Structs
 */
class PositionsFeedFormat extends AbstractStructBase
{
    /**
     * The notesFormat
     * @var string
     */
    public $notesFormat;
    /**
     * The parseDateFormat
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $parseDateFormat;
    /**
     * The outputDateFormat
     * @var string
     */
    public $outputDateFormat;
    /**
     * The dateXPath
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateXPath;
    /**
     * The positionBaseXPath
     * @var string
     */
    public $positionBaseXPath;
    /**
     * The positionRefXPath
     * @var string
     */
    public $positionRefXPath;
    /**
     * The notesXPath
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat
     */
    public $notesXPath;
    /**
     * Constructor method for positionsFeedFormat
     * @uses PositionsFeedFormat::setNotesFormat()
     * @uses PositionsFeedFormat::setParseDateFormat()
     * @uses PositionsFeedFormat::setOutputDateFormat()
     * @uses PositionsFeedFormat::setDateXPath()
     * @uses PositionsFeedFormat::setPositionBaseXPath()
     * @uses PositionsFeedFormat::setPositionRefXPath()
     * @uses PositionsFeedFormat::setNotesXPath()
     * @param string $notesFormat
     * @param string $parseDateFormat
     * @param string $outputDateFormat
     * @param string $dateXPath
     * @param string $positionBaseXPath
     * @param string $positionRefXPath
     * @param \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat $notesXPath
     */
    public function __construct($notesFormat = null, $parseDateFormat = null, $outputDateFormat = null, $dateXPath = null, $positionBaseXPath = null, $positionRefXPath = null, \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat $notesXPath = null)
    {
        $this
            ->setNotesFormat($notesFormat)
            ->setParseDateFormat($parseDateFormat)
            ->setOutputDateFormat($outputDateFormat)
            ->setDateXPath($dateXPath)
            ->setPositionBaseXPath($positionBaseXPath)
            ->setPositionRefXPath($positionRefXPath)
            ->setNotesXPath($notesXPath);
    }
    /**
     * Get notesFormat value
     * @return string|null
     */
    public function getNotesFormat()
    {
        return $this->notesFormat;
    }
    /**
     * Set notesFormat value
     * @param string $notesFormat
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setNotesFormat($notesFormat = null)
    {
        // validation for constraint: string
        if (!is_null($notesFormat) && !is_string($notesFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notesFormat)), __LINE__);
        }
        $this->notesFormat = $notesFormat;
        return $this;
    }
    /**
     * Get parseDateFormat value
     * @return string|null
     */
    public function getParseDateFormat()
    {
        return $this->parseDateFormat;
    }
    /**
     * Set parseDateFormat value
     * @param string $parseDateFormat
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setParseDateFormat($parseDateFormat = null)
    {
        // validation for constraint: string
        if (!is_null($parseDateFormat) && !is_string($parseDateFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($parseDateFormat)), __LINE__);
        }
        $this->parseDateFormat = $parseDateFormat;
        return $this;
    }
    /**
     * Get outputDateFormat value
     * @return string|null
     */
    public function getOutputDateFormat()
    {
        return $this->outputDateFormat;
    }
    /**
     * Set outputDateFormat value
     * @param string $outputDateFormat
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setOutputDateFormat($outputDateFormat = null)
    {
        // validation for constraint: string
        if (!is_null($outputDateFormat) && !is_string($outputDateFormat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($outputDateFormat)), __LINE__);
        }
        $this->outputDateFormat = $outputDateFormat;
        return $this;
    }
    /**
     * Get dateXPath value
     * @return string|null
     */
    public function getDateXPath()
    {
        return $this->dateXPath;
    }
    /**
     * Set dateXPath value
     * @param string $dateXPath
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setDateXPath($dateXPath = null)
    {
        // validation for constraint: string
        if (!is_null($dateXPath) && !is_string($dateXPath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateXPath)), __LINE__);
        }
        $this->dateXPath = $dateXPath;
        return $this;
    }
    /**
     * Get positionBaseXPath value
     * @return string|null
     */
    public function getPositionBaseXPath()
    {
        return $this->positionBaseXPath;
    }
    /**
     * Set positionBaseXPath value
     * @param string $positionBaseXPath
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setPositionBaseXPath($positionBaseXPath = null)
    {
        // validation for constraint: string
        if (!is_null($positionBaseXPath) && !is_string($positionBaseXPath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($positionBaseXPath)), __LINE__);
        }
        $this->positionBaseXPath = $positionBaseXPath;
        return $this;
    }
    /**
     * Get positionRefXPath value
     * @return string|null
     */
    public function getPositionRefXPath()
    {
        return $this->positionRefXPath;
    }
    /**
     * Set positionRefXPath value
     * @param string $positionRefXPath
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setPositionRefXPath($positionRefXPath = null)
    {
        // validation for constraint: string
        if (!is_null($positionRefXPath) && !is_string($positionRefXPath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($positionRefXPath)), __LINE__);
        }
        $this->positionRefXPath = $positionRefXPath;
        return $this;
    }
    /**
     * Get notesXPath value
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat|null
     */
    public function getNotesXPath()
    {
        return $this->notesXPath;
    }
    /**
     * Set notesXPath value
     * @param \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat $notesXPath
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public function setNotesXPath(\QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat $notesXPath = null)
    {
        $this->notesXPath = $notesXPath;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedFormat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
