<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for positionsFeedNotesFormat StructType
 * @subpackage Structs
 */
class PositionsFeedNotesFormat extends AbstractStructBase
{
    /**
     * The noteFormat
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat[]
     */
    public $noteFormat;
    /**
     * Constructor method for positionsFeedNotesFormat
     * @uses PositionsFeedNotesFormat::setNoteFormat()
     * @param \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat[] $noteFormat
     */
    public function __construct(array $noteFormat = array())
    {
        $this
            ->setNoteFormat($noteFormat);
    }
    /**
     * Get noteFormat value
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat[]|null
     */
    public function getNoteFormat()
    {
        return $this->noteFormat;
    }
    /**
     * Set noteFormat value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat[] $noteFormat
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat
     */
    public function setNoteFormat(array $noteFormat = array())
    {
        foreach ($noteFormat as $positionsFeedNotesFormatNoteFormatItem) {
            // validation for constraint: itemType
            if (!$positionsFeedNotesFormatNoteFormatItem instanceof \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat) {
                throw new \InvalidArgumentException(sprintf('The noteFormat property can only contain items of \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat, "%s" given', is_object($positionsFeedNotesFormatNoteFormatItem) ? get_class($positionsFeedNotesFormatNoteFormatItem) : gettype($positionsFeedNotesFormatNoteFormatItem)), __LINE__);
            }
        }
        $this->noteFormat = $noteFormat;
        return $this;
    }
    /**
     * Add item to noteFormat value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat $item
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat
     */
    public function addToNoteFormat(\QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat) {
            throw new \InvalidArgumentException(sprintf('The noteFormat property can only contain items of \QCC\CampusM\CloudService\StructType\PositionsFeedNoteFormat, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->noteFormat[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\PositionsFeedNotesFormat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
