<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for profileTutorial StructType
 * @subpackage Structs
 */
class ProfileTutorial extends AbstractStructBase
{
    /**
     * The pgCode
     * @var int
     */
    public $pgCode;
    /**
     * The content
     * @var \QCC\CampusM\CloudService\StructType\CachedGuideItems
     */
    public $content;
    /**
     * Constructor method for profileTutorial
     * @uses ProfileTutorial::setPgCode()
     * @uses ProfileTutorial::setContent()
     * @param int $pgCode
     * @param \QCC\CampusM\CloudService\StructType\CachedGuideItems $content
     */
    public function __construct($pgCode = null, \QCC\CampusM\CloudService\StructType\CachedGuideItems $content = null)
    {
        $this
            ->setPgCode($pgCode)
            ->setContent($content);
    }
    /**
     * Get pgCode value
     * @return int|null
     */
    public function getPgCode()
    {
        return $this->pgCode;
    }
    /**
     * Set pgCode value
     * @param int $pgCode
     * @return \QCC\CampusM\CloudService\StructType\ProfileTutorial
     */
    public function setPgCode($pgCode = null)
    {
        // validation for constraint: int
        if (!is_null($pgCode) && !is_numeric($pgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($pgCode)), __LINE__);
        }
        $this->pgCode = $pgCode;
        return $this;
    }
    /**
     * Get content value
     * @return \QCC\CampusM\CloudService\StructType\CachedGuideItems|null
     */
    public function getContent()
    {
        return $this->content;
    }
    /**
     * Set content value
     * @param \QCC\CampusM\CloudService\StructType\CachedGuideItems $content
     * @return \QCC\CampusM\CloudService\StructType\ProfileTutorial
     */
    public function setContent(\QCC\CampusM\CloudService\StructType\CachedGuideItems $content = null)
    {
        $this->content = $content;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ProfileTutorial
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
