<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for profiles StructType
 * @subpackage Structs
 */
class Profiles extends AbstractStructBase
{
    /**
     * The profile
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\Profile[]
     */
    public $profile;
    /**
     * Constructor method for profiles
     * @uses Profiles::setProfile()
     * @param \QCC\CampusM\CloudService\StructType\Profile[] $profile
     */
    public function __construct(array $profile = array())
    {
        $this
            ->setProfile($profile);
    }
    /**
     * Get profile value
     * @return \QCC\CampusM\CloudService\StructType\Profile[]|null
     */
    public function getProfile()
    {
        return $this->profile;
    }
    /**
     * Set profile value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Profile[] $profile
     * @return \QCC\CampusM\CloudService\StructType\Profiles
     */
    public function setProfile(array $profile = array())
    {
        foreach ($profile as $profilesProfileItem) {
            // validation for constraint: itemType
            if (!$profilesProfileItem instanceof \QCC\CampusM\CloudService\StructType\Profile) {
                throw new \InvalidArgumentException(sprintf('The profile property can only contain items of \QCC\CampusM\CloudService\StructType\Profile, "%s" given', is_object($profilesProfileItem) ? get_class($profilesProfileItem) : gettype($profilesProfileItem)), __LINE__);
            }
        }
        $this->profile = $profile;
        return $this;
    }
    /**
     * Add item to profile value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Profile $item
     * @return \QCC\CampusM\CloudService\StructType\Profiles
     */
    public function addToProfile(\QCC\CampusM\CloudService\StructType\Profile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Profile) {
            throw new \InvalidArgumentException(sprintf('The profile property can only contain items of \QCC\CampusM\CloudService\StructType\Profile, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->profile[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Profiles
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
