<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for questions StructType
 * @subpackage Structs
 */
class Questions extends AbstractStructBase
{
    /**
     * The question
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Question[]
     */
    public $question;
    /**
     * Constructor method for questions
     * @uses Questions::setQuestion()
     * @param \QCC\CampusM\CloudService\StructType\Question[] $question
     */
    public function __construct(array $question = array())
    {
        $this
            ->setQuestion($question);
    }
    /**
     * Get question value
     * @return \QCC\CampusM\CloudService\StructType\Question[]|null
     */
    public function getQuestion()
    {
        return $this->question;
    }
    /**
     * Set question value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Question[] $question
     * @return \QCC\CampusM\CloudService\StructType\Questions
     */
    public function setQuestion(array $question = array())
    {
        foreach ($question as $questionsQuestionItem) {
            // validation for constraint: itemType
            if (!$questionsQuestionItem instanceof \QCC\CampusM\CloudService\StructType\Question) {
                throw new \InvalidArgumentException(sprintf('The question property can only contain items of \QCC\CampusM\CloudService\StructType\Question, "%s" given', is_object($questionsQuestionItem) ? get_class($questionsQuestionItem) : gettype($questionsQuestionItem)), __LINE__);
            }
        }
        $this->question = $question;
        return $this;
    }
    /**
     * Add item to question value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Question $item
     * @return \QCC\CampusM\CloudService\StructType\Questions
     */
    public function addToQuestion(\QCC\CampusM\CloudService\StructType\Question $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Question) {
            throw new \InvalidArgumentException(sprintf('The question property can only contain items of \QCC\CampusM\CloudService\StructType\Question, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->question[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Questions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
