<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for regProcessResponse StructType
 * @subpackage Structs
 */
class RegProcessResponse extends AbstractStructBase
{
    /**
     * The newLogin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $newLogin;
    /**
     * The allowGuest
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $allowGuest;
    /**
     * The ldapLogin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapLogin;
    /**
     * The guestLabel
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $guestLabel;
    /**
     * The studentLabel
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $studentLabel;
    /**
     * The ldapServiceAccess
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ldapServiceAccess;
    /**
     * The loginEndpoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $loginEndpoint;
    /**
     * The userName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * The passWord
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $passWord;
    /**
     * The userPrompt
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userPrompt;
    /**
     * The loginDesc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $loginDesc;
    /**
     * The promptLabel1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $promptLabel1;
    /**
     * The promptLabel2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $promptLabel2;
    /**
     * The icon
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $icon;
    /**
     * The appName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $appName;
    /**
     * The webHostname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $webHostname;
    /**
     * Constructor method for regProcessResponse
     * @uses RegProcessResponse::setNewLogin()
     * @uses RegProcessResponse::setAllowGuest()
     * @uses RegProcessResponse::setLdapLogin()
     * @uses RegProcessResponse::setGuestLabel()
     * @uses RegProcessResponse::setStudentLabel()
     * @uses RegProcessResponse::setLdapServiceAccess()
     * @uses RegProcessResponse::setLoginEndpoint()
     * @uses RegProcessResponse::setUserName()
     * @uses RegProcessResponse::setPassWord()
     * @uses RegProcessResponse::setUserPrompt()
     * @uses RegProcessResponse::setLoginDesc()
     * @uses RegProcessResponse::setPromptLabel1()
     * @uses RegProcessResponse::setPromptLabel2()
     * @uses RegProcessResponse::setIcon()
     * @uses RegProcessResponse::setAppName()
     * @uses RegProcessResponse::setWebHostname()
     * @param string $newLogin
     * @param string $allowGuest
     * @param string $ldapLogin
     * @param string $guestLabel
     * @param string $studentLabel
     * @param string $ldapServiceAccess
     * @param string $loginEndpoint
     * @param string $userName
     * @param string $passWord
     * @param string $userPrompt
     * @param string $loginDesc
     * @param string $promptLabel1
     * @param string $promptLabel2
     * @param string $icon
     * @param string $appName
     * @param string $webHostname
     */
    public function __construct($newLogin = null, $allowGuest = null, $ldapLogin = null, $guestLabel = null, $studentLabel = null, $ldapServiceAccess = null, $loginEndpoint = null, $userName = null, $passWord = null, $userPrompt = null, $loginDesc = null, $promptLabel1 = null, $promptLabel2 = null, $icon = null, $appName = null, $webHostname = null)
    {
        $this
            ->setNewLogin($newLogin)
            ->setAllowGuest($allowGuest)
            ->setLdapLogin($ldapLogin)
            ->setGuestLabel($guestLabel)
            ->setStudentLabel($studentLabel)
            ->setLdapServiceAccess($ldapServiceAccess)
            ->setLoginEndpoint($loginEndpoint)
            ->setUserName($userName)
            ->setPassWord($passWord)
            ->setUserPrompt($userPrompt)
            ->setLoginDesc($loginDesc)
            ->setPromptLabel1($promptLabel1)
            ->setPromptLabel2($promptLabel2)
            ->setIcon($icon)
            ->setAppName($appName)
            ->setWebHostname($webHostname);
    }
    /**
     * Get newLogin value
     * @return string|null
     */
    public function getNewLogin()
    {
        return $this->newLogin;
    }
    /**
     * Set newLogin value
     * @param string $newLogin
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setNewLogin($newLogin = null)
    {
        // validation for constraint: string
        if (!is_null($newLogin) && !is_string($newLogin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newLogin)), __LINE__);
        }
        $this->newLogin = $newLogin;
        return $this;
    }
    /**
     * Get allowGuest value
     * @return string|null
     */
    public function getAllowGuest()
    {
        return $this->allowGuest;
    }
    /**
     * Set allowGuest value
     * @param string $allowGuest
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setAllowGuest($allowGuest = null)
    {
        // validation for constraint: string
        if (!is_null($allowGuest) && !is_string($allowGuest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($allowGuest)), __LINE__);
        }
        $this->allowGuest = $allowGuest;
        return $this;
    }
    /**
     * Get ldapLogin value
     * @return string|null
     */
    public function getLdapLogin()
    {
        return $this->ldapLogin;
    }
    /**
     * Set ldapLogin value
     * @param string $ldapLogin
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setLdapLogin($ldapLogin = null)
    {
        // validation for constraint: string
        if (!is_null($ldapLogin) && !is_string($ldapLogin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ldapLogin)), __LINE__);
        }
        $this->ldapLogin = $ldapLogin;
        return $this;
    }
    /**
     * Get guestLabel value
     * @return string|null
     */
    public function getGuestLabel()
    {
        return $this->guestLabel;
    }
    /**
     * Set guestLabel value
     * @param string $guestLabel
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setGuestLabel($guestLabel = null)
    {
        // validation for constraint: string
        if (!is_null($guestLabel) && !is_string($guestLabel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($guestLabel)), __LINE__);
        }
        $this->guestLabel = $guestLabel;
        return $this;
    }
    /**
     * Get studentLabel value
     * @return string|null
     */
    public function getStudentLabel()
    {
        return $this->studentLabel;
    }
    /**
     * Set studentLabel value
     * @param string $studentLabel
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setStudentLabel($studentLabel = null)
    {
        // validation for constraint: string
        if (!is_null($studentLabel) && !is_string($studentLabel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($studentLabel)), __LINE__);
        }
        $this->studentLabel = $studentLabel;
        return $this;
    }
    /**
     * Get ldapServiceAccess value
     * @return string|null
     */
    public function getLdapServiceAccess()
    {
        return $this->ldapServiceAccess;
    }
    /**
     * Set ldapServiceAccess value
     * @param string $ldapServiceAccess
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setLdapServiceAccess($ldapServiceAccess = null)
    {
        // validation for constraint: string
        if (!is_null($ldapServiceAccess) && !is_string($ldapServiceAccess)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ldapServiceAccess)), __LINE__);
        }
        $this->ldapServiceAccess = $ldapServiceAccess;
        return $this;
    }
    /**
     * Get loginEndpoint value
     * @return string|null
     */
    public function getLoginEndpoint()
    {
        return $this->loginEndpoint;
    }
    /**
     * Set loginEndpoint value
     * @param string $loginEndpoint
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setLoginEndpoint($loginEndpoint = null)
    {
        // validation for constraint: string
        if (!is_null($loginEndpoint) && !is_string($loginEndpoint)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loginEndpoint)), __LINE__);
        }
        $this->loginEndpoint = $loginEndpoint;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get passWord value
     * @return string|null
     */
    public function getPassWord()
    {
        return $this->passWord;
    }
    /**
     * Set passWord value
     * @param string $passWord
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setPassWord($passWord = null)
    {
        // validation for constraint: string
        if (!is_null($passWord) && !is_string($passWord)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($passWord)), __LINE__);
        }
        $this->passWord = $passWord;
        return $this;
    }
    /**
     * Get userPrompt value
     * @return string|null
     */
    public function getUserPrompt()
    {
        return $this->userPrompt;
    }
    /**
     * Set userPrompt value
     * @param string $userPrompt
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setUserPrompt($userPrompt = null)
    {
        // validation for constraint: string
        if (!is_null($userPrompt) && !is_string($userPrompt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userPrompt)), __LINE__);
        }
        $this->userPrompt = $userPrompt;
        return $this;
    }
    /**
     * Get loginDesc value
     * @return string|null
     */
    public function getLoginDesc()
    {
        return $this->loginDesc;
    }
    /**
     * Set loginDesc value
     * @param string $loginDesc
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setLoginDesc($loginDesc = null)
    {
        // validation for constraint: string
        if (!is_null($loginDesc) && !is_string($loginDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loginDesc)), __LINE__);
        }
        $this->loginDesc = $loginDesc;
        return $this;
    }
    /**
     * Get promptLabel1 value
     * @return string|null
     */
    public function getPromptLabel1()
    {
        return $this->promptLabel1;
    }
    /**
     * Set promptLabel1 value
     * @param string $promptLabel1
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setPromptLabel1($promptLabel1 = null)
    {
        // validation for constraint: string
        if (!is_null($promptLabel1) && !is_string($promptLabel1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($promptLabel1)), __LINE__);
        }
        $this->promptLabel1 = $promptLabel1;
        return $this;
    }
    /**
     * Get promptLabel2 value
     * @return string|null
     */
    public function getPromptLabel2()
    {
        return $this->promptLabel2;
    }
    /**
     * Set promptLabel2 value
     * @param string $promptLabel2
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setPromptLabel2($promptLabel2 = null)
    {
        // validation for constraint: string
        if (!is_null($promptLabel2) && !is_string($promptLabel2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($promptLabel2)), __LINE__);
        }
        $this->promptLabel2 = $promptLabel2;
        return $this;
    }
    /**
     * Get icon value
     * @return string|null
     */
    public function getIcon()
    {
        return $this->icon;
    }
    /**
     * Set icon value
     * @param string $icon
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setIcon($icon = null)
    {
        // validation for constraint: string
        if (!is_null($icon) && !is_string($icon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($icon)), __LINE__);
        }
        $this->icon = $icon;
        return $this;
    }
    /**
     * Get appName value
     * @return string|null
     */
    public function getAppName()
    {
        return $this->appName;
    }
    /**
     * Set appName value
     * @param string $appName
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setAppName($appName = null)
    {
        // validation for constraint: string
        if (!is_null($appName) && !is_string($appName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($appName)), __LINE__);
        }
        $this->appName = $appName;
        return $this;
    }
    /**
     * Get webHostname value
     * @return string|null
     */
    public function getWebHostname()
    {
        return $this->webHostname;
    }
    /**
     * Set webHostname value
     * @param string $webHostname
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public function setWebHostname($webHostname = null)
    {
        // validation for constraint: string
        if (!is_null($webHostname) && !is_string($webHostname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webHostname)), __LINE__);
        }
        $this->webHostname = $webHostname;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\RegProcessResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
