<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for regions StructType
 * @subpackage Structs
 */
class Regions extends AbstractStructBase
{
    /**
     * The region
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $region;
    /**
     * Constructor method for regions
     * @uses Regions::setRegion()
     * @param string[] $region
     */
    public function __construct(array $region = array())
    {
        $this
            ->setRegion($region);
    }
    /**
     * Get region value
     * @return string[]|null
     */
    public function getRegion()
    {
        return $this->region;
    }
    /**
     * Set region value
     * @throws \InvalidArgumentException
     * @param string[] $region
     * @return \QCC\CampusM\CloudService\StructType\Regions
     */
    public function setRegion(array $region = array())
    {
        foreach ($region as $regionsRegionItem) {
            // validation for constraint: itemType
            if (!is_string($regionsRegionItem)) {
                throw new \InvalidArgumentException(sprintf('The region property can only contain items of string, "%s" given', is_object($regionsRegionItem) ? get_class($regionsRegionItem) : gettype($regionsRegionItem)), __LINE__);
            }
        }
        $this->region = $region;
        return $this;
    }
    /**
     * Add item to region value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \QCC\CampusM\CloudService\StructType\Regions
     */
    public function addToRegion($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The region property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->region[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Regions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
