<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for reportItEntryOption StructType
 * @subpackage Structs
 */
class ReportItEntryOption extends AbstractStructBase
{
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The link
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $link;
    /**
     * The mandatory
     * @var string
     */
    public $mandatory;
    /**
     * The sort_order
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sort_order;
    /**
     * Constructor method for reportItEntryOption
     * @uses ReportItEntryOption::setDescription()
     * @uses ReportItEntryOption::setType()
     * @uses ReportItEntryOption::setLink()
     * @uses ReportItEntryOption::setMandatory()
     * @uses ReportItEntryOption::setSort_order()
     * @param string $description
     * @param string $type
     * @param string $link
     * @param string $mandatory
     * @param int $sort_order
     */
    public function __construct($description = null, $type = null, $link = null, $mandatory = null, $sort_order = null)
    {
        $this
            ->setDescription($description)
            ->setType($type)
            ->setLink($link)
            ->setMandatory($mandatory)
            ->setSort_order($sort_order);
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get link value
     * @return string|null
     */
    public function getLink()
    {
        return $this->link;
    }
    /**
     * Set link value
     * @param string $link
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public function setLink($link = null)
    {
        // validation for constraint: string
        if (!is_null($link) && !is_string($link)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($link)), __LINE__);
        }
        $this->link = $link;
        return $this;
    }
    /**
     * Get mandatory value
     * @return string|null
     */
    public function getMandatory()
    {
        return $this->mandatory;
    }
    /**
     * Set mandatory value
     * @param string $mandatory
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public function setMandatory($mandatory = null)
    {
        // validation for constraint: string
        if (!is_null($mandatory) && !is_string($mandatory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mandatory)), __LINE__);
        }
        $this->mandatory = $mandatory;
        return $this;
    }
    /**
     * Get sort_order value
     * @return int|null
     */
    public function getSort_order()
    {
        return $this->sort_order;
    }
    /**
     * Set sort_order value
     * @param int $sort_order
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public function setSort_order($sort_order = null)
    {
        // validation for constraint: int
        if (!is_null($sort_order) && !is_numeric($sort_order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sort_order)), __LINE__);
        }
        $this->sort_order = $sort_order;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
