<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for reportItEntryPersonalDetail StructType
 * @subpackage Structs
 */
class ReportItEntryPersonalDetail extends AbstractStructBase
{
    /**
     * The entry
     * @var string
     */
    public $entry;
    /**
     * The value
     * @var string
     */
    public $value;
    /**
     * The mandatory
     * @var string
     */
    public $mandatory;
    /**
     * The sort_order
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sort_order;
    /**
     * Constructor method for reportItEntryPersonalDetail
     * @uses ReportItEntryPersonalDetail::setEntry()
     * @uses ReportItEntryPersonalDetail::setValue()
     * @uses ReportItEntryPersonalDetail::setMandatory()
     * @uses ReportItEntryPersonalDetail::setSort_order()
     * @param string $entry
     * @param string $value
     * @param string $mandatory
     * @param int $sort_order
     */
    public function __construct($entry = null, $value = null, $mandatory = null, $sort_order = null)
    {
        $this
            ->setEntry($entry)
            ->setValue($value)
            ->setMandatory($mandatory)
            ->setSort_order($sort_order);
    }
    /**
     * Get entry value
     * @return string|null
     */
    public function getEntry()
    {
        return $this->entry;
    }
    /**
     * Set entry value
     * @param string $entry
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryPersonalDetail
     */
    public function setEntry($entry = null)
    {
        // validation for constraint: string
        if (!is_null($entry) && !is_string($entry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($entry)), __LINE__);
        }
        $this->entry = $entry;
        return $this;
    }
    /**
     * Get value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param string $value
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryPersonalDetail
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($value)), __LINE__);
        }
        $this->value = $value;
        return $this;
    }
    /**
     * Get mandatory value
     * @return string|null
     */
    public function getMandatory()
    {
        return $this->mandatory;
    }
    /**
     * Set mandatory value
     * @param string $mandatory
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryPersonalDetail
     */
    public function setMandatory($mandatory = null)
    {
        // validation for constraint: string
        if (!is_null($mandatory) && !is_string($mandatory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mandatory)), __LINE__);
        }
        $this->mandatory = $mandatory;
        return $this;
    }
    /**
     * Get sort_order value
     * @return int|null
     */
    public function getSort_order()
    {
        return $this->sort_order;
    }
    /**
     * Set sort_order value
     * @param int $sort_order
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryPersonalDetail
     */
    public function setSort_order($sort_order = null)
    {
        // validation for constraint: int
        if (!is_null($sort_order) && !is_numeric($sort_order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sort_order)), __LINE__);
        }
        $this->sort_order = $sort_order;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ReportItEntryPersonalDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
