<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rssCategories StructType
 * @subpackage Structs
 */
class RssCategories extends AbstractStructBase
{
    /**
     * The rssCategory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\RssCategory[]
     */
    public $rssCategory;
    /**
     * Constructor method for rssCategories
     * @uses RssCategories::setRssCategory()
     * @param \QCC\CampusM\CloudService\StructType\RssCategory[] $rssCategory
     */
    public function __construct(array $rssCategory = array())
    {
        $this
            ->setRssCategory($rssCategory);
    }
    /**
     * Get rssCategory value
     * @return \QCC\CampusM\CloudService\StructType\RssCategory[]|null
     */
    public function getRssCategory()
    {
        return $this->rssCategory;
    }
    /**
     * Set rssCategory value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\RssCategory[] $rssCategory
     * @return \QCC\CampusM\CloudService\StructType\RssCategories
     */
    public function setRssCategory(array $rssCategory = array())
    {
        foreach ($rssCategory as $rssCategoriesRssCategoryItem) {
            // validation for constraint: itemType
            if (!$rssCategoriesRssCategoryItem instanceof \QCC\CampusM\CloudService\StructType\RssCategory) {
                throw new \InvalidArgumentException(sprintf('The rssCategory property can only contain items of \QCC\CampusM\CloudService\StructType\RssCategory, "%s" given', is_object($rssCategoriesRssCategoryItem) ? get_class($rssCategoriesRssCategoryItem) : gettype($rssCategoriesRssCategoryItem)), __LINE__);
            }
        }
        $this->rssCategory = $rssCategory;
        return $this;
    }
    /**
     * Add item to rssCategory value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\RssCategory $item
     * @return \QCC\CampusM\CloudService\StructType\RssCategories
     */
    public function addToRssCategory(\QCC\CampusM\CloudService\StructType\RssCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\RssCategory) {
            throw new \InvalidArgumentException(sprintf('The rssCategory property can only contain items of \QCC\CampusM\CloudService\StructType\RssCategory, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->rssCategory[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\RssCategories
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
