<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rssCategory StructType
 * @subpackage Structs
 */
class RssCategory extends AbstractStructBase
{
    /**
     * The code
     * @var int
     */
    public $code;
    /**
     * The desc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $desc;
    /**
     * The feeds
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Feeds
     */
    public $feeds;
    /**
     * Constructor method for rssCategory
     * @uses RssCategory::setCode()
     * @uses RssCategory::setDesc()
     * @uses RssCategory::setFeeds()
     * @param int $code
     * @param string $desc
     * @param \QCC\CampusM\CloudService\StructType\Feeds $feeds
     */
    public function __construct($code = null, $desc = null, \QCC\CampusM\CloudService\StructType\Feeds $feeds = null)
    {
        $this
            ->setCode($code)
            ->setDesc($desc)
            ->setFeeds($feeds);
    }
    /**
     * Get code value
     * @return int|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param int $code
     * @return \QCC\CampusM\CloudService\StructType\RssCategory
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !is_numeric($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get desc value
     * @return string|null
     */
    public function getDesc()
    {
        return $this->desc;
    }
    /**
     * Set desc value
     * @param string $desc
     * @return \QCC\CampusM\CloudService\StructType\RssCategory
     */
    public function setDesc($desc = null)
    {
        // validation for constraint: string
        if (!is_null($desc) && !is_string($desc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($desc)), __LINE__);
        }
        $this->desc = $desc;
        return $this;
    }
    /**
     * Get feeds value
     * @return \QCC\CampusM\CloudService\StructType\Feeds|null
     */
    public function getFeeds()
    {
        return $this->feeds;
    }
    /**
     * Set feeds value
     * @param \QCC\CampusM\CloudService\StructType\Feeds $feeds
     * @return \QCC\CampusM\CloudService\StructType\RssCategory
     */
    public function setFeeds(\QCC\CampusM\CloudService\StructType\Feeds $feeds = null)
    {
        $this->feeds = $feeds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\RssCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
