<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchSuggestions StructType
 * @subpackage Structs
 */
class SearchSuggestions extends AbstractStructBase
{
    /**
     * The suggestionsMenuCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode[]
     */
    public $suggestionsMenuCode;
    /**
     * The suggestionsBase
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Suggestions
     */
    public $suggestionsBase;
    /**
     * Constructor method for searchSuggestions
     * @uses SearchSuggestions::setSuggestionsMenuCode()
     * @uses SearchSuggestions::setSuggestionsBase()
     * @param \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode[] $suggestionsMenuCode
     * @param \QCC\CampusM\CloudService\StructType\Suggestions $suggestionsBase
     */
    public function __construct(array $suggestionsMenuCode = array(), \QCC\CampusM\CloudService\StructType\Suggestions $suggestionsBase = null)
    {
        $this
            ->setSuggestionsMenuCode($suggestionsMenuCode)
            ->setSuggestionsBase($suggestionsBase);
    }
    /**
     * Get suggestionsMenuCode value
     * @return \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode[]|null
     */
    public function getSuggestionsMenuCode()
    {
        return $this->suggestionsMenuCode;
    }
    /**
     * Set suggestionsMenuCode value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode[] $suggestionsMenuCode
     * @return \QCC\CampusM\CloudService\StructType\SearchSuggestions
     */
    public function setSuggestionsMenuCode(array $suggestionsMenuCode = array())
    {
        foreach ($suggestionsMenuCode as $searchSuggestionsSuggestionsMenuCodeItem) {
            // validation for constraint: itemType
            if (!$searchSuggestionsSuggestionsMenuCodeItem instanceof \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode) {
                throw new \InvalidArgumentException(sprintf('The suggestionsMenuCode property can only contain items of \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode, "%s" given', is_object($searchSuggestionsSuggestionsMenuCodeItem) ? get_class($searchSuggestionsSuggestionsMenuCodeItem) : gettype($searchSuggestionsSuggestionsMenuCodeItem)), __LINE__);
            }
        }
        $this->suggestionsMenuCode = $suggestionsMenuCode;
        return $this;
    }
    /**
     * Add item to suggestionsMenuCode value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode $item
     * @return \QCC\CampusM\CloudService\StructType\SearchSuggestions
     */
    public function addToSuggestionsMenuCode(\QCC\CampusM\CloudService\StructType\SuggestionsMenuCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode) {
            throw new \InvalidArgumentException(sprintf('The suggestionsMenuCode property can only contain items of \QCC\CampusM\CloudService\StructType\SuggestionsMenuCode, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->suggestionsMenuCode[] = $item;
        return $this;
    }
    /**
     * Get suggestionsBase value
     * @return \QCC\CampusM\CloudService\StructType\Suggestions|null
     */
    public function getSuggestionsBase()
    {
        return $this->suggestionsBase;
    }
    /**
     * Set suggestionsBase value
     * @param \QCC\CampusM\CloudService\StructType\Suggestions $suggestionsBase
     * @return \QCC\CampusM\CloudService\StructType\SearchSuggestions
     */
    public function setSuggestionsBase(\QCC\CampusM\CloudService\StructType\Suggestions $suggestionsBase = null)
    {
        $this->suggestionsBase = $suggestionsBase;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SearchSuggestions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
