<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchposition StructType
 * @subpackage Structs
 */
class Searchposition extends AbstractStructBase
{
    /**
     * The building_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $building_name;
    /**
     * The map_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $map_name;
    /**
     * The category
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $category;
    /**
     * The latitude
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $latitude;
    /**
     * The longitude
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $longitude;
    /**
     * Constructor method for searchposition
     * @uses Searchposition::setBuilding_name()
     * @uses Searchposition::setMap_name()
     * @uses Searchposition::setCategory()
     * @uses Searchposition::setLatitude()
     * @uses Searchposition::setLongitude()
     * @param string $building_name
     * @param string $map_name
     * @param string $category
     * @param float $latitude
     * @param float $longitude
     */
    public function __construct($building_name = null, $map_name = null, $category = null, $latitude = null, $longitude = null)
    {
        $this
            ->setBuilding_name($building_name)
            ->setMap_name($map_name)
            ->setCategory($category)
            ->setLatitude($latitude)
            ->setLongitude($longitude);
    }
    /**
     * Get building_name value
     * @return string|null
     */
    public function getBuilding_name()
    {
        return $this->building_name;
    }
    /**
     * Set building_name value
     * @param string $building_name
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public function setBuilding_name($building_name = null)
    {
        // validation for constraint: string
        if (!is_null($building_name) && !is_string($building_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($building_name)), __LINE__);
        }
        $this->building_name = $building_name;
        return $this;
    }
    /**
     * Get map_name value
     * @return string|null
     */
    public function getMap_name()
    {
        return $this->map_name;
    }
    /**
     * Set map_name value
     * @param string $map_name
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public function setMap_name($map_name = null)
    {
        // validation for constraint: string
        if (!is_null($map_name) && !is_string($map_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($map_name)), __LINE__);
        }
        $this->map_name = $map_name;
        return $this;
    }
    /**
     * Get category value
     * @return string|null
     */
    public function getCategory()
    {
        return $this->category;
    }
    /**
     * Set category value
     * @param string $category
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public function setCategory($category = null)
    {
        // validation for constraint: string
        if (!is_null($category) && !is_string($category)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($category)), __LINE__);
        }
        $this->category = $category;
        return $this;
    }
    /**
     * Get latitude value
     * @return float|null
     */
    public function getLatitude()
    {
        return $this->latitude;
    }
    /**
     * Set latitude value
     * @param float $latitude
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public function setLatitude($latitude = null)
    {
        $this->latitude = $latitude;
        return $this;
    }
    /**
     * Get longitude value
     * @return float|null
     */
    public function getLongitude()
    {
        return $this->longitude;
    }
    /**
     * Set longitude value
     * @param float $longitude
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public function setLongitude($longitude = null)
    {
        $this->longitude = $longitude;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Searchposition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
