<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sendAlertEmailsRequest StructType
 * @subpackage Structs
 */
class SendAlertEmailsRequest extends AbstractAdminServiceRequest
{
    /**
     * The mailboxAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mailboxAddress;
    /**
     * The mailboxPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mailboxPassword;
    /**
     * The pop3protocol
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pop3protocol;
    /**
     * The pop3auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pop3auth;
    /**
     * The pop3socketFactoryFallback
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pop3socketFactoryFallback;
    /**
     * The pop3server
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pop3server;
    /**
     * The pop3port
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pop3port;
    /**
     * Constructor method for sendAlertEmailsRequest
     * @uses SendAlertEmailsRequest::setMailboxAddress()
     * @uses SendAlertEmailsRequest::setMailboxPassword()
     * @uses SendAlertEmailsRequest::setPop3protocol()
     * @uses SendAlertEmailsRequest::setPop3auth()
     * @uses SendAlertEmailsRequest::setPop3socketFactoryFallback()
     * @uses SendAlertEmailsRequest::setPop3server()
     * @uses SendAlertEmailsRequest::setPop3port()
     * @param string $mailboxAddress
     * @param string $mailboxPassword
     * @param string $pop3protocol
     * @param string $pop3auth
     * @param string $pop3socketFactoryFallback
     * @param string $pop3server
     * @param string $pop3port
     */
    public function __construct($mailboxAddress = null, $mailboxPassword = null, $pop3protocol = null, $pop3auth = null, $pop3socketFactoryFallback = null, $pop3server = null, $pop3port = null)
    {
        $this
            ->setMailboxAddress($mailboxAddress)
            ->setMailboxPassword($mailboxPassword)
            ->setPop3protocol($pop3protocol)
            ->setPop3auth($pop3auth)
            ->setPop3socketFactoryFallback($pop3socketFactoryFallback)
            ->setPop3server($pop3server)
            ->setPop3port($pop3port);
    }
    /**
     * Get mailboxAddress value
     * @return string|null
     */
    public function getMailboxAddress()
    {
        return $this->mailboxAddress;
    }
    /**
     * Set mailboxAddress value
     * @param string $mailboxAddress
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setMailboxAddress($mailboxAddress = null)
    {
        // validation for constraint: string
        if (!is_null($mailboxAddress) && !is_string($mailboxAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mailboxAddress)), __LINE__);
        }
        $this->mailboxAddress = $mailboxAddress;
        return $this;
    }
    /**
     * Get mailboxPassword value
     * @return string|null
     */
    public function getMailboxPassword()
    {
        return $this->mailboxPassword;
    }
    /**
     * Set mailboxPassword value
     * @param string $mailboxPassword
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setMailboxPassword($mailboxPassword = null)
    {
        // validation for constraint: string
        if (!is_null($mailboxPassword) && !is_string($mailboxPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mailboxPassword)), __LINE__);
        }
        $this->mailboxPassword = $mailboxPassword;
        return $this;
    }
    /**
     * Get pop3protocol value
     * @return string|null
     */
    public function getPop3protocol()
    {
        return $this->pop3protocol;
    }
    /**
     * Set pop3protocol value
     * @param string $pop3protocol
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setPop3protocol($pop3protocol = null)
    {
        // validation for constraint: string
        if (!is_null($pop3protocol) && !is_string($pop3protocol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pop3protocol)), __LINE__);
        }
        $this->pop3protocol = $pop3protocol;
        return $this;
    }
    /**
     * Get pop3auth value
     * @return string|null
     */
    public function getPop3auth()
    {
        return $this->pop3auth;
    }
    /**
     * Set pop3auth value
     * @param string $pop3auth
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setPop3auth($pop3auth = null)
    {
        // validation for constraint: string
        if (!is_null($pop3auth) && !is_string($pop3auth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pop3auth)), __LINE__);
        }
        $this->pop3auth = $pop3auth;
        return $this;
    }
    /**
     * Get pop3socketFactoryFallback value
     * @return string|null
     */
    public function getPop3socketFactoryFallback()
    {
        return $this->pop3socketFactoryFallback;
    }
    /**
     * Set pop3socketFactoryFallback value
     * @param string $pop3socketFactoryFallback
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setPop3socketFactoryFallback($pop3socketFactoryFallback = null)
    {
        // validation for constraint: string
        if (!is_null($pop3socketFactoryFallback) && !is_string($pop3socketFactoryFallback)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pop3socketFactoryFallback)), __LINE__);
        }
        $this->pop3socketFactoryFallback = $pop3socketFactoryFallback;
        return $this;
    }
    /**
     * Get pop3server value
     * @return string|null
     */
    public function getPop3server()
    {
        return $this->pop3server;
    }
    /**
     * Set pop3server value
     * @param string $pop3server
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setPop3server($pop3server = null)
    {
        // validation for constraint: string
        if (!is_null($pop3server) && !is_string($pop3server)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pop3server)), __LINE__);
        }
        $this->pop3server = $pop3server;
        return $this;
    }
    /**
     * Get pop3port value
     * @return string|null
     */
    public function getPop3port()
    {
        return $this->pop3port;
    }
    /**
     * Set pop3port value
     * @param string $pop3port
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public function setPop3port($pop3port = null)
    {
        // validation for constraint: string
        if (!is_null($pop3port) && !is_string($pop3port)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pop3port)), __LINE__);
        }
        $this->pop3port = $pop3port;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SendAlertEmailsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
