<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for services StructType
 * @subpackage Structs
 */
class Services extends AbstractStructBase
{
    /**
     * The uitem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Uitem[]
     */
    public $uitem;
    /**
     * Constructor method for services
     * @uses Services::setUitem()
     * @param \QCC\CampusM\CloudService\StructType\Uitem[] $uitem
     */
    public function __construct(array $uitem = array())
    {
        $this
            ->setUitem($uitem);
    }
    /**
     * Get uitem value
     * @return \QCC\CampusM\CloudService\StructType\Uitem[]|null
     */
    public function getUitem()
    {
        return $this->uitem;
    }
    /**
     * Set uitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Uitem[] $uitem
     * @return \QCC\CampusM\CloudService\StructType\Services
     */
    public function setUitem(array $uitem = array())
    {
        foreach ($uitem as $servicesUitemItem) {
            // validation for constraint: itemType
            if (!$servicesUitemItem instanceof \QCC\CampusM\CloudService\StructType\Uitem) {
                throw new \InvalidArgumentException(sprintf('The uitem property can only contain items of \QCC\CampusM\CloudService\StructType\Uitem, "%s" given', is_object($servicesUitemItem) ? get_class($servicesUitemItem) : gettype($servicesUitemItem)), __LINE__);
            }
        }
        $this->uitem = $uitem;
        return $this;
    }
    /**
     * Add item to uitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Uitem $item
     * @return \QCC\CampusM\CloudService\StructType\Services
     */
    public function addToUitem(\QCC\CampusM\CloudService\StructType\Uitem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Uitem) {
            throw new \InvalidArgumentException(sprintf('The uitem property can only contain items of \QCC\CampusM\CloudService\StructType\Uitem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->uitem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Services
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
