<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for setPersonalisationConfigResponse StructType
 * @subpackage Structs
 */
class SetPersonalisationConfigResponse extends AbstractStructBase
{
    /**
     * The profileId
     * @var int
     */
    public $profileId;
    /**
     * The userPersonalisationLastUpdated
     * @var string
     */
    public $userPersonalisationLastUpdated;
    /**
     * Constructor method for setPersonalisationConfigResponse
     * @uses SetPersonalisationConfigResponse::setProfileId()
     * @uses SetPersonalisationConfigResponse::setUserPersonalisationLastUpdated()
     * @param int $profileId
     * @param string $userPersonalisationLastUpdated
     */
    public function __construct($profileId = null, $userPersonalisationLastUpdated = null)
    {
        $this
            ->setProfileId($profileId)
            ->setUserPersonalisationLastUpdated($userPersonalisationLastUpdated);
    }
    /**
     * Get profileId value
     * @return int|null
     */
    public function getProfileId()
    {
        return $this->profileId;
    }
    /**
     * Set profileId value
     * @param int $profileId
     * @return \QCC\CampusM\CloudService\StructType\SetPersonalisationConfigResponse
     */
    public function setProfileId($profileId = null)
    {
        // validation for constraint: int
        if (!is_null($profileId) && !is_numeric($profileId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($profileId)), __LINE__);
        }
        $this->profileId = $profileId;
        return $this;
    }
    /**
     * Get userPersonalisationLastUpdated value
     * @return string|null
     */
    public function getUserPersonalisationLastUpdated()
    {
        return $this->userPersonalisationLastUpdated;
    }
    /**
     * Set userPersonalisationLastUpdated value
     * @param string $userPersonalisationLastUpdated
     * @return \QCC\CampusM\CloudService\StructType\SetPersonalisationConfigResponse
     */
    public function setUserPersonalisationLastUpdated($userPersonalisationLastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($userPersonalisationLastUpdated) && !is_string($userPersonalisationLastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userPersonalisationLastUpdated)), __LINE__);
        }
        $this->userPersonalisationLastUpdated = $userPersonalisationLastUpdated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SetPersonalisationConfigResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
