<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for setupCouncilAlertsRequest StructType
 * @subpackage Structs
 */
class SetupCouncilAlertsRequest extends AbstractStructBase
{
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The orgMobilePassword
     * @var string
     */
    public $orgMobilePassword;
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The profileId
     * @var int
     */
    public $profileId;
    /**
     * The postcode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postcode;
    /**
     * The addressDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addressDescription;
    /**
     * The uprn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $uprn;
    /**
     * The propertyCategory
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $propertyCategory;
    /**
     * The flowDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\FlowDetails
     */
    public $flowDetails;
    /**
     * Constructor method for setupCouncilAlertsRequest
     * @uses SetupCouncilAlertsRequest::setOrgCode()
     * @uses SetupCouncilAlertsRequest::setOrgMobilePassword()
     * @uses SetupCouncilAlertsRequest::setPersonId()
     * @uses SetupCouncilAlertsRequest::setPassword()
     * @uses SetupCouncilAlertsRequest::setProfileId()
     * @uses SetupCouncilAlertsRequest::setPostcode()
     * @uses SetupCouncilAlertsRequest::setAddressDescription()
     * @uses SetupCouncilAlertsRequest::setUprn()
     * @uses SetupCouncilAlertsRequest::setPropertyCategory()
     * @uses SetupCouncilAlertsRequest::setFlowDetails()
     * @param int $orgCode
     * @param string $orgMobilePassword
     * @param int $personId
     * @param string $password
     * @param int $profileId
     * @param string $postcode
     * @param string $addressDescription
     * @param string $uprn
     * @param string $propertyCategory
     * @param \QCC\CampusM\CloudService\StructType\FlowDetails $flowDetails
     */
    public function __construct($orgCode = null, $orgMobilePassword = null, $personId = null, $password = null, $profileId = null, $postcode = null, $addressDescription = null, $uprn = null, $propertyCategory = null, \QCC\CampusM\CloudService\StructType\FlowDetails $flowDetails = null)
    {
        $this
            ->setOrgCode($orgCode)
            ->setOrgMobilePassword($orgMobilePassword)
            ->setPersonId($personId)
            ->setPassword($password)
            ->setProfileId($profileId)
            ->setPostcode($postcode)
            ->setAddressDescription($addressDescription)
            ->setUprn($uprn)
            ->setPropertyCategory($propertyCategory)
            ->setFlowDetails($flowDetails);
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get orgMobilePassword value
     * @return string|null
     */
    public function getOrgMobilePassword()
    {
        return $this->orgMobilePassword;
    }
    /**
     * Set orgMobilePassword value
     * @param string $orgMobilePassword
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setOrgMobilePassword($orgMobilePassword = null)
    {
        // validation for constraint: string
        if (!is_null($orgMobilePassword) && !is_string($orgMobilePassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orgMobilePassword)), __LINE__);
        }
        $this->orgMobilePassword = $orgMobilePassword;
        return $this;
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get profileId value
     * @return int|null
     */
    public function getProfileId()
    {
        return $this->profileId;
    }
    /**
     * Set profileId value
     * @param int $profileId
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setProfileId($profileId = null)
    {
        // validation for constraint: int
        if (!is_null($profileId) && !is_numeric($profileId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($profileId)), __LINE__);
        }
        $this->profileId = $profileId;
        return $this;
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get addressDescription value
     * @return string|null
     */
    public function getAddressDescription()
    {
        return $this->addressDescription;
    }
    /**
     * Set addressDescription value
     * @param string $addressDescription
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setAddressDescription($addressDescription = null)
    {
        // validation for constraint: string
        if (!is_null($addressDescription) && !is_string($addressDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressDescription)), __LINE__);
        }
        $this->addressDescription = $addressDescription;
        return $this;
    }
    /**
     * Get uprn value
     * @return string|null
     */
    public function getUprn()
    {
        return $this->uprn;
    }
    /**
     * Set uprn value
     * @param string $uprn
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setUprn($uprn = null)
    {
        // validation for constraint: string
        if (!is_null($uprn) && !is_string($uprn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uprn)), __LINE__);
        }
        $this->uprn = $uprn;
        return $this;
    }
    /**
     * Get propertyCategory value
     * @return string|null
     */
    public function getPropertyCategory()
    {
        return $this->propertyCategory;
    }
    /**
     * Set propertyCategory value
     * @param string $propertyCategory
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setPropertyCategory($propertyCategory = null)
    {
        // validation for constraint: string
        if (!is_null($propertyCategory) && !is_string($propertyCategory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($propertyCategory)), __LINE__);
        }
        $this->propertyCategory = $propertyCategory;
        return $this;
    }
    /**
     * Get flowDetails value
     * @return \QCC\CampusM\CloudService\StructType\FlowDetails|null
     */
    public function getFlowDetails()
    {
        return $this->flowDetails;
    }
    /**
     * Set flowDetails value
     * @param \QCC\CampusM\CloudService\StructType\FlowDetails $flowDetails
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public function setFlowDetails(\QCC\CampusM\CloudService\StructType\FlowDetails $flowDetails = null)
    {
        $this->flowDetails = $flowDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SetupCouncilAlertsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
