<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sitems StructType
 * @subpackage Structs
 */
class Sitems extends AbstractStructBase
{
    /**
     * The sitem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Sitem[]
     */
    public $sitem;
    /**
     * Constructor method for sitems
     * @uses Sitems::setSitem()
     * @param \QCC\CampusM\CloudService\StructType\Sitem[] $sitem
     */
    public function __construct(array $sitem = array())
    {
        $this
            ->setSitem($sitem);
    }
    /**
     * Get sitem value
     * @return \QCC\CampusM\CloudService\StructType\Sitem[]|null
     */
    public function getSitem()
    {
        return $this->sitem;
    }
    /**
     * Set sitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Sitem[] $sitem
     * @return \QCC\CampusM\CloudService\StructType\Sitems
     */
    public function setSitem(array $sitem = array())
    {
        foreach ($sitem as $sitemsSitemItem) {
            // validation for constraint: itemType
            if (!$sitemsSitemItem instanceof \QCC\CampusM\CloudService\StructType\Sitem) {
                throw new \InvalidArgumentException(sprintf('The sitem property can only contain items of \QCC\CampusM\CloudService\StructType\Sitem, "%s" given', is_object($sitemsSitemItem) ? get_class($sitemsSitemItem) : gettype($sitemsSitemItem)), __LINE__);
            }
        }
        $this->sitem = $sitem;
        return $this;
    }
    /**
     * Add item to sitem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\Sitem $item
     * @return \QCC\CampusM\CloudService\StructType\Sitems
     */
    public function addToSitem(\QCC\CampusM\CloudService\StructType\Sitem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\Sitem) {
            throw new \InvalidArgumentException(sprintf('The sitem property can only contain items of \QCC\CampusM\CloudService\StructType\Sitem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->sitem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Sitems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
