<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for splashPageResponse StructType
 * @subpackage Structs
 */
class SplashPageResponse extends AbstractStructBase
{
    /**
     * The spiUpd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $spiUpd;
    /**
     * The hpiUpd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hpiUpd;
    /**
     * The hmpiUpd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hmpiUpd;
    /**
     * The spiImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $spiImage;
    /**
     * The hpiImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hpiImage;
    /**
     * The hmpiImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hmpiImage;
    /**
     * Constructor method for splashPageResponse
     * @uses SplashPageResponse::setSpiUpd()
     * @uses SplashPageResponse::setHpiUpd()
     * @uses SplashPageResponse::setHmpiUpd()
     * @uses SplashPageResponse::setSpiImage()
     * @uses SplashPageResponse::setHpiImage()
     * @uses SplashPageResponse::setHmpiImage()
     * @param string $spiUpd
     * @param string $hpiUpd
     * @param string $hmpiUpd
     * @param string $spiImage
     * @param string $hpiImage
     * @param string $hmpiImage
     */
    public function __construct($spiUpd = null, $hpiUpd = null, $hmpiUpd = null, $spiImage = null, $hpiImage = null, $hmpiImage = null)
    {
        $this
            ->setSpiUpd($spiUpd)
            ->setHpiUpd($hpiUpd)
            ->setHmpiUpd($hmpiUpd)
            ->setSpiImage($spiImage)
            ->setHpiImage($hpiImage)
            ->setHmpiImage($hmpiImage);
    }
    /**
     * Get spiUpd value
     * @return string|null
     */
    public function getSpiUpd()
    {
        return $this->spiUpd;
    }
    /**
     * Set spiUpd value
     * @param string $spiUpd
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setSpiUpd($spiUpd = null)
    {
        // validation for constraint: string
        if (!is_null($spiUpd) && !is_string($spiUpd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spiUpd)), __LINE__);
        }
        $this->spiUpd = $spiUpd;
        return $this;
    }
    /**
     * Get hpiUpd value
     * @return string|null
     */
    public function getHpiUpd()
    {
        return $this->hpiUpd;
    }
    /**
     * Set hpiUpd value
     * @param string $hpiUpd
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setHpiUpd($hpiUpd = null)
    {
        // validation for constraint: string
        if (!is_null($hpiUpd) && !is_string($hpiUpd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hpiUpd)), __LINE__);
        }
        $this->hpiUpd = $hpiUpd;
        return $this;
    }
    /**
     * Get hmpiUpd value
     * @return string|null
     */
    public function getHmpiUpd()
    {
        return $this->hmpiUpd;
    }
    /**
     * Set hmpiUpd value
     * @param string $hmpiUpd
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setHmpiUpd($hmpiUpd = null)
    {
        // validation for constraint: string
        if (!is_null($hmpiUpd) && !is_string($hmpiUpd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hmpiUpd)), __LINE__);
        }
        $this->hmpiUpd = $hmpiUpd;
        return $this;
    }
    /**
     * Get spiImage value
     * @return string|null
     */
    public function getSpiImage()
    {
        return $this->spiImage;
    }
    /**
     * Set spiImage value
     * @param string $spiImage
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setSpiImage($spiImage = null)
    {
        // validation for constraint: string
        if (!is_null($spiImage) && !is_string($spiImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spiImage)), __LINE__);
        }
        $this->spiImage = $spiImage;
        return $this;
    }
    /**
     * Get hpiImage value
     * @return string|null
     */
    public function getHpiImage()
    {
        return $this->hpiImage;
    }
    /**
     * Set hpiImage value
     * @param string $hpiImage
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setHpiImage($hpiImage = null)
    {
        // validation for constraint: string
        if (!is_null($hpiImage) && !is_string($hpiImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hpiImage)), __LINE__);
        }
        $this->hpiImage = $hpiImage;
        return $this;
    }
    /**
     * Get hmpiImage value
     * @return string|null
     */
    public function getHmpiImage()
    {
        return $this->hmpiImage;
    }
    /**
     * Set hmpiImage value
     * @param string $hmpiImage
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public function setHmpiImage($hmpiImage = null)
    {
        // validation for constraint: string
        if (!is_null($hmpiImage) && !is_string($hmpiImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hmpiImage)), __LINE__);
        }
        $this->hmpiImage = $hmpiImage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SplashPageResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
