<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for submitIdea StructType
 * @subpackage Structs
 */
class SubmitIdea extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The vcCode
     * @var int
     */
    public $vcCode;
    /**
     * The anonFlag
     * @var string
     */
    public $anonFlag;
    /**
     * The askQuestion
     * @var string
     */
    public $askQuestion;
    /**
     * The activeFrom
     * @var string
     */
    public $activeFrom;
    /**
     * The expiryDt
     * @var string
     */
    public $expiryDt;
    /**
     * Constructor method for submitIdea
     * @uses SubmitIdea::setPersonId()
     * @uses SubmitIdea::setPassword()
     * @uses SubmitIdea::setVcCode()
     * @uses SubmitIdea::setAnonFlag()
     * @uses SubmitIdea::setAskQuestion()
     * @uses SubmitIdea::setActiveFrom()
     * @uses SubmitIdea::setExpiryDt()
     * @param int $personId
     * @param string $password
     * @param int $vcCode
     * @param string $anonFlag
     * @param string $askQuestion
     * @param string $activeFrom
     * @param string $expiryDt
     */
    public function __construct($personId = null, $password = null, $vcCode = null, $anonFlag = null, $askQuestion = null, $activeFrom = null, $expiryDt = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setVcCode($vcCode)
            ->setAnonFlag($anonFlag)
            ->setAskQuestion($askQuestion)
            ->setActiveFrom($activeFrom)
            ->setExpiryDt($expiryDt);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get vcCode value
     * @return int|null
     */
    public function getVcCode()
    {
        return $this->vcCode;
    }
    /**
     * Set vcCode value
     * @param int $vcCode
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setVcCode($vcCode = null)
    {
        // validation for constraint: int
        if (!is_null($vcCode) && !is_numeric($vcCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vcCode)), __LINE__);
        }
        $this->vcCode = $vcCode;
        return $this;
    }
    /**
     * Get anonFlag value
     * @return string|null
     */
    public function getAnonFlag()
    {
        return $this->anonFlag;
    }
    /**
     * Set anonFlag value
     * @param string $anonFlag
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setAnonFlag($anonFlag = null)
    {
        // validation for constraint: string
        if (!is_null($anonFlag) && !is_string($anonFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($anonFlag)), __LINE__);
        }
        $this->anonFlag = $anonFlag;
        return $this;
    }
    /**
     * Get askQuestion value
     * @return string|null
     */
    public function getAskQuestion()
    {
        return $this->askQuestion;
    }
    /**
     * Set askQuestion value
     * @param string $askQuestion
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setAskQuestion($askQuestion = null)
    {
        // validation for constraint: string
        if (!is_null($askQuestion) && !is_string($askQuestion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($askQuestion)), __LINE__);
        }
        $this->askQuestion = $askQuestion;
        return $this;
    }
    /**
     * Get activeFrom value
     * @return string|null
     */
    public function getActiveFrom()
    {
        return $this->activeFrom;
    }
    /**
     * Set activeFrom value
     * @param string $activeFrom
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setActiveFrom($activeFrom = null)
    {
        // validation for constraint: string
        if (!is_null($activeFrom) && !is_string($activeFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($activeFrom)), __LINE__);
        }
        $this->activeFrom = $activeFrom;
        return $this;
    }
    /**
     * Get expiryDt value
     * @return string|null
     */
    public function getExpiryDt()
    {
        return $this->expiryDt;
    }
    /**
     * Set expiryDt value
     * @param string $expiryDt
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public function setExpiryDt($expiryDt = null)
    {
        // validation for constraint: string
        if (!is_null($expiryDt) && !is_string($expiryDt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expiryDt)), __LINE__);
        }
        $this->expiryDt = $expiryDt;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SubmitIdea
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
