<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for submitOptions StructType
 * @subpackage Structs
 */
class SubmitOptions extends AbstractStructBase
{
    /**
     * The submitOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \QCC\CampusM\CloudService\StructType\SubmitOption[]
     */
    public $submitOption;
    /**
     * Constructor method for submitOptions
     * @uses SubmitOptions::setSubmitOption()
     * @param \QCC\CampusM\CloudService\StructType\SubmitOption[] $submitOption
     */
    public function __construct(array $submitOption = array())
    {
        $this
            ->setSubmitOption($submitOption);
    }
    /**
     * Get submitOption value
     * @return \QCC\CampusM\CloudService\StructType\SubmitOption[]|null
     */
    public function getSubmitOption()
    {
        return $this->submitOption;
    }
    /**
     * Set submitOption value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\SubmitOption[] $submitOption
     * @return \QCC\CampusM\CloudService\StructType\SubmitOptions
     */
    public function setSubmitOption(array $submitOption = array())
    {
        foreach ($submitOption as $submitOptionsSubmitOptionItem) {
            // validation for constraint: itemType
            if (!$submitOptionsSubmitOptionItem instanceof \QCC\CampusM\CloudService\StructType\SubmitOption) {
                throw new \InvalidArgumentException(sprintf('The submitOption property can only contain items of \QCC\CampusM\CloudService\StructType\SubmitOption, "%s" given', is_object($submitOptionsSubmitOptionItem) ? get_class($submitOptionsSubmitOptionItem) : gettype($submitOptionsSubmitOptionItem)), __LINE__);
            }
        }
        $this->submitOption = $submitOption;
        return $this;
    }
    /**
     * Add item to submitOption value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\SubmitOption $item
     * @return \QCC\CampusM\CloudService\StructType\SubmitOptions
     */
    public function addToSubmitOption(\QCC\CampusM\CloudService\StructType\SubmitOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\SubmitOption) {
            throw new \InvalidArgumentException(sprintf('The submitOption property can only contain items of \QCC\CampusM\CloudService\StructType\SubmitOption, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->submitOption[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SubmitOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
