<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for submitQuestion StructType
 * @subpackage Structs
 */
class SubmitQuestion extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The vcCode
     * @var int
     */
    public $vcCode;
    /**
     * The classCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $classCode;
    /**
     * The anonFlag
     * @var string
     */
    public $anonFlag;
    /**
     * The askQuestion
     * @var string
     */
    public $askQuestion;
    /**
     * The activeFrom
     * @var string
     */
    public $activeFrom;
    /**
     * The expiryDt
     * @var string
     */
    public $expiryDt;
    /**
     * The amendVote
     * @var string
     */
    public $amendVote;
    /**
     * The featured
     * @var string
     */
    public $featured;
    /**
     * The answerType
     * @var string
     */
    public $answerType;
    /**
     * The submitOptions
     * @var \QCC\CampusM\CloudService\StructType\SubmitOptions
     */
    public $submitOptions;
    /**
     * Constructor method for submitQuestion
     * @uses SubmitQuestion::setPersonId()
     * @uses SubmitQuestion::setPassword()
     * @uses SubmitQuestion::setVcCode()
     * @uses SubmitQuestion::setClassCode()
     * @uses SubmitQuestion::setAnonFlag()
     * @uses SubmitQuestion::setAskQuestion()
     * @uses SubmitQuestion::setActiveFrom()
     * @uses SubmitQuestion::setExpiryDt()
     * @uses SubmitQuestion::setAmendVote()
     * @uses SubmitQuestion::setFeatured()
     * @uses SubmitQuestion::setAnswerType()
     * @uses SubmitQuestion::setSubmitOptions()
     * @param int $personId
     * @param string $password
     * @param int $vcCode
     * @param int $classCode
     * @param string $anonFlag
     * @param string $askQuestion
     * @param string $activeFrom
     * @param string $expiryDt
     * @param string $amendVote
     * @param string $featured
     * @param string $answerType
     * @param \QCC\CampusM\CloudService\StructType\SubmitOptions $submitOptions
     */
    public function __construct($personId = null, $password = null, $vcCode = null, $classCode = null, $anonFlag = null, $askQuestion = null, $activeFrom = null, $expiryDt = null, $amendVote = null, $featured = null, $answerType = null, \QCC\CampusM\CloudService\StructType\SubmitOptions $submitOptions = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setVcCode($vcCode)
            ->setClassCode($classCode)
            ->setAnonFlag($anonFlag)
            ->setAskQuestion($askQuestion)
            ->setActiveFrom($activeFrom)
            ->setExpiryDt($expiryDt)
            ->setAmendVote($amendVote)
            ->setFeatured($featured)
            ->setAnswerType($answerType)
            ->setSubmitOptions($submitOptions);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get vcCode value
     * @return int|null
     */
    public function getVcCode()
    {
        return $this->vcCode;
    }
    /**
     * Set vcCode value
     * @param int $vcCode
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setVcCode($vcCode = null)
    {
        // validation for constraint: int
        if (!is_null($vcCode) && !is_numeric($vcCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vcCode)), __LINE__);
        }
        $this->vcCode = $vcCode;
        return $this;
    }
    /**
     * Get classCode value
     * @return int|null
     */
    public function getClassCode()
    {
        return $this->classCode;
    }
    /**
     * Set classCode value
     * @param int $classCode
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setClassCode($classCode = null)
    {
        // validation for constraint: int
        if (!is_null($classCode) && !is_numeric($classCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($classCode)), __LINE__);
        }
        $this->classCode = $classCode;
        return $this;
    }
    /**
     * Get anonFlag value
     * @return string|null
     */
    public function getAnonFlag()
    {
        return $this->anonFlag;
    }
    /**
     * Set anonFlag value
     * @param string $anonFlag
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setAnonFlag($anonFlag = null)
    {
        // validation for constraint: string
        if (!is_null($anonFlag) && !is_string($anonFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($anonFlag)), __LINE__);
        }
        $this->anonFlag = $anonFlag;
        return $this;
    }
    /**
     * Get askQuestion value
     * @return string|null
     */
    public function getAskQuestion()
    {
        return $this->askQuestion;
    }
    /**
     * Set askQuestion value
     * @param string $askQuestion
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setAskQuestion($askQuestion = null)
    {
        // validation for constraint: string
        if (!is_null($askQuestion) && !is_string($askQuestion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($askQuestion)), __LINE__);
        }
        $this->askQuestion = $askQuestion;
        return $this;
    }
    /**
     * Get activeFrom value
     * @return string|null
     */
    public function getActiveFrom()
    {
        return $this->activeFrom;
    }
    /**
     * Set activeFrom value
     * @param string $activeFrom
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setActiveFrom($activeFrom = null)
    {
        // validation for constraint: string
        if (!is_null($activeFrom) && !is_string($activeFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($activeFrom)), __LINE__);
        }
        $this->activeFrom = $activeFrom;
        return $this;
    }
    /**
     * Get expiryDt value
     * @return string|null
     */
    public function getExpiryDt()
    {
        return $this->expiryDt;
    }
    /**
     * Set expiryDt value
     * @param string $expiryDt
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setExpiryDt($expiryDt = null)
    {
        // validation for constraint: string
        if (!is_null($expiryDt) && !is_string($expiryDt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expiryDt)), __LINE__);
        }
        $this->expiryDt = $expiryDt;
        return $this;
    }
    /**
     * Get amendVote value
     * @return string|null
     */
    public function getAmendVote()
    {
        return $this->amendVote;
    }
    /**
     * Set amendVote value
     * @param string $amendVote
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setAmendVote($amendVote = null)
    {
        // validation for constraint: string
        if (!is_null($amendVote) && !is_string($amendVote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($amendVote)), __LINE__);
        }
        $this->amendVote = $amendVote;
        return $this;
    }
    /**
     * Get featured value
     * @return string|null
     */
    public function getFeatured()
    {
        return $this->featured;
    }
    /**
     * Set featured value
     * @param string $featured
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setFeatured($featured = null)
    {
        // validation for constraint: string
        if (!is_null($featured) && !is_string($featured)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($featured)), __LINE__);
        }
        $this->featured = $featured;
        return $this;
    }
    /**
     * Get answerType value
     * @return string|null
     */
    public function getAnswerType()
    {
        return $this->answerType;
    }
    /**
     * Set answerType value
     * @param string $answerType
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setAnswerType($answerType = null)
    {
        // validation for constraint: string
        if (!is_null($answerType) && !is_string($answerType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($answerType)), __LINE__);
        }
        $this->answerType = $answerType;
        return $this;
    }
    /**
     * Get submitOptions value
     * @return \QCC\CampusM\CloudService\StructType\SubmitOptions|null
     */
    public function getSubmitOptions()
    {
        return $this->submitOptions;
    }
    /**
     * Set submitOptions value
     * @param \QCC\CampusM\CloudService\StructType\SubmitOptions $submitOptions
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public function setSubmitOptions(\QCC\CampusM\CloudService\StructType\SubmitOptions $submitOptions = null)
    {
        $this->submitOptions = $submitOptions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\SubmitQuestion
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
