<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for toolBar StructType
 * @subpackage Structs
 */
class ToolBar extends AbstractStructBase
{
    /**
     * The code
     * @var string
     */
    public $code;
    /**
     * The toolBarMenuItems
     * @var \QCC\CampusM\CloudService\StructType\ToolBarMenuItems
     */
    public $toolBarMenuItems;
    /**
     * Constructor method for toolBar
     * @uses ToolBar::setCode()
     * @uses ToolBar::setToolBarMenuItems()
     * @param string $code
     * @param \QCC\CampusM\CloudService\StructType\ToolBarMenuItems $toolBarMenuItems
     */
    public function __construct($code = null, \QCC\CampusM\CloudService\StructType\ToolBarMenuItems $toolBarMenuItems = null)
    {
        $this
            ->setCode($code)
            ->setToolBarMenuItems($toolBarMenuItems);
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \QCC\CampusM\CloudService\StructType\ToolBar
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get toolBarMenuItems value
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItems|null
     */
    public function getToolBarMenuItems()
    {
        return $this->toolBarMenuItems;
    }
    /**
     * Set toolBarMenuItems value
     * @param \QCC\CampusM\CloudService\StructType\ToolBarMenuItems $toolBarMenuItems
     * @return \QCC\CampusM\CloudService\StructType\ToolBar
     */
    public function setToolBarMenuItems(\QCC\CampusM\CloudService\StructType\ToolBarMenuItems $toolBarMenuItems = null)
    {
        $this->toolBarMenuItems = $toolBarMenuItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ToolBar
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
