<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for toolBarMenuItem StructType
 * @subpackage Structs
 */
class ToolBarMenuItem extends AbstractStructBase
{
    /**
     * The display
     * @var string
     */
    public $display;
    /**
     * The iconImage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $iconImage;
    /**
     * The webAppIcon
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $webAppIcon;
    /**
     * The webUIMDCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $webUIMDCode;
    /**
     * The sortOrder
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sortOrder;
    /**
     * The securePrompt
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $securePrompt;
    /**
     * Constructor method for toolBarMenuItem
     * @uses ToolBarMenuItem::setDisplay()
     * @uses ToolBarMenuItem::setIconImage()
     * @uses ToolBarMenuItem::setWebAppIcon()
     * @uses ToolBarMenuItem::setWebUIMDCode()
     * @uses ToolBarMenuItem::setSortOrder()
     * @uses ToolBarMenuItem::setSecurePrompt()
     * @param string $display
     * @param string $iconImage
     * @param string $webAppIcon
     * @param string $webUIMDCode
     * @param string $sortOrder
     * @param string $securePrompt
     */
    public function __construct($display = null, $iconImage = null, $webAppIcon = null, $webUIMDCode = null, $sortOrder = null, $securePrompt = null)
    {
        $this
            ->setDisplay($display)
            ->setIconImage($iconImage)
            ->setWebAppIcon($webAppIcon)
            ->setWebUIMDCode($webUIMDCode)
            ->setSortOrder($sortOrder)
            ->setSecurePrompt($securePrompt);
    }
    /**
     * Get display value
     * @return string|null
     */
    public function getDisplay()
    {
        return $this->display;
    }
    /**
     * Set display value
     * @param string $display
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setDisplay($display = null)
    {
        // validation for constraint: string
        if (!is_null($display) && !is_string($display)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($display)), __LINE__);
        }
        $this->display = $display;
        return $this;
    }
    /**
     * Get iconImage value
     * @return string|null
     */
    public function getIconImage()
    {
        return $this->iconImage;
    }
    /**
     * Set iconImage value
     * @param string $iconImage
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setIconImage($iconImage = null)
    {
        // validation for constraint: string
        if (!is_null($iconImage) && !is_string($iconImage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iconImage)), __LINE__);
        }
        $this->iconImage = $iconImage;
        return $this;
    }
    /**
     * Get webAppIcon value
     * @return string|null
     */
    public function getWebAppIcon()
    {
        return $this->webAppIcon;
    }
    /**
     * Set webAppIcon value
     * @param string $webAppIcon
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setWebAppIcon($webAppIcon = null)
    {
        // validation for constraint: string
        if (!is_null($webAppIcon) && !is_string($webAppIcon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webAppIcon)), __LINE__);
        }
        $this->webAppIcon = $webAppIcon;
        return $this;
    }
    /**
     * Get webUIMDCode value
     * @return string|null
     */
    public function getWebUIMDCode()
    {
        return $this->webUIMDCode;
    }
    /**
     * Set webUIMDCode value
     * @param string $webUIMDCode
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setWebUIMDCode($webUIMDCode = null)
    {
        // validation for constraint: string
        if (!is_null($webUIMDCode) && !is_string($webUIMDCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webUIMDCode)), __LINE__);
        }
        $this->webUIMDCode = $webUIMDCode;
        return $this;
    }
    /**
     * Get sortOrder value
     * @return string|null
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }
    /**
     * Set sortOrder value
     * @param string $sortOrder
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setSortOrder($sortOrder = null)
    {
        // validation for constraint: string
        if (!is_null($sortOrder) && !is_string($sortOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sortOrder)), __LINE__);
        }
        $this->sortOrder = $sortOrder;
        return $this;
    }
    /**
     * Get securePrompt value
     * @return string|null
     */
    public function getSecurePrompt()
    {
        return $this->securePrompt;
    }
    /**
     * Set securePrompt value
     * @param string $securePrompt
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public function setSecurePrompt($securePrompt = null)
    {
        // validation for constraint: string
        if (!is_null($securePrompt) && !is_string($securePrompt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($securePrompt)), __LINE__);
        }
        $this->securePrompt = $securePrompt;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
