<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for toolBarMenuItems StructType
 * @subpackage Structs
 */
class ToolBarMenuItems extends AbstractStructBase
{
    /**
     * The toolBarMenuItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\ToolBarMenuItem[]
     */
    public $toolBarMenuItem;
    /**
     * Constructor method for toolBarMenuItems
     * @uses ToolBarMenuItems::setToolBarMenuItem()
     * @param \QCC\CampusM\CloudService\StructType\ToolBarMenuItem[] $toolBarMenuItem
     */
    public function __construct(array $toolBarMenuItem = array())
    {
        $this
            ->setToolBarMenuItem($toolBarMenuItem);
    }
    /**
     * Get toolBarMenuItem value
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItem[]|null
     */
    public function getToolBarMenuItem()
    {
        return $this->toolBarMenuItem;
    }
    /**
     * Set toolBarMenuItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\ToolBarMenuItem[] $toolBarMenuItem
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItems
     */
    public function setToolBarMenuItem(array $toolBarMenuItem = array())
    {
        foreach ($toolBarMenuItem as $toolBarMenuItemsToolBarMenuItemItem) {
            // validation for constraint: itemType
            if (!$toolBarMenuItemsToolBarMenuItemItem instanceof \QCC\CampusM\CloudService\StructType\ToolBarMenuItem) {
                throw new \InvalidArgumentException(sprintf('The toolBarMenuItem property can only contain items of \QCC\CampusM\CloudService\StructType\ToolBarMenuItem, "%s" given', is_object($toolBarMenuItemsToolBarMenuItemItem) ? get_class($toolBarMenuItemsToolBarMenuItemItem) : gettype($toolBarMenuItemsToolBarMenuItemItem)), __LINE__);
            }
        }
        $this->toolBarMenuItem = $toolBarMenuItem;
        return $this;
    }
    /**
     * Add item to toolBarMenuItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\ToolBarMenuItem $item
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItems
     */
    public function addToToolBarMenuItem(\QCC\CampusM\CloudService\StructType\ToolBarMenuItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\ToolBarMenuItem) {
            throw new \InvalidArgumentException(sprintf('The toolBarMenuItem property can only contain items of \QCC\CampusM\CloudService\StructType\ToolBarMenuItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->toolBarMenuItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ToolBarMenuItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
