<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ud StructType
 * @subpackage Structs
 */
class Ud extends AbstractStructBase
{
    /**
     * The ht
     * @var string
     */
    public $ht;
    /**
     * The des
     * @var string
     */
    public $des;
    /**
     * The dt
     * @var string
     */
    public $dt;
    /**
     * The ua
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ua;
    /**
     * The ip
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ip;
    /**
     * The br
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $br;
    /**
     * The url
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $url;
    /**
     * Constructor method for ud
     * @uses Ud::setHt()
     * @uses Ud::setDes()
     * @uses Ud::setDt()
     * @uses Ud::setUa()
     * @uses Ud::setIp()
     * @uses Ud::setBr()
     * @uses Ud::setUrl()
     * @param string $ht
     * @param string $des
     * @param string $dt
     * @param string $ua
     * @param string $ip
     * @param string $br
     * @param string $url
     */
    public function __construct($ht = null, $des = null, $dt = null, $ua = null, $ip = null, $br = null, $url = null)
    {
        $this
            ->setHt($ht)
            ->setDes($des)
            ->setDt($dt)
            ->setUa($ua)
            ->setIp($ip)
            ->setBr($br)
            ->setUrl($url);
    }
    /**
     * Get ht value
     * @return string|null
     */
    public function getHt()
    {
        return $this->ht;
    }
    /**
     * Set ht value
     * @param string $ht
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setHt($ht = null)
    {
        // validation for constraint: string
        if (!is_null($ht) && !is_string($ht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ht)), __LINE__);
        }
        $this->ht = $ht;
        return $this;
    }
    /**
     * Get des value
     * @return string|null
     */
    public function getDes()
    {
        return $this->des;
    }
    /**
     * Set des value
     * @param string $des
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setDes($des = null)
    {
        // validation for constraint: string
        if (!is_null($des) && !is_string($des)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($des)), __LINE__);
        }
        $this->des = $des;
        return $this;
    }
    /**
     * Get dt value
     * @return string|null
     */
    public function getDt()
    {
        return $this->dt;
    }
    /**
     * Set dt value
     * @param string $dt
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setDt($dt = null)
    {
        // validation for constraint: string
        if (!is_null($dt) && !is_string($dt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dt)), __LINE__);
        }
        $this->dt = $dt;
        return $this;
    }
    /**
     * Get ua value
     * @return string|null
     */
    public function getUa()
    {
        return $this->ua;
    }
    /**
     * Set ua value
     * @param string $ua
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setUa($ua = null)
    {
        // validation for constraint: string
        if (!is_null($ua) && !is_string($ua)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ua)), __LINE__);
        }
        $this->ua = $ua;
        return $this;
    }
    /**
     * Get ip value
     * @return string|null
     */
    public function getIp()
    {
        return $this->ip;
    }
    /**
     * Set ip value
     * @param string $ip
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setIp($ip = null)
    {
        // validation for constraint: string
        if (!is_null($ip) && !is_string($ip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ip)), __LINE__);
        }
        $this->ip = $ip;
        return $this;
    }
    /**
     * Get br value
     * @return string|null
     */
    public function getBr()
    {
        return $this->br;
    }
    /**
     * Set br value
     * @param string $br
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setBr($br = null)
    {
        // validation for constraint: string
        if (!is_null($br) && !is_string($br)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($br)), __LINE__);
        }
        $this->br = $br;
        return $this;
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Ud
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
