<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for uitem StructType
 * @subpackage Structs
 */
class Uitem extends AbstractStructBase
{
    /**
     * The userid
     * @var int
     */
    public $userid;
    /**
     * The accessType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $accessType;
    /**
     * The prompt
     * @var string
     */
    public $prompt;
    /**
     * The prompt1Label
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prompt1Label;
    /**
     * The prompt2Label
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prompt2Label;
    /**
     * The defaultUsername
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $defaultUsername;
    /**
     * The defaultPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $defaultPassword;
    /**
     * The promptDefaultCredentials
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $promptDefaultCredentials;
    /**
     * The sitems
     * @var \QCC\CampusM\CloudService\StructType\Sitems
     */
    public $sitems;
    /**
     * The ssoHost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ssoHost;
    /**
     * The ssoRequiresGet
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ssoRequiresGet;
    /**
     * The oAuthAuthorizeEndpoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthAuthorizeEndpoint;
    /**
     * The oAuthTokenEndpoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthTokenEndpoint;
    /**
     * The oAuthScope
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthScope;
    /**
     * The oAuthClientID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthClientID;
    /**
     * The oAuthCallbackURL
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthCallbackURL;
    /**
     * The oAuthCallbackType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $oAuthCallbackType;
    /**
     * Constructor method for uitem
     * @uses Uitem::setUserid()
     * @uses Uitem::setAccessType()
     * @uses Uitem::setPrompt()
     * @uses Uitem::setPrompt1Label()
     * @uses Uitem::setPrompt2Label()
     * @uses Uitem::setDefaultUsername()
     * @uses Uitem::setDefaultPassword()
     * @uses Uitem::setPromptDefaultCredentials()
     * @uses Uitem::setSitems()
     * @uses Uitem::setSsoHost()
     * @uses Uitem::setSsoRequiresGet()
     * @uses Uitem::setOAuthAuthorizeEndpoint()
     * @uses Uitem::setOAuthTokenEndpoint()
     * @uses Uitem::setOAuthScope()
     * @uses Uitem::setOAuthClientID()
     * @uses Uitem::setOAuthCallbackURL()
     * @uses Uitem::setOAuthCallbackType()
     * @param int $userid
     * @param string $accessType
     * @param string $prompt
     * @param string $prompt1Label
     * @param string $prompt2Label
     * @param string $defaultUsername
     * @param string $defaultPassword
     * @param string $promptDefaultCredentials
     * @param \QCC\CampusM\CloudService\StructType\Sitems $sitems
     * @param string $ssoHost
     * @param string $ssoRequiresGet
     * @param string $oAuthAuthorizeEndpoint
     * @param string $oAuthTokenEndpoint
     * @param string $oAuthScope
     * @param string $oAuthClientID
     * @param string $oAuthCallbackURL
     * @param string $oAuthCallbackType
     */
    public function __construct($userid = null, $accessType = null, $prompt = null, $prompt1Label = null, $prompt2Label = null, $defaultUsername = null, $defaultPassword = null, $promptDefaultCredentials = null, \QCC\CampusM\CloudService\StructType\Sitems $sitems = null, $ssoHost = null, $ssoRequiresGet = null, $oAuthAuthorizeEndpoint = null, $oAuthTokenEndpoint = null, $oAuthScope = null, $oAuthClientID = null, $oAuthCallbackURL = null, $oAuthCallbackType = null)
    {
        $this
            ->setUserid($userid)
            ->setAccessType($accessType)
            ->setPrompt($prompt)
            ->setPrompt1Label($prompt1Label)
            ->setPrompt2Label($prompt2Label)
            ->setDefaultUsername($defaultUsername)
            ->setDefaultPassword($defaultPassword)
            ->setPromptDefaultCredentials($promptDefaultCredentials)
            ->setSitems($sitems)
            ->setSsoHost($ssoHost)
            ->setSsoRequiresGet($ssoRequiresGet)
            ->setOAuthAuthorizeEndpoint($oAuthAuthorizeEndpoint)
            ->setOAuthTokenEndpoint($oAuthTokenEndpoint)
            ->setOAuthScope($oAuthScope)
            ->setOAuthClientID($oAuthClientID)
            ->setOAuthCallbackURL($oAuthCallbackURL)
            ->setOAuthCallbackType($oAuthCallbackType);
    }
    /**
     * Get userid value
     * @return int|null
     */
    public function getUserid()
    {
        return $this->userid;
    }
    /**
     * Set userid value
     * @param int $userid
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setUserid($userid = null)
    {
        // validation for constraint: int
        if (!is_null($userid) && !is_numeric($userid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userid)), __LINE__);
        }
        $this->userid = $userid;
        return $this;
    }
    /**
     * Get accessType value
     * @return string|null
     */
    public function getAccessType()
    {
        return $this->accessType;
    }
    /**
     * Set accessType value
     * @param string $accessType
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setAccessType($accessType = null)
    {
        // validation for constraint: string
        if (!is_null($accessType) && !is_string($accessType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accessType)), __LINE__);
        }
        $this->accessType = $accessType;
        return $this;
    }
    /**
     * Get prompt value
     * @return string|null
     */
    public function getPrompt()
    {
        return $this->prompt;
    }
    /**
     * Set prompt value
     * @param string $prompt
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setPrompt($prompt = null)
    {
        // validation for constraint: string
        if (!is_null($prompt) && !is_string($prompt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt)), __LINE__);
        }
        $this->prompt = $prompt;
        return $this;
    }
    /**
     * Get prompt1Label value
     * @return string|null
     */
    public function getPrompt1Label()
    {
        return $this->prompt1Label;
    }
    /**
     * Set prompt1Label value
     * @param string $prompt1Label
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setPrompt1Label($prompt1Label = null)
    {
        // validation for constraint: string
        if (!is_null($prompt1Label) && !is_string($prompt1Label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt1Label)), __LINE__);
        }
        $this->prompt1Label = $prompt1Label;
        return $this;
    }
    /**
     * Get prompt2Label value
     * @return string|null
     */
    public function getPrompt2Label()
    {
        return $this->prompt2Label;
    }
    /**
     * Set prompt2Label value
     * @param string $prompt2Label
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setPrompt2Label($prompt2Label = null)
    {
        // validation for constraint: string
        if (!is_null($prompt2Label) && !is_string($prompt2Label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt2Label)), __LINE__);
        }
        $this->prompt2Label = $prompt2Label;
        return $this;
    }
    /**
     * Get defaultUsername value
     * @return string|null
     */
    public function getDefaultUsername()
    {
        return $this->defaultUsername;
    }
    /**
     * Set defaultUsername value
     * @param string $defaultUsername
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setDefaultUsername($defaultUsername = null)
    {
        // validation for constraint: string
        if (!is_null($defaultUsername) && !is_string($defaultUsername)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($defaultUsername)), __LINE__);
        }
        $this->defaultUsername = $defaultUsername;
        return $this;
    }
    /**
     * Get defaultPassword value
     * @return string|null
     */
    public function getDefaultPassword()
    {
        return $this->defaultPassword;
    }
    /**
     * Set defaultPassword value
     * @param string $defaultPassword
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setDefaultPassword($defaultPassword = null)
    {
        // validation for constraint: string
        if (!is_null($defaultPassword) && !is_string($defaultPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($defaultPassword)), __LINE__);
        }
        $this->defaultPassword = $defaultPassword;
        return $this;
    }
    /**
     * Get promptDefaultCredentials value
     * @return string|null
     */
    public function getPromptDefaultCredentials()
    {
        return $this->promptDefaultCredentials;
    }
    /**
     * Set promptDefaultCredentials value
     * @param string $promptDefaultCredentials
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setPromptDefaultCredentials($promptDefaultCredentials = null)
    {
        // validation for constraint: string
        if (!is_null($promptDefaultCredentials) && !is_string($promptDefaultCredentials)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($promptDefaultCredentials)), __LINE__);
        }
        $this->promptDefaultCredentials = $promptDefaultCredentials;
        return $this;
    }
    /**
     * Get sitems value
     * @return \QCC\CampusM\CloudService\StructType\Sitems|null
     */
    public function getSitems()
    {
        return $this->sitems;
    }
    /**
     * Set sitems value
     * @param \QCC\CampusM\CloudService\StructType\Sitems $sitems
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setSitems(\QCC\CampusM\CloudService\StructType\Sitems $sitems = null)
    {
        $this->sitems = $sitems;
        return $this;
    }
    /**
     * Get ssoHost value
     * @return string|null
     */
    public function getSsoHost()
    {
        return $this->ssoHost;
    }
    /**
     * Set ssoHost value
     * @param string $ssoHost
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setSsoHost($ssoHost = null)
    {
        // validation for constraint: string
        if (!is_null($ssoHost) && !is_string($ssoHost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ssoHost)), __LINE__);
        }
        $this->ssoHost = $ssoHost;
        return $this;
    }
    /**
     * Get ssoRequiresGet value
     * @return string|null
     */
    public function getSsoRequiresGet()
    {
        return $this->ssoRequiresGet;
    }
    /**
     * Set ssoRequiresGet value
     * @param string $ssoRequiresGet
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setSsoRequiresGet($ssoRequiresGet = null)
    {
        // validation for constraint: string
        if (!is_null($ssoRequiresGet) && !is_string($ssoRequiresGet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ssoRequiresGet)), __LINE__);
        }
        $this->ssoRequiresGet = $ssoRequiresGet;
        return $this;
    }
    /**
     * Get oAuthAuthorizeEndpoint value
     * @return string|null
     */
    public function getOAuthAuthorizeEndpoint()
    {
        return $this->oAuthAuthorizeEndpoint;
    }
    /**
     * Set oAuthAuthorizeEndpoint value
     * @param string $oAuthAuthorizeEndpoint
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthAuthorizeEndpoint($oAuthAuthorizeEndpoint = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthAuthorizeEndpoint) && !is_string($oAuthAuthorizeEndpoint)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthAuthorizeEndpoint)), __LINE__);
        }
        $this->oAuthAuthorizeEndpoint = $oAuthAuthorizeEndpoint;
        return $this;
    }
    /**
     * Get oAuthTokenEndpoint value
     * @return string|null
     */
    public function getOAuthTokenEndpoint()
    {
        return $this->oAuthTokenEndpoint;
    }
    /**
     * Set oAuthTokenEndpoint value
     * @param string $oAuthTokenEndpoint
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthTokenEndpoint($oAuthTokenEndpoint = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthTokenEndpoint) && !is_string($oAuthTokenEndpoint)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthTokenEndpoint)), __LINE__);
        }
        $this->oAuthTokenEndpoint = $oAuthTokenEndpoint;
        return $this;
    }
    /**
     * Get oAuthScope value
     * @return string|null
     */
    public function getOAuthScope()
    {
        return $this->oAuthScope;
    }
    /**
     * Set oAuthScope value
     * @param string $oAuthScope
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthScope($oAuthScope = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthScope) && !is_string($oAuthScope)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthScope)), __LINE__);
        }
        $this->oAuthScope = $oAuthScope;
        return $this;
    }
    /**
     * Get oAuthClientID value
     * @return string|null
     */
    public function getOAuthClientID()
    {
        return $this->oAuthClientID;
    }
    /**
     * Set oAuthClientID value
     * @param string $oAuthClientID
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthClientID($oAuthClientID = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthClientID) && !is_string($oAuthClientID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthClientID)), __LINE__);
        }
        $this->oAuthClientID = $oAuthClientID;
        return $this;
    }
    /**
     * Get oAuthCallbackURL value
     * @return string|null
     */
    public function getOAuthCallbackURL()
    {
        return $this->oAuthCallbackURL;
    }
    /**
     * Set oAuthCallbackURL value
     * @param string $oAuthCallbackURL
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthCallbackURL($oAuthCallbackURL = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthCallbackURL) && !is_string($oAuthCallbackURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthCallbackURL)), __LINE__);
        }
        $this->oAuthCallbackURL = $oAuthCallbackURL;
        return $this;
    }
    /**
     * Get oAuthCallbackType value
     * @return string|null
     */
    public function getOAuthCallbackType()
    {
        return $this->oAuthCallbackType;
    }
    /**
     * Set oAuthCallbackType value
     * @param string $oAuthCallbackType
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public function setOAuthCallbackType($oAuthCallbackType = null)
    {
        // validation for constraint: string
        if (!is_null($oAuthCallbackType) && !is_string($oAuthCallbackType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oAuthCallbackType)), __LINE__);
        }
        $this->oAuthCallbackType = $oAuthCallbackType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Uitem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
