<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updatePositionNotes StructType
 * @subpackage Structs
 */
class UpdatePositionNotes extends AbstractStructBase
{
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The serviceTypeName
     * @var string
     */
    public $serviceTypeName;
    /**
     * The orgServicePassword
     * @var string
     */
    public $orgServicePassword;
    /**
     * Constructor method for updatePositionNotes
     * @uses UpdatePositionNotes::setOrgCode()
     * @uses UpdatePositionNotes::setServiceTypeName()
     * @uses UpdatePositionNotes::setOrgServicePassword()
     * @param int $orgCode
     * @param string $serviceTypeName
     * @param string $orgServicePassword
     */
    public function __construct($orgCode = null, $serviceTypeName = null, $orgServicePassword = null)
    {
        $this
            ->setOrgCode($orgCode)
            ->setServiceTypeName($serviceTypeName)
            ->setOrgServicePassword($orgServicePassword);
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\UpdatePositionNotes
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get serviceTypeName value
     * @return string|null
     */
    public function getServiceTypeName()
    {
        return $this->serviceTypeName;
    }
    /**
     * Set serviceTypeName value
     * @param string $serviceTypeName
     * @return \QCC\CampusM\CloudService\StructType\UpdatePositionNotes
     */
    public function setServiceTypeName($serviceTypeName = null)
    {
        // validation for constraint: string
        if (!is_null($serviceTypeName) && !is_string($serviceTypeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceTypeName)), __LINE__);
        }
        $this->serviceTypeName = $serviceTypeName;
        return $this;
    }
    /**
     * Get orgServicePassword value
     * @return string|null
     */
    public function getOrgServicePassword()
    {
        return $this->orgServicePassword;
    }
    /**
     * Set orgServicePassword value
     * @param string $orgServicePassword
     * @return \QCC\CampusM\CloudService\StructType\UpdatePositionNotes
     */
    public function setOrgServicePassword($orgServicePassword = null)
    {
        // validation for constraint: string
        if (!is_null($orgServicePassword) && !is_string($orgServicePassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orgServicePassword)), __LINE__);
        }
        $this->orgServicePassword = $orgServicePassword;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\UpdatePositionNotes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
