<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateRssSubsRequest StructType
 * @subpackage Structs
 */
class UpdateRssSubsRequest extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The profileId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $profileId;
    /**
     * The updt
     * @var string
     */
    public $updt;
    /**
     * The feeds
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\Feeds
     */
    public $feeds;
    /**
     * Constructor method for updateRssSubsRequest
     * @uses UpdateRssSubsRequest::setPersonId()
     * @uses UpdateRssSubsRequest::setPassword()
     * @uses UpdateRssSubsRequest::setProfileId()
     * @uses UpdateRssSubsRequest::setUpdt()
     * @uses UpdateRssSubsRequest::setFeeds()
     * @param int $personId
     * @param string $password
     * @param int $profileId
     * @param string $updt
     * @param \QCC\CampusM\CloudService\StructType\Feeds $feeds
     */
    public function __construct($personId = null, $password = null, $profileId = null, $updt = null, \QCC\CampusM\CloudService\StructType\Feeds $feeds = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setProfileId($profileId)
            ->setUpdt($updt)
            ->setFeeds($feeds);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get profileId value
     * @return int|null
     */
    public function getProfileId()
    {
        return $this->profileId;
    }
    /**
     * Set profileId value
     * @param int $profileId
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public function setProfileId($profileId = null)
    {
        // validation for constraint: int
        if (!is_null($profileId) && !is_numeric($profileId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($profileId)), __LINE__);
        }
        $this->profileId = $profileId;
        return $this;
    }
    /**
     * Get updt value
     * @return string|null
     */
    public function getUpdt()
    {
        return $this->updt;
    }
    /**
     * Set updt value
     * @param string $updt
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public function setUpdt($updt = null)
    {
        // validation for constraint: string
        if (!is_null($updt) && !is_string($updt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($updt)), __LINE__);
        }
        $this->updt = $updt;
        return $this;
    }
    /**
     * Get feeds value
     * @return \QCC\CampusM\CloudService\StructType\Feeds|null
     */
    public function getFeeds()
    {
        return $this->feeds;
    }
    /**
     * Set feeds value
     * @param \QCC\CampusM\CloudService\StructType\Feeds $feeds
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public function setFeeds(\QCC\CampusM\CloudService\StructType\Feeds $feeds = null)
    {
        $this->feeds = $feeds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\UpdateRssSubsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
