<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for userLoginResponse StructType
 * @subpackage Structs
 */
class UserLoginResponse extends AbstractStructBase
{
    /**
     * The confirmation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $confirmation;
    /**
     * The personId
     * @var string
     */
    public $personId;
    /**
     * The firstname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstname;
    /**
     * The surname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $surname;
    /**
     * The optOut
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $optOut;
    /**
     * The userType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userType;
    /**
     * The emailAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $emailAddress;
    /**
     * The devUser
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $devUser;
    /**
     * The dateRegistered
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateRegistered;
    /**
     * The dateLastUsed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateLastUsed;
    /**
     * The phoneModel
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phoneModel;
    /**
     * The deviceCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deviceCode;
    /**
     * The shareLoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $shareLoc;
    /**
     * The updateLoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $updateLoc;
    /**
     * The profileRoleLists
     * @var \QCC\CampusM\CloudService\StructType\ProfileRoleLists
     */
    public $profileRoleLists;
    /**
     * Constructor method for userLoginResponse
     * @uses UserLoginResponse::setConfirmation()
     * @uses UserLoginResponse::setPersonId()
     * @uses UserLoginResponse::setFirstname()
     * @uses UserLoginResponse::setSurname()
     * @uses UserLoginResponse::setOptOut()
     * @uses UserLoginResponse::setUserType()
     * @uses UserLoginResponse::setEmailAddress()
     * @uses UserLoginResponse::setDevUser()
     * @uses UserLoginResponse::setDateRegistered()
     * @uses UserLoginResponse::setDateLastUsed()
     * @uses UserLoginResponse::setPhoneModel()
     * @uses UserLoginResponse::setDeviceCode()
     * @uses UserLoginResponse::setShareLoc()
     * @uses UserLoginResponse::setUpdateLoc()
     * @uses UserLoginResponse::setProfileRoleLists()
     * @param string $confirmation
     * @param string $personId
     * @param string $firstname
     * @param string $surname
     * @param string $optOut
     * @param string $userType
     * @param string $emailAddress
     * @param string $devUser
     * @param string $dateRegistered
     * @param string $dateLastUsed
     * @param string $phoneModel
     * @param string $deviceCode
     * @param string $shareLoc
     * @param int $updateLoc
     * @param \QCC\CampusM\CloudService\StructType\ProfileRoleLists $profileRoleLists
     */
    public function __construct($confirmation = null, $personId = null, $firstname = null, $surname = null, $optOut = null, $userType = null, $emailAddress = null, $devUser = null, $dateRegistered = null, $dateLastUsed = null, $phoneModel = null, $deviceCode = null, $shareLoc = null, $updateLoc = null, \QCC\CampusM\CloudService\StructType\ProfileRoleLists $profileRoleLists = null)
    {
        $this
            ->setConfirmation($confirmation)
            ->setPersonId($personId)
            ->setFirstname($firstname)
            ->setSurname($surname)
            ->setOptOut($optOut)
            ->setUserType($userType)
            ->setEmailAddress($emailAddress)
            ->setDevUser($devUser)
            ->setDateRegistered($dateRegistered)
            ->setDateLastUsed($dateLastUsed)
            ->setPhoneModel($phoneModel)
            ->setDeviceCode($deviceCode)
            ->setShareLoc($shareLoc)
            ->setUpdateLoc($updateLoc)
            ->setProfileRoleLists($profileRoleLists);
    }
    /**
     * Get confirmation value
     * @return string|null
     */
    public function getConfirmation()
    {
        return $this->confirmation;
    }
    /**
     * Set confirmation value
     * @param string $confirmation
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setConfirmation($confirmation = null)
    {
        // validation for constraint: string
        if (!is_null($confirmation) && !is_string($confirmation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($confirmation)), __LINE__);
        }
        $this->confirmation = $confirmation;
        return $this;
    }
    /**
     * Get personId value
     * @return string|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param string $personId
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: string
        if (!is_null($personId) && !is_string($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get firstname value
     * @return string|null
     */
    public function getFirstname()
    {
        return $this->firstname;
    }
    /**
     * Set firstname value
     * @param string $firstname
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setFirstname($firstname = null)
    {
        // validation for constraint: string
        if (!is_null($firstname) && !is_string($firstname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstname)), __LINE__);
        }
        $this->firstname = $firstname;
        return $this;
    }
    /**
     * Get surname value
     * @return string|null
     */
    public function getSurname()
    {
        return $this->surname;
    }
    /**
     * Set surname value
     * @param string $surname
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setSurname($surname = null)
    {
        // validation for constraint: string
        if (!is_null($surname) && !is_string($surname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($surname)), __LINE__);
        }
        $this->surname = $surname;
        return $this;
    }
    /**
     * Get optOut value
     * @return string|null
     */
    public function getOptOut()
    {
        return $this->optOut;
    }
    /**
     * Set optOut value
     * @param string $optOut
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setOptOut($optOut = null)
    {
        // validation for constraint: string
        if (!is_null($optOut) && !is_string($optOut)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($optOut)), __LINE__);
        }
        $this->optOut = $optOut;
        return $this;
    }
    /**
     * Get userType value
     * @return string|null
     */
    public function getUserType()
    {
        return $this->userType;
    }
    /**
     * Set userType value
     * @param string $userType
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setUserType($userType = null)
    {
        // validation for constraint: string
        if (!is_null($userType) && !is_string($userType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userType)), __LINE__);
        }
        $this->userType = $userType;
        return $this;
    }
    /**
     * Get emailAddress value
     * @return string|null
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }
    /**
     * Set emailAddress value
     * @param string $emailAddress
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setEmailAddress($emailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddress) && !is_string($emailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($emailAddress)), __LINE__);
        }
        $this->emailAddress = $emailAddress;
        return $this;
    }
    /**
     * Get devUser value
     * @return string|null
     */
    public function getDevUser()
    {
        return $this->devUser;
    }
    /**
     * Set devUser value
     * @param string $devUser
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setDevUser($devUser = null)
    {
        // validation for constraint: string
        if (!is_null($devUser) && !is_string($devUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($devUser)), __LINE__);
        }
        $this->devUser = $devUser;
        return $this;
    }
    /**
     * Get dateRegistered value
     * @return string|null
     */
    public function getDateRegistered()
    {
        return $this->dateRegistered;
    }
    /**
     * Set dateRegistered value
     * @param string $dateRegistered
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setDateRegistered($dateRegistered = null)
    {
        // validation for constraint: string
        if (!is_null($dateRegistered) && !is_string($dateRegistered)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateRegistered)), __LINE__);
        }
        $this->dateRegistered = $dateRegistered;
        return $this;
    }
    /**
     * Get dateLastUsed value
     * @return string|null
     */
    public function getDateLastUsed()
    {
        return $this->dateLastUsed;
    }
    /**
     * Set dateLastUsed value
     * @param string $dateLastUsed
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setDateLastUsed($dateLastUsed = null)
    {
        // validation for constraint: string
        if (!is_null($dateLastUsed) && !is_string($dateLastUsed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateLastUsed)), __LINE__);
        }
        $this->dateLastUsed = $dateLastUsed;
        return $this;
    }
    /**
     * Get phoneModel value
     * @return string|null
     */
    public function getPhoneModel()
    {
        return $this->phoneModel;
    }
    /**
     * Set phoneModel value
     * @param string $phoneModel
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setPhoneModel($phoneModel = null)
    {
        // validation for constraint: string
        if (!is_null($phoneModel) && !is_string($phoneModel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneModel)), __LINE__);
        }
        $this->phoneModel = $phoneModel;
        return $this;
    }
    /**
     * Get deviceCode value
     * @return string|null
     */
    public function getDeviceCode()
    {
        return $this->deviceCode;
    }
    /**
     * Set deviceCode value
     * @param string $deviceCode
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setDeviceCode($deviceCode = null)
    {
        // validation for constraint: string
        if (!is_null($deviceCode) && !is_string($deviceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deviceCode)), __LINE__);
        }
        $this->deviceCode = $deviceCode;
        return $this;
    }
    /**
     * Get shareLoc value
     * @return string|null
     */
    public function getShareLoc()
    {
        return $this->shareLoc;
    }
    /**
     * Set shareLoc value
     * @param string $shareLoc
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setShareLoc($shareLoc = null)
    {
        // validation for constraint: string
        if (!is_null($shareLoc) && !is_string($shareLoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shareLoc)), __LINE__);
        }
        $this->shareLoc = $shareLoc;
        return $this;
    }
    /**
     * Get updateLoc value
     * @return int|null
     */
    public function getUpdateLoc()
    {
        return $this->updateLoc;
    }
    /**
     * Set updateLoc value
     * @param int $updateLoc
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setUpdateLoc($updateLoc = null)
    {
        // validation for constraint: int
        if (!is_null($updateLoc) && !is_numeric($updateLoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($updateLoc)), __LINE__);
        }
        $this->updateLoc = $updateLoc;
        return $this;
    }
    /**
     * Get profileRoleLists value
     * @return \QCC\CampusM\CloudService\StructType\ProfileRoleLists|null
     */
    public function getProfileRoleLists()
    {
        return $this->profileRoleLists;
    }
    /**
     * Set profileRoleLists value
     * @param \QCC\CampusM\CloudService\StructType\ProfileRoleLists $profileRoleLists
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public function setProfileRoleLists(\QCC\CampusM\CloudService\StructType\ProfileRoleLists $profileRoleLists = null)
    {
        $this->profileRoleLists = $profileRoleLists;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\UserLoginResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
