<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for v3Images StructType
 * @subpackage Structs
 */
class V3Images extends AbstractStructBase
{
    /**
     * The v3Header
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $v3Header;
    /**
     * The v3Bground
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $v3Bground;
    /**
     * The v3Grid
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $v3Grid;
    /**
     * The v3List
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $v3List;
    /**
     * The v3HeaderLogo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $v3HeaderLogo;
    /**
     * Constructor method for v3Images
     * @uses V3Images::setV3Header()
     * @uses V3Images::setV3Bground()
     * @uses V3Images::setV3Grid()
     * @uses V3Images::setV3List()
     * @uses V3Images::setV3HeaderLogo()
     * @param string $v3Header
     * @param string $v3Bground
     * @param string $v3Grid
     * @param string $v3List
     * @param string $v3HeaderLogo
     */
    public function __construct($v3Header = null, $v3Bground = null, $v3Grid = null, $v3List = null, $v3HeaderLogo = null)
    {
        $this
            ->setV3Header($v3Header)
            ->setV3Bground($v3Bground)
            ->setV3Grid($v3Grid)
            ->setV3List($v3List)
            ->setV3HeaderLogo($v3HeaderLogo);
    }
    /**
     * Get v3Header value
     * @return string|null
     */
    public function getV3Header()
    {
        return $this->v3Header;
    }
    /**
     * Set v3Header value
     * @param string $v3Header
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public function setV3Header($v3Header = null)
    {
        // validation for constraint: string
        if (!is_null($v3Header) && !is_string($v3Header)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v3Header)), __LINE__);
        }
        $this->v3Header = $v3Header;
        return $this;
    }
    /**
     * Get v3Bground value
     * @return string|null
     */
    public function getV3Bground()
    {
        return $this->v3Bground;
    }
    /**
     * Set v3Bground value
     * @param string $v3Bground
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public function setV3Bground($v3Bground = null)
    {
        // validation for constraint: string
        if (!is_null($v3Bground) && !is_string($v3Bground)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v3Bground)), __LINE__);
        }
        $this->v3Bground = $v3Bground;
        return $this;
    }
    /**
     * Get v3Grid value
     * @return string|null
     */
    public function getV3Grid()
    {
        return $this->v3Grid;
    }
    /**
     * Set v3Grid value
     * @param string $v3Grid
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public function setV3Grid($v3Grid = null)
    {
        // validation for constraint: string
        if (!is_null($v3Grid) && !is_string($v3Grid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v3Grid)), __LINE__);
        }
        $this->v3Grid = $v3Grid;
        return $this;
    }
    /**
     * Get v3List value
     * @return string|null
     */
    public function getV3List()
    {
        return $this->v3List;
    }
    /**
     * Set v3List value
     * @param string $v3List
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public function setV3List($v3List = null)
    {
        // validation for constraint: string
        if (!is_null($v3List) && !is_string($v3List)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v3List)), __LINE__);
        }
        $this->v3List = $v3List;
        return $this;
    }
    /**
     * Get v3HeaderLogo value
     * @return string|null
     */
    public function getV3HeaderLogo()
    {
        return $this->v3HeaderLogo;
    }
    /**
     * Set v3HeaderLogo value
     * @param string $v3HeaderLogo
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public function setV3HeaderLogo($v3HeaderLogo = null)
    {
        // validation for constraint: string
        if (!is_null($v3HeaderLogo) && !is_string($v3HeaderLogo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($v3HeaderLogo)), __LINE__);
        }
        $this->v3HeaderLogo = $v3HeaderLogo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\V3Images
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
