<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for validValues StructType
 * @subpackage Structs
 */
class ValidValues extends AbstractStructBase
{
    /**
     * The valueItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \QCC\CampusM\CloudService\StructType\ValueItem[]
     */
    public $valueItem;
    /**
     * Constructor method for validValues
     * @uses ValidValues::setValueItem()
     * @param \QCC\CampusM\CloudService\StructType\ValueItem[] $valueItem
     */
    public function __construct(array $valueItem = array())
    {
        $this
            ->setValueItem($valueItem);
    }
    /**
     * Get valueItem value
     * @return \QCC\CampusM\CloudService\StructType\ValueItem[]|null
     */
    public function getValueItem()
    {
        return $this->valueItem;
    }
    /**
     * Set valueItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\ValueItem[] $valueItem
     * @return \QCC\CampusM\CloudService\StructType\ValidValues
     */
    public function setValueItem(array $valueItem = array())
    {
        foreach ($valueItem as $validValuesValueItemItem) {
            // validation for constraint: itemType
            if (!$validValuesValueItemItem instanceof \QCC\CampusM\CloudService\StructType\ValueItem) {
                throw new \InvalidArgumentException(sprintf('The valueItem property can only contain items of \QCC\CampusM\CloudService\StructType\ValueItem, "%s" given', is_object($validValuesValueItemItem) ? get_class($validValuesValueItemItem) : gettype($validValuesValueItemItem)), __LINE__);
            }
        }
        $this->valueItem = $valueItem;
        return $this;
    }
    /**
     * Add item to valueItem value
     * @throws \InvalidArgumentException
     * @param \QCC\CampusM\CloudService\StructType\ValueItem $item
     * @return \QCC\CampusM\CloudService\StructType\ValidValues
     */
    public function addToValueItem(\QCC\CampusM\CloudService\StructType\ValueItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \QCC\CampusM\CloudService\StructType\ValueItem) {
            throw new \InvalidArgumentException(sprintf('The valueItem property can only contain items of \QCC\CampusM\CloudService\StructType\ValueItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->valueItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\ValidValues
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
