<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for voteResultUrlRequest StructType
 * @subpackage Structs
 */
class VoteResultUrlRequest extends AbstractStructBase
{
    /**
     * The personId
     * @var int
     */
    public $personId;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The orgCode
     * @var int
     */
    public $orgCode;
    /**
     * The vqCode
     * @var int
     */
    public $vqCode;
    /**
     * The chartType
     * @var string
     */
    public $chartType;
    /**
     * The width
     * @var int
     */
    public $width;
    /**
     * The height
     * @var int
     */
    public $height;
    /**
     * The colour
     * @var string
     */
    public $colour;
    /**
     * Constructor method for voteResultUrlRequest
     * @uses VoteResultUrlRequest::setPersonId()
     * @uses VoteResultUrlRequest::setPassword()
     * @uses VoteResultUrlRequest::setOrgCode()
     * @uses VoteResultUrlRequest::setVqCode()
     * @uses VoteResultUrlRequest::setChartType()
     * @uses VoteResultUrlRequest::setWidth()
     * @uses VoteResultUrlRequest::setHeight()
     * @uses VoteResultUrlRequest::setColour()
     * @param int $personId
     * @param string $password
     * @param int $orgCode
     * @param int $vqCode
     * @param string $chartType
     * @param int $width
     * @param int $height
     * @param string $colour
     */
    public function __construct($personId = null, $password = null, $orgCode = null, $vqCode = null, $chartType = null, $width = null, $height = null, $colour = null)
    {
        $this
            ->setPersonId($personId)
            ->setPassword($password)
            ->setOrgCode($orgCode)
            ->setVqCode($vqCode)
            ->setChartType($chartType)
            ->setWidth($width)
            ->setHeight($height)
            ->setColour($colour);
    }
    /**
     * Get personId value
     * @return int|null
     */
    public function getPersonId()
    {
        return $this->personId;
    }
    /**
     * Set personId value
     * @param int $personId
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setPersonId($personId = null)
    {
        // validation for constraint: int
        if (!is_null($personId) && !is_numeric($personId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($personId)), __LINE__);
        }
        $this->personId = $personId;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get orgCode value
     * @return int|null
     */
    public function getOrgCode()
    {
        return $this->orgCode;
    }
    /**
     * Set orgCode value
     * @param int $orgCode
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setOrgCode($orgCode = null)
    {
        // validation for constraint: int
        if (!is_null($orgCode) && !is_numeric($orgCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orgCode)), __LINE__);
        }
        $this->orgCode = $orgCode;
        return $this;
    }
    /**
     * Get vqCode value
     * @return int|null
     */
    public function getVqCode()
    {
        return $this->vqCode;
    }
    /**
     * Set vqCode value
     * @param int $vqCode
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setVqCode($vqCode = null)
    {
        // validation for constraint: int
        if (!is_null($vqCode) && !is_numeric($vqCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vqCode)), __LINE__);
        }
        $this->vqCode = $vqCode;
        return $this;
    }
    /**
     * Get chartType value
     * @return string|null
     */
    public function getChartType()
    {
        return $this->chartType;
    }
    /**
     * Set chartType value
     * @param string $chartType
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setChartType($chartType = null)
    {
        // validation for constraint: string
        if (!is_null($chartType) && !is_string($chartType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($chartType)), __LINE__);
        }
        $this->chartType = $chartType;
        return $this;
    }
    /**
     * Get width value
     * @return int|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param int $width
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setWidth($width = null)
    {
        // validation for constraint: int
        if (!is_null($width) && !is_numeric($width)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($width)), __LINE__);
        }
        $this->width = $width;
        return $this;
    }
    /**
     * Get height value
     * @return int|null
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * Set height value
     * @param int $height
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setHeight($height = null)
    {
        // validation for constraint: int
        if (!is_null($height) && !is_numeric($height)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($height)), __LINE__);
        }
        $this->height = $height;
        return $this;
    }
    /**
     * Get colour value
     * @return string|null
     */
    public function getColour()
    {
        return $this->colour;
    }
    /**
     * Set colour value
     * @param string $colour
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public function setColour($colour = null)
    {
        // validation for constraint: string
        if (!is_null($colour) && !is_string($colour)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($colour)), __LINE__);
        }
        $this->colour = $colour;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\VoteResultUrlRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
