<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for web2Data StructType
 * @subpackage Structs
 */
class Web2Data extends AbstractStructBase
{
    /**
     * The web2Data
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $web2Data;
    /**
     * The tileStyle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tileStyle;
    /**
     * Constructor method for web2Data
     * @uses Web2Data::setWeb2Data()
     * @uses Web2Data::setTileStyle()
     * @param string $web2Data
     * @param string $tileStyle
     */
    public function __construct($web2Data = null, $tileStyle = null)
    {
        $this
            ->setWeb2Data($web2Data)
            ->setTileStyle($tileStyle);
    }
    /**
     * Get web2Data value
     * @return string|null
     */
    public function getWeb2Data()
    {
        return $this->web2Data;
    }
    /**
     * Set web2Data value
     * @param string $web2Data
     * @return \QCC\CampusM\CloudService\StructType\Web2Data
     */
    public function setWeb2Data($web2Data = null)
    {
        // validation for constraint: string
        if (!is_null($web2Data) && !is_string($web2Data)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($web2Data)), __LINE__);
        }
        $this->web2Data = $web2Data;
        return $this;
    }
    /**
     * Get tileStyle value
     * @return string|null
     */
    public function getTileStyle()
    {
        return $this->tileStyle;
    }
    /**
     * Set tileStyle value
     * @param string $tileStyle
     * @return \QCC\CampusM\CloudService\StructType\Web2Data
     */
    public function setTileStyle($tileStyle = null)
    {
        // validation for constraint: string
        if (!is_null($tileStyle) && !is_string($tileStyle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tileStyle)), __LINE__);
        }
        $this->tileStyle = $tileStyle;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Web2Data
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
