<?php

namespace QCC\CampusM\CloudService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for workhours StructType
 * @subpackage Structs
 */
class Workhours extends AbstractStructBase
{
    /**
     * The workhour
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $workhour;
    /**
     * Constructor method for workhours
     * @uses Workhours::setWorkhour()
     * @param string[] $workhour
     */
    public function __construct(array $workhour = array())
    {
        $this
            ->setWorkhour($workhour);
    }
    /**
     * Get workhour value
     * @return string[]|null
     */
    public function getWorkhour()
    {
        return $this->workhour;
    }
    /**
     * Set workhour value
     * @throws \InvalidArgumentException
     * @param string[] $workhour
     * @return \QCC\CampusM\CloudService\StructType\Workhours
     */
    public function setWorkhour(array $workhour = array())
    {
        foreach ($workhour as $workhoursWorkhourItem) {
            // validation for constraint: itemType
            if (!is_string($workhoursWorkhourItem)) {
                throw new \InvalidArgumentException(sprintf('The workhour property can only contain items of string, "%s" given', is_object($workhoursWorkhourItem) ? get_class($workhoursWorkhourItem) : gettype($workhoursWorkhourItem)), __LINE__);
            }
        }
        $this->workhour = $workhour;
        return $this;
    }
    /**
     * Add item to workhour value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \QCC\CampusM\CloudService\StructType\Workhours
     */
    public function addToWorkhour($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The workhour property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->workhour[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \QCC\CampusM\CloudService\StructType\Workhours
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
